/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Thanks to abaddon for proof-reading our comm.c and pointing out bugs.  *
 *  Any remaining bugs are, of course, our work, not his.  :)              *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "magic.h"
#include "recycle.h"
#include "tables.h"


extern bool write_to_descriptor    args( ( int desc, char *txt, int length ) );
DECLARE_DO_FUN( do_help          );
DECLARE_DO_FUN( do_look          );
DECLARE_DO_FUN( do_outfit        );
DECLARE_DO_FUN( do_skills        );
DECLARE_DO_FUN( do_unread        );


extern const char echo_off_str[];
extern const char echo_on_str[];
extern char *invalid_name_parts;
extern int wizlock;


#define MAX_NEWBIE_ITEMS      10

struct equipment_modifier
{
    int                       vnum;
    char *                    name;
    char *                    short_desc;
    char *                    long_desc;
};

struct racial_equipment
{
    char *                    race;
    struct equipment_modifier items[ MAX_NEWBIE_ITEMS ];
};

const struct racial_equipment newbie_items[] =
{
    {
        "human"
    },

    {
        "high-elf",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy leather vest", "a finely cut leather vest", "A finely cut vest of leather sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy silver dagger", "a silver dagger", "A well crafted dagger of silver sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy silver sword", "a silver short sword", "A well crafted short sword, made of silver, rests here." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy hardened oak spear", "an oak spear", "A fire blackened spear of oak sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy oak staff", "an oak staff", "A staff of oak rests here." }
        }
    },

    {
        "grey-elf",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy leather vest", "a finely cut leather vest", "A finely cut vest of leather sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy silver dagger", "a silver dagger", "A well crafted dagger of silver sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy silver sword", "a silver short sword", "A well crafted short sword, made of silver, rests here." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy hardened oak spear", "an oak spear", "A fire blackened spear of oak sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy oak staff", "an oak staff", "A staff of oak rests here." }
        }
    },

    {
        "wild-elf",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy leather vest", "a green and brown leather vest", "A leather vest, coloured green and brown, sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy silver dagger", "a silver dagger", "A well crafted dagger of silver sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy silver sword", "a silver short sword", "A well crafted short sword, made of silver, rests here." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy hardened oak spear", "an oak spear", "A fire blackened spear of oak sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy oak staff", "an oak staff", "A staff of oak rests here." }
        }
    },

    {
        "dwarf",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy leather vest", "a sturdy leather vest", "A sturdy leather vest sits here unused." },
          { OBJ_VNUM_SCHOOL_MACE,   "academy steel mace", "a dwarfen steel mace", "A mace, fashioned from dwarfen steel, sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy steel dagger", "a dwarfen steel dagger", "A dagger, fashioned from dwarfen steel, sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy steel short sword", "a dwarfen steel short sword", "A short sword, fashioned from dwarfen steel, sits here unused." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy dwarfen short spear", "a dwarfen short spear", "A dwarfen short spear sits here unused." },
          { OBJ_VNUM_SCHOOL_AXE,    "academy dwarfen steel axe", "a finely crafted dwarfen steel axe", "A dagger, fashioned from dwarfen steel, sits here unused." }
        }
    },

    {
        "hill-giant",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy crude fur vest", "a crude vest of fur", "A crudely fashioned fur veswt sits here unused." },
          { OBJ_VNUM_SCHOOL_MACE,   "academy tree branch", "a tree branch", "The branch of a tree rests here." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy sharpened twig", "a sharpened twig", "A twig, with one sharpened end, sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy crude stone sword", "a primitive stone sword", "A crudely made sword of stone sits here unused." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy stone tipped spear", "a primitive stone tipped spear", "A primitive spear, with a crudely sharpened stone tip, sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy sapling", "a snapped off sapling", "A snapped off sapling trunk rests here." },
          { OBJ_VNUM_SCHOOL_AXE,    "academy stone axe", "a primitive stone axe", "A primitive stone axe rests here." },
          { OBJ_VNUM_SCHOOL_FLAIL,  "academy stone flail", "a primitive stone flail", "A flail made from a large rock, tied to a tree branch, rests here unused." },
          { OBJ_VNUM_SCHOOL_WHIP,   "academy rusty iron chain", "a rusty iron chain", "A rusty iron chain rests here." },
          { OBJ_VNUM_SCHOOL_POLEARM,"academy stone halberd", "a primitive stone halberd", "A primitive stone halberd rests here unushed." }
        }
    },

    {
        "fire-giant",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy salamander skin vest", "a salamander skin vest", "A bright red vest, made from salamader skin, sits here unused." },
          { OBJ_VNUM_SCHOOL_MACE,   "academy red-iron mace", "a red-iron branch", "A red-iron mace sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy red-iron dagger", "a red-iron dagger", "A red-iron dagger sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy red-iron sword", "a red-iron sword", "A red-iron sword sits here unused." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy red-iron spear", "a red-iron spear", "A red-iron spear sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy red-iron staff", "a red-iron staff", "A red-iron staff rests here." },
          { OBJ_VNUM_SCHOOL_AXE,    "academy red-iron axe", "a red-iron axe", "A red-iron axe rests here." },
          { OBJ_VNUM_SCHOOL_FLAIL,  "academy red-iron flail", "a red-iron flail", "A flail made from red-iron, rests here unused." },
          { OBJ_VNUM_SCHOOL_WHIP,   "academy red-iron chain", "a red-iron chain", "A red-iron chain rests here." },
          { OBJ_VNUM_SCHOOL_POLEARM,"academy red-iron halberd", "a red-iron halberd", "A red-iron halberd rests here unushed." }
        }
    },

    {
        "storm-giant",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy gaur skin vest", "a gaur skin vest", "A vest, made from gaur skin, sits here unused." },
          { OBJ_VNUM_SCHOOL_MACE,   "academy blue steel mace", "a blue steel branch", "A blue steel mace sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy blue steel dagger", "a blue steel dagger", "A blue steel dagger sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy blue steel sword", "a blue steel sword", "A blue steel sword sits here unused." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy blue steel spear", "a blue steel spear", "A blue steel spear sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy blue steel staff", "a blue steel staff", "A blue steel staff rests here." },
          { OBJ_VNUM_SCHOOL_AXE,    "academy blue steel axe", "a blue steel axe", "A blue steel axe rests here." },
          { OBJ_VNUM_SCHOOL_FLAIL,  "academy blue steel flail", "a blue steel flail", "A flail made from blue steel, rests here unused." },
          { OBJ_VNUM_SCHOOL_WHIP,   "academy blue steel chain", "a blue steel chain", "A blue steel chain rests here." },
          { OBJ_VNUM_SCHOOL_POLEARM,"academy blue steel halberd", "a blue steel halberd", "A blue steel halberd rests here unushed." }
        }
    },

    {
        "frost-giant",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy white fur vest", "a thick white fur vest", "A white vest of thick fur lies here unused." },
          { OBJ_VNUM_SCHOOL_MACE,   "academy blue steel mace", "a blue steel branch", "A blue steel mace sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy blue steel dagger", "a blue steel dagger", "A blue steel dagger sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy blue steel sword", "a blue steel sword", "A blue steel sword sits here unused." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy blue steel spear", "a blue steel spear", "A blue steel spear sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy blue steel staff", "a blue steel staff", "A blue steel staff rests here." },
          { OBJ_VNUM_SCHOOL_AXE,    "academy blue steel axe", "a blue steel axe", "A blue steel axe rests here." },
          { OBJ_VNUM_SCHOOL_FLAIL,  "academy blue steel flail", "a blue steel flail", "A flail made from blue steel, rests here unused." },
          { OBJ_VNUM_SCHOOL_WHIP,   "academy blue steel chain", "a blue steel chain", "A blue steel chain rests here." },
          { OBJ_VNUM_SCHOOL_POLEARM,"academy blue steel halberd", "a blue steel halberd", "A blue steel halberd rests here unushed." }
        }
    },

    {
        "centaur",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy woolen vest", "a well crafted woolen vest", "A well crafted vest of wool sits here unused." }
        }
    },

    {
        "half-elf",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy leather vest", "a green and brown leather vest", "A leather vest, coloured green and brown, sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy silver dagger", "a silver dagger", "A well crafted dagger of silver sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy silver sword", "a silver short sword", "A well crafted short sword, made of silver, rests here." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy hardened oak spear", "an oak spear", "A fire blackened spear of oak sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy oak staff", "an oak staff", "A staff of oak rests here." }
        }
    },

    {
        "gnome",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy purple jacket", "a purple woven jacket", "A woven jacket, died purple, sits here unused." }
        }
    },

    {
        "half-orc",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy studded leather vest", "a studded leather vest", "A studded leather vest sits here unused." },
          { OBJ_VNUM_SCHOOL_MACE,   "academy iron studded mace", "an iron studded mace", "An iron studded mace sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy blackened steel stiletto", "a blackened steel stiletto", "A blackened steel stiletto sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy blackened steel scimiar", "a blackened steel scimitar", "A blackened steel scimitar sits here unused." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy barbed spear", "a viciously barbed spear", "A viciously barbed spear sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy iron short-staff", "a iron short-staff", "A iron short-staff rests here." },
          { OBJ_VNUM_SCHOOL_AXE,    "academy steel battle axe", "a steel battle axe", "A steel battle axe rests here." },
          { OBJ_VNUM_SCHOOL_FLAIL,  "academy studded iron flail", "a studded iron flail", "A flail made from iron rests here unused." },
          { OBJ_VNUM_SCHOOL_WHIP,   "academy leather bull-whip", "a leather bull-whip", "A leather bull-whip rests here." },
          { OBJ_VNUM_SCHOOL_POLEARM,"academy iron halberd", "an iron halberd", "An iron halberd rests here unushed." }
        }
    },

    {
        "cambion",
        { { OBJ_VNUM_SCHOOL_VEST,   "academy studded leather vest", "a studded leather vest", "A studded leather vest sits here unused." },
          { OBJ_VNUM_SCHOOL_MACE,   "academy iron studded mace", "an iron studded mace", "An iron studded mace sits here unused." },
          { OBJ_VNUM_SCHOOL_DAGGER, "academy blackened steel stiletto", "a blackened steel stiletto", "A blackened steel stiletto sits here unused." },
          { OBJ_VNUM_SCHOOL_SWORD,  "academy blackened steel scimiar", "a blackened steel scimitar", "A blackened steel scimitar sits here unused." },
          { OBJ_VNUM_SCHOOL_SPEAR,  "academy barbed spear", "a viciously barbed spear", "A viciously barbed spear sits here unused." },
          { OBJ_VNUM_SCHOOL_STAFF,  "academy iron short-staff", "a iron short-staff", "A iron short-staff rests here." },
          { OBJ_VNUM_SCHOOL_AXE,    "academy steel battle axe", "a steel battle axe", "A steel battle axe rests here." },
          { OBJ_VNUM_SCHOOL_FLAIL,  "academy studded iron flail", "a studded iron flail", "A flail made from iron rests here unused." },
          { OBJ_VNUM_SCHOOL_WHIP,   "academy leather bull-whip", "a leather bull-whip", "A leather bull-whip rests here." },
          { OBJ_VNUM_SCHOOL_POLEARM,"academy iron halberd", "an iron halberd", "An iron halberd rests here unushed." }
        }
    },

    {
        ""
    }
};


typedef void (*list_fn)( DESCRIPTOR_DATA *d );

static void list_advantages( DESCRIPTOR_DATA *d, const struct advantage_type *table );
static void skill_list( DESCRIPTOR_DATA *d );
static void advantage_list( DESCRIPTOR_DATA *d );
static void disadvantage_list( DESCRIPTOR_DATA *d );
static void ancestor_list( DESCRIPTOR_DATA *d );
static void advantage_prompt( DESCRIPTOR_DATA *d );
static void list_advantages_gained( DESCRIPTOR_DATA *d, int min, int max, const struct advantage_type *table );



void convert_racial_equipment( const char *race, OBJ_DATA *obj )
{
    int i;

    for ( i=0; !IS_NULLSTR(newbie_items[i].race); ++i )
    {
        int j;

        if ( strcmp(newbie_items[i].race, race) )
            continue;

        for ( j=0; j<MAX_NEWBIE_ITEMS && newbie_items[i].items[j].vnum; ++j )
        {
            if ( newbie_items[i].items[j].vnum == obj->pIndexData->vnum )
            {
	        free_string( obj->name );
                free_string( obj->short_descr );
                free_string( obj->description );

	        obj->name        = str_dup( newbie_items[i].items[j].name );
                obj->short_descr = str_dup( newbie_items[i].items[j].short_desc );
                obj->description = str_dup( newbie_items[i].items[j].long_desc );
                return;
            }
        }

        return;
    }
}


/*
 * Parse a name for acceptability.
 */
bool check_parse_name( char *name )
{
    /*
     * Length restrictions.
     */
    if ( strlen(name) <  2 )
	return FALSE;

#if defined(MSDOS)
    if ( strlen(name) >  8 )
	return FALSE;
#endif

#if defined(macintosh) || defined(unix)
    if ( strlen(name) > 12 )
	return FALSE;
#endif

    /*
     * Alphanumerics only.
     * Lock out IllIll twits.
     */
    {
	bool fIll,adjcaps = FALSE,cleancaps = FALSE;
	int total_caps = 0;
	char *pc;

	fIll = TRUE;
	for ( pc = name; *pc != '\0'; pc++ )
	{
	    if ( !isalpha(*pc) )
		return FALSE;

	    if ( isupper(*pc)) /* ugly anti-caps hack */
	    {
		if (adjcaps)
		    cleancaps = TRUE;
		total_caps++;
		adjcaps = TRUE;
	    }
	    else
		adjcaps = FALSE;

	    if ( LOWER(*pc) != 'i' && LOWER(*pc) != 'l' )
		fIll = FALSE;
	}

	if ( fIll )
	    return FALSE;

	if (cleancaps || (total_caps > (strlen(name)) / 2 && strlen(name) < 3))
	    return FALSE;
    }

    /*
     * Prevent players from naming themselves after mobs.
     */
    {
	extern MOB_INDEX_DATA *mob_index_hash[MAX_KEY_HASH];
	MOB_INDEX_DATA *pMobIndex;
	int iHash;

	for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
	{
	    for ( pMobIndex  = mob_index_hash[iHash];
		  pMobIndex != NULL;
		  pMobIndex  = pMobIndex->next )
	    {
		if ( is_name( name, pMobIndex->player_name ) )
		    return FALSE;
	    }
	}
    }

    return TRUE;
}


/*
 * Check to see whether the name contains any of the invalid parts.
 */
bool validate_name_parts( char *orig_name, char *partlist )
{
    char name[MAX_INPUT_LENGTH]; 
    char part[MAX_INPUT_LENGTH];
    char *list;
    char *ch;
    
    /* we don't want to modify the original name to take a copy */
    strcpy( name, orig_name );

    /* fix crash on NULL partlist */
    if ( partlist == NULL || partlist[0] == '\0' )
        return TRUE;

    /* validate_name on "" returns TRUE */
    if ( name[0] == '\0' )
        return TRUE;

    /* we don't want to consider case */
    for ( ch = name; *ch != '\0'; ch++ )
	*ch = LOWER(*ch);
    
    /* check name against each part in partlist */
    list = partlist;
	    
    for ( ; ; )  /* start parsing partlist */
    {
	list = one_argument(list,part);
	if ( part[0] == '\0' )  /* this part was not found, we're finished looking */
	    break;

	if ( strstr(name, part) != NULL )
	    return FALSE; /* part was found in name -- invalid */
    }
	return TRUE;
}


/*
 * Look for link-dead player to reconnect.
 */
bool check_reconnect( DESCRIPTOR_DATA *d, char *name, bool fConn )
{
    CHAR_DATA *ch;

    for ( ch = char_list; ch != NULL; ch = ch->next )
    {
	if ( !IS_NPC(ch)
	&&   (!fConn || ch->desc == NULL)
	&&   !str_cmp(d->character->name, ch->name) )
	{
	    if ( fConn == FALSE )
	    {
		free_string( d->character->pcdata->pwd );
		d->character->pcdata->pwd = str_dup( ch->pcdata->pwd );
	    }
	    else
	    {
		/* Fix problems with pet duplication. */
		nuke_pets( d->character );

		free_char( d->character );
		d->character    = ch;
		ch->desc        = d;
		ch->timer       = 0;

		send_to_char(
		    "Reconnecting. Type replay to see missed tells.\n\r", ch );
		act( "$n has reconnected.", ch, NULL, NULL, TO_ROOM );

		sprintf( log_buf, "%s@%s reconnected.", ch->name, d->host );
		log_string( log_buf );
		wiznet( "$N groks the fullness of $S link.",
		    ch, NULL, WIZ_LINKS, 0, get_trust(ch) );
		d->connected = CON_PLAYING;
	    }
	    return TRUE;
	}
    }

    return FALSE;
}


/*
 * Check if already playing.
 */
bool check_playing( DESCRIPTOR_DATA *d, char *name )
{
    DESCRIPTOR_DATA *dold;

    for ( dold = descriptor_list; dold; dold = dold->next )
    {
	if ( dold != d
	&&   dold->character != NULL
	&&   dold->connected != CON_GET_NAME
	&&   dold->connected != CON_GET_OLD_PASSWORD
	&&   !str_cmp( name, dold->original
		 ? dold->original->name : dold->character->name ) )
	{
	    write_to_buffer( d, "That character is already playing.\n\r",0);
	    write_to_buffer( d, "Do you wish to connect anyway (Y/N)?",0);
	    d->connected = CON_BREAK_CONNECT;
	    return TRUE;
	}
    }

    return FALSE;
}


/*
 * Check if already creating.
 */
bool check_creating( DESCRIPTOR_DATA *d, char *name )
{
    DESCRIPTOR_DATA *dold;

    for ( dold = descriptor_list; dold; dold = dold->next )
    {
	if ( dold != d
	&&   dold->character != NULL
	&&   dold->connected != CON_GET_NAME
	&&   dold->connected != CON_GET_NEW_PASSWORD
	&&   dold->connected != CON_CONFIRM_NEW_PASSWORD
	&&   dold->connected != CON_PLAYING
	&&   !str_cmp( name, dold->original
		 ? dold->original->name : dold->character->name ) )
	{
	    write_to_buffer( d, 
		"A character with that name is already undergoing creation.\n\r",
		0 );
		
	    close_socket( d, TRUE );
	    return TRUE;
	}
    }

    return FALSE;
}


void pick_hometown( DESCRIPTOR_DATA *d )
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *ch;
    int col, ht;

    ch = d->character;

    write_to_buffer( d, "  ", 2 );

    for ( ht = 1, col = 0; hometown_table[ht].ht_name != NULL; ht++ )
    {
	if (!hometown_table[ht].ht_avail)
	    continue;

	if (hometown_table[ht].ht_restrict[ch->race] == 0)
	    continue;

	if (((hometown_table[ht].ht_restrict[18] == 0) && (ch->alignment > 350))
	 || ((hometown_table[ht].ht_restrict[19] == 0) && (ch->alignment <= 350 && ch->alignment >= -350))
	 || ((hometown_table[ht].ht_restrict[20] == 0) && (ch->alignment < -350)))
	    continue;

        sprintf( buf, "%-15s ", hometown_table[ht].ht_name );
        write_to_buffer( d, buf, 0 );
    
        if ( ++col % 4 == 0 )
            write_to_buffer( d, "\n\r  ", 4 );
    }
    if ( col % 4 == 0 )
        write_to_buffer( d, "\n\r", 2 );
    write_to_buffer( d, "\n\r", 2 );
            
    write_to_buffer( d, "\n\rWhere do you wish to settle (help for more information)? ", 0 );
}


void generate_stats( DESCRIPTOR_DATA *d )
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *ch;
    int deviation;
    int i;
    
    ch = d->character;
    deviation = 0;

    for (i=0; i<MAX_STATS; i++)
    {
      int change;
      
      do {
	ch->perm_stat[i] = pc_race_table[ch->race].stats[i];
	ch->perm_stat[i] += number_range( 1, 20 ) - 10;
	
	if ( ch->perm_stat[i] < 12 )
	    ch->perm_stat[i] = 12;
	else if ( ch->perm_stat[i] > pc_race_table[ch->race].max_stats[i] )
	    ch->perm_stat[i] = pc_race_table[ch->race].max_stats[i];
	
	change = ch->perm_stat[i] - pc_race_table[ch->race].stats[i];
      } while ( deviation + change >  25
      ||        deviation + change < -30 );
      
      deviation += change;
    }

    ch->perm_stat[class_table[ch->class].attr_prime] += 12;
    
    sprintf( buf, "Strength       : %-15s\n\r", get_stat_word(ch, STAT_STR) );
    write_to_buffer( d, buf, 0 );
    sprintf( buf, "Intelligence   : %-15s\n\r", get_stat_word(ch, STAT_INT) );
    write_to_buffer( d, buf, 0 );
    sprintf( buf, "Wisdom         : %-15s\n\r", get_stat_word(ch, STAT_WIS) );
    write_to_buffer( d, buf, 0 );
    sprintf( buf, "Dexterity      : %-15s\n\r", get_stat_word(ch, STAT_DEX) );
    write_to_buffer( d, buf, 0 );
    sprintf( buf, "Constitution   : %-15s\n\r", get_stat_word(ch, STAT_CON) );
    write_to_buffer( d, buf, 0 );
    sprintf( buf, "Perception     : %-15s\n\r", get_stat_word(ch, STAT_PER) );
    write_to_buffer( d, buf, 0 );
    sprintf( buf, "Charisma       : %-15s\n\r", get_stat_word(ch, STAT_CHA) );
    write_to_buffer( d, buf, 0 );
    
    write_to_buffer( d, "Are these attributes acceptable (Y/N)? ", 0 );
}


void nanny_get_name( DESCRIPTOR_DATA *d, char *argument )
{
    const char *bad_names =
    "all auto immortal self someone something the you loner test tester "
    "testing guest dopie dopy sleepie sleepy dufus stereoman kinky "
    "stereo sexy bimbo sexkitten raistlin harlot caramon slut fuck "
    "fuckhead cum whore spell cola uncola abc abcdef abbreviation "
    "abnormal abomb abominable abortion adult adulterer advance "
    "adverb advertise advertisement anal ass asshole asswipe anarch "
    "adventurer and animal antichrist hitler asslick asspick babe baby "
    "bachelor back bacon bacteria bad bait ball balls big ban bank bart "
    "bastard bbb bbbb bear beauty beef beggar bitch blond bloody blow "
    "blowjob blubber brigand bugger bung bunghole caca celebacy "
    "celebate character charm charmer charming chink chit climax "
    "clitoris clown cock cocksucker cum comshot cunninglus cunt cyber "
    "cyberpunk dick dickless dickwad dung fellatio kcuf shit gay faggot "
    "tits lag lagboy lagman breast insert insertion hole beavis "
    "butthead cheater davidian honor stormrider storm honour master "
    "student masturbate masturbation harlot steroid gandalf frodo "
    "lord friend help freak newbie incorporated corporated blood";

    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *ch;
    bool fOld;

    if ( argument[0] == '\0' )
    {
	close_socket( d, TRUE );
	return;
    }

    argument[0] = UPPER( argument[0] );
    if ( !check_parse_name(argument) )
    {
	write_to_buffer( d, "Illegal name, try another.\n\r"
                            "Name: ", 0 );
	return;
    }
    
     /*
      * Reserved words.
      */
    if ( is_name(argument, (char *) bad_names) )
    {
        write_to_buffer( d, "Illegal name, try another.\n\rName: ", 0 );
        sprintf( buf, "Invalid logon attempted: %s@%s", argument, d->host );
        wiznet( buf, NULL, NULL, WIZ_LOGINS,0 ,0 );
        log_string( buf );
        return;
    }
    
    /*
     * Check for restricted string pre/in/suffixes
     */
    if ( !validate_name_parts( argument, invalid_name_parts) )
    {
	write_to_buffer( d, "Illegal name, try another.\n\r"
                            "Name: ", 0 );
	sprintf( buf, "Invalid logon attempted: %s@%s", argument, d->host );
	wiznet( buf, NULL, NULL, WIZ_LOGINS, 0 ,0 );
	log_string( buf );
	return;
    }

    fOld = load_char_obj( d, argument );
    ch   = d->character;

    if ( IS_SET(ch->act, PLR_DENY) )
    {
	sprintf( log_buf, "Denying access to %s@%s.", argument, d->host );
	log_string( log_buf );
	write_to_buffer( d, "You are denied access.\n\r", 0 );
	close_socket( d, TRUE );
	return;
    }

    if ( check_ban(d->host, BAN_PERMIT) && !IS_SET(ch->act, PLR_PERMIT) )
    {
	write_to_buffer( d, "Your site has been banned from this mud.\n\r", 0 );
	close_socket( d, TRUE );
	return;
    }

    if ( check_reconnect( d, argument, FALSE ) )
    {
	fOld = TRUE;
    }
    else
    {
	if ( wizlock > ch->level ) 
	{
	    write_to_buffer( d, "The game is locked for maintenance. Please try again later.\n\r", 0 );
	    close_socket( d, TRUE );
	    return;
	}
    }

    if ( fOld )
    {
	/* Old player */
	write_to_buffer( d, "Password: ", 0 );
	write_to_buffer( d, echo_off_str, 0 );
	d->connected = CON_GET_OLD_PASSWORD;
	return;
    }
    else
    {
	/* New player */
	if ( wizlock > 0 )
	{
	    write_to_buffer( d, "No new players can be created at the moment.\n\r"
                                "Please try again later.\n\r", 0 );
	    close_socket( d, TRUE );
	    return;
	}

	if ( check_ban(d->host, BAN_NEWBIES) )
	{
	    write_to_buffer( d,
		"New players are not allowed from your site.\n\r", 0 );
	    close_socket( d, TRUE );
	    return;
	}
    
	sprintf( buf, "Did I get that right, %s (Y/N)? ", argument );
	write_to_buffer( d, buf, 0 );
	d->connected = CON_CONFIRM_NEW_NAME;
	return;
    }
}


void nanny_get_old_password( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;

#if defined(unix)
    write_to_buffer( d, "\n\r", 2 );
#endif

    if ( strcmp(crypt(argument, ch->pcdata->pwd), ch->pcdata->pwd) )
    {
	write_to_buffer( d, "Wrong password.\n\r", 0 );

	sprintf( log_buf, "%s@%s: incorrect password.", ch->name, d->host );
	log_string( log_buf );
	wiznet( log_buf, NULL, NULL, WIZ_LOGINS, 0, get_trust(ch) );

	close_socket( d, TRUE );
	return;
    }

    write_to_buffer( d, echo_on_str, 0 );

    if ( check_playing(d, ch->name) )
	return;

    if ( check_reconnect(d, ch->name, TRUE) )
	return;

    sprintf( log_buf, "%s@%s has connected.", ch->name, d->host );
    log_string( log_buf );
    wiznet( log_buf, NULL, NULL, WIZ_SITES, 0, get_trust(ch) );

    if ( IS_IMMORTAL(ch) )
    {
	do_help( ch, "imotd" );
	d->connected = CON_READ_IMOTD;
    }
    else
    {
	do_help( ch, "motd" );
	d->connected = CON_READ_MOTD;
    }
}


void nanny_break_connect( DESCRIPTOR_DATA *d, char *argument )
{
    DESCRIPTOR_DATA *d_old, *d_next;
    CHAR_DATA *ch = d->character;

    switch( *argument )
    {
    case 'y':
    case 'Y':
	for ( d_old = descriptor_list; d_old != NULL; d_old = d_next )
	{
	    d_next = d_old->next;
	    if ( d_old == d || d_old->character == NULL )
		continue;

	    if ( str_cmp(ch->name, 
                         d_old->original ?
		            d_old->original->name : 
                            d_old->character->name) )
		continue;

	    close_socket( d_old, FALSE );
	}

	if ( check_reconnect( d, ch->name, TRUE) )
	    return;

	write_to_buffer( d, "Reconnect attempt failed.\n\r", 0 );
        /* Fall through to no case... */

    case 'n':
    case 'N':
	write_to_buffer( d, "Name: ", 0 );
	if ( d->character != NULL )
	{
	    free_char( d->character );
	    d->character = NULL;
	}
	d->connected = CON_GET_NAME;
	break;

    default:
	write_to_buffer( d, "Please type Y or N? ", 0 );
	break;
    }
}


void nanny_confirm_new_name( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char buf[MAX_STRING_LENGTH];

    switch ( *argument )
    {
    case 'y':
    case 'Y':
	sprintf( buf, "New character.\n\r\n\r"
                      "Give me a password for %s: %s",
	    ch->name, echo_off_str );
	write_to_buffer( d, buf, 0 );
	d->connected = CON_GET_NEW_PASSWORD;
	break;

    case 'n':
    case 'N':
	write_to_buffer( d, "Ok, what IS it, then? ", 0 );
	free_char( d->character );
	d->character = NULL;
	d->connected = CON_GET_NAME;
	break;

    default:
	write_to_buffer( d, "Please type Yes or No? ", 0 );
	break;
    }
}


void nanny_get_new_password( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char *pwdnew;
    char *p;

#if defined(unix)
    write_to_buffer( d, "\n\r", 2 );
#endif

    if ( strlen(argument) < 5 )
    {
	write_to_buffer( d,
	    "Password must be at least five characters long.\n\r"
	    "Password: ",
	    0 );
	return;
    }

    pwdnew = crypt( argument, ch->name );
    for ( p = pwdnew; *p != '\0'; p++ )
    {
	if ( *p == '~' )
	{
	    write_to_buffer( d,
		"New password not acceptable, try again.\n\r"
		"Password: ",
		0 );
	    return;
	}
    }

    free_string( ch->pcdata->pwd );
    ch->pcdata->pwd = str_dup( pwdnew );
    write_to_buffer( d, "Please retype password: ", 0 );
    d->connected = CON_CONFIRM_NEW_PASSWORD;
}


void display_race_list( DESCRIPTOR_DATA *d )
{
    char buf[MAX_STRING_LENGTH];
    int col, race;

    write_to_buffer( d, "  ", 2 );
    for ( race = 1, col = 0; race_table[race].name != NULL; race++ )
    {
	if ( !race_table[race].pc_race )
	    continue;

	if ( (!pc_race_table[race].ok_rel[0] && (d->character->pcdata->religion == 4))
	  || (!pc_race_table[race].ok_rel[1] && (d->character->pcdata->religion == 1))
	  || (!pc_race_table[race].ok_rel[2] && (d->character->pcdata->religion == 2))
	  || (!pc_race_table[race].ok_rel[3] && (d->character->pcdata->religion == 3)) )
	    continue;

        sprintf( buf, "%-18s ", race_table[race].name );
        write_to_buffer( d, buf, 0 );
        
        if ( ++col % 4 == 0 )
            write_to_buffer( d, "\n\r  ", 4 );
    }
    if ( col % 4 == 0 )
        write_to_buffer( d, "\n\r", 2 );
    write_to_buffer( d, "\n\r", 2 );

    write_to_buffer( d, "What is your race (help for more information)? ", 0 );
}


void nanny_confirm_new_password( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;

#if defined(unix)
    write_to_buffer( d, "\n\r", 2 );
#endif

    if ( strcmp( crypt(argument, ch->pcdata->pwd), ch->pcdata->pwd) )
    {
	write_to_buffer( d, 
	    "Passwords don't match.\n\r"
            "Retype password: ",
	    0 );
	d->connected = CON_GET_NEW_PASSWORD;
	return;
    }

    write_to_buffer( d, echo_on_str, 0 );
    write_to_buffer( d, "\n\r", 2 );
    
    if ( check_creating(d, ch->name) )
	return;
    
    do_help( ch, "god choices" );
    write_to_buffer(d, "To whom are you faithful? ", 0 );
    d->connected = CON_GET_NEW_GOD;
}


void display_sex_prompt( DESCRIPTOR_DATA *d, int race )
{
    char buf[MAX_STRING_LENGTH];
    bool first = TRUE;
    
    buf[ 0 ] = '\0';
    strcat( buf, "\n\rWhat is your sex (" );
    if ( IS_SET(pc_race_table[race].sexes, SEX_FLAG_MALE) )
    {
        strcat( buf, "M" );
        first = FALSE;
    }
    if ( IS_SET(pc_race_table[race].sexes, SEX_FLAG_FEMALE) )
    {
        if ( first )
            first = FALSE;
        else
            strcat( buf, "/" );
        strcat( buf, "F" );
    }
    if ( IS_SET(pc_race_table[race].sexes, SEX_FLAG_NEUTRAL) )
    {
        if ( first )
            first = FALSE;
        else
            strcat( buf, "/" );
        strcat( buf, "N" );
    }
    strcat( buf, ")? " );

    write_to_buffer( d, buf, 0 );
}


void nanny_get_new_race( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char arg[MAX_INPUT_LENGTH];
    bool not_recommended = FALSE;
    int iClass;
    int default_sex = -1;
    int race, i;

    one_argument( argument, arg );

    if ( !strcmp(arg, "help") )
    {
	argument = one_argument( argument, arg );
	if ( argument[0] == '\0' )
	    do_help( ch, "race help" );
	else
	    do_help( ch, argument );

	write_to_buffer( d,
	    "What is your race (help for more information)? ",0);
	return;
    }

    race = race_lookup( argument );

    if ( race == 0 || !race_table[race].pc_race
    || (!pc_race_table[race].ok_rel[0] && (d->character->pcdata->religion == 4))
    || (!pc_race_table[race].ok_rel[1] && (d->character->pcdata->religion == 1))
    || (!pc_race_table[race].ok_rel[2] && (d->character->pcdata->religion == 2))
    || (!pc_race_table[race].ok_rel[3] && (d->character->pcdata->religion == 3)) )
    {
	write_to_buffer( d,"That is not a valid race.\n\r", 0 );
	write_to_buffer( d,"The following races are available:\n\r  ", 0 );
        display_race_list( d );
	return;
    }

    ch->race = race;

    /* initialize stats */
    for ( i = 0; i < MAX_STATS; i++ )
	ch->perm_stat[i]    = pc_race_table[race].stats[i];
    ch->affected_by         = ch->affected_by|race_table[race].aff;
    ch->imm_flags           = ch->imm_flags|race_table[race].imm;
    ch->res_flags           = ch->res_flags|race_table[race].res;
    ch->vuln_flags          = ch->vuln_flags|race_table[race].vuln;
    ch->form                = race_table[race].form;
    ch->parts               = race_table[race].parts;

    /* add skills */
    for ( i = 0; i < 5; i++ )
    {
	if ( pc_race_table[race].skills[i] == NULL )
	    break;
	group_add( ch, pc_race_table[race].skills[i], FALSE );
    }
    /* add cost */
    ch->pcdata->points = pc_race_table[race].points;
    ch->size = pc_race_table[race].size;

    /* check if we even need to ask for their sex */
    if ( pc_race_table[race].sexes == 0
    ||   pc_race_table[race].sexes == SEX_FLAG_NEUTRAL )
        default_sex = SEX_NEUTRAL;
    else if ( pc_race_table[race].sexes == SEX_FLAG_MALE )
        default_sex = SEX_MALE;
    else if ( pc_race_table[race].sexes == SEX_FLAG_FEMALE )
        default_sex = SEX_FEMALE;
    if ( default_sex != -1 )
    {
        ch->sex                 = default_sex;
        ch->pcdata->true_sex    = default_sex;

        write_to_buffer( d, "\n\rThe following classes are available:\n\r  ", 0 );
        for ( iClass = 0; iClass < MAX_CLASS; iClass++ )
        {
            if ( !religion_table[GET_GOD(ch)].classes[iClass] )
                continue;

	    write_to_buffer( d, class_table[iClass].name, 0 );
	    if ( pc_race_table[ch->race].class_mult[iClass] >= 150 )
	    {
		write_to_buffer( d, "* ", 2 );
		not_recommended = TRUE;
	    }
	    else
		write_to_buffer( d, " ", 1 );
	}
	write_to_buffer( d, "\n\r", 2 );
	if ( not_recommended )
	    write_to_buffer( d, "* not recommended due to your race.\n\r", 0 );
	write_to_buffer( d, "\n\rWhat is your class (use help for more information)? ", 0 );
	d->connected = CON_GET_NEW_CLASS;
	return;
    }

    display_sex_prompt( d, race );
    d->connected = CON_GET_NEW_SEX;
}


void nanny_get_new_sex( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    bool not_recommended = FALSE;
    int iClass;

    switch ( argument[0] )
    {
    case 'm': 
    case 'M':
        if ( !IS_SET(pc_race_table[ch->race].sexes, SEX_FLAG_MALE) )
        {
            write_to_buffer( d, "That's not a valid sex for this race.\n\r", 0 );
            display_sex_prompt( d, ch->race );
            return;
        }
        ch->sex                 = SEX_MALE;    
	ch->pcdata->true_sex    = SEX_MALE;
	break;

    case 'f':
    case 'F':
        if ( !IS_SET(pc_race_table[ch->race].sexes, SEX_FLAG_FEMALE) )
        {
            write_to_buffer( d, "That's not a valid sex for this race.\n\r", 0 );
            display_sex_prompt( d, ch->race );
            return;
        }
        ch->sex                 = SEX_FEMALE;    
	ch->pcdata->true_sex    = SEX_FEMALE;
	break;

    case 'n':
    case 'N':
        if ( !IS_SET(pc_race_table[ch->race].sexes, SEX_FLAG_NEUTRAL) )
        {
            write_to_buffer( d, "That's not a valid sex for this race.\n\r", 0 );
            display_sex_prompt( d, ch->race );
            return;
        }
        ch->sex                 = SEX_NEUTRAL;    
	ch->pcdata->true_sex    = SEX_NEUTRAL;
	break;

    default:
	write_to_buffer( d, "That's not a sex.\n\r", 0 );
        display_sex_prompt( d, ch->race );
	return;
    }
    
    write_to_buffer( d, "\n\rThe following classes are available:\n\r  ", 0 );
    for ( iClass = 0; iClass < MAX_CLASS; iClass++ )
    {
        if ( !religion_table[GET_GOD(ch)].classes[iClass] )
            continue;
        
        write_to_buffer( d, class_table[iClass].name, 0 );
        if ( pc_race_table[ch->race].class_mult[iClass] >= 150 )
        {
            write_to_buffer( d, "* ", 2 );
            not_recommended = TRUE;
        }
        else
            write_to_buffer( d, " ", 1 );
    }
    write_to_buffer( d, "\n\r", 2 );
    if ( not_recommended )
        write_to_buffer( d, "* not recommended due to your race.\n\r", 0 );
    write_to_buffer( d, "\n\rWhat is your class (use help for more information)? ", 0 );
    d->connected = CON_GET_NEW_CLASS;
}


void nanny_get_new_god( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char arg[MAX_INPUT_LENGTH];

    one_argument( argument, arg );

    if ( !strcmp(arg, "help") )
    {
	argument = one_argument( argument, arg );
	if ( argument[0] == '\0' )
	    do_help( ch, "god choices" );
	else
	    do_help( ch, argument );

	write_to_buffer(d, "To whom are you faithful? ", 0 );
	return;
    }

    ch->pcdata->religion = religion_lookup( argument );
    if ( GET_GOD(ch) == -1 || !religion_table[GET_GOD(ch)].player_god )
    {
	write_to_buffer( d, "That's not a valid choice\n\rTo whom are you faithful? ", 0 );
	return; 
    }

    write_to_buffer( d, "\n\r", 2 );
    write_to_buffer( d, "The following races are available:\n\r", 0 );
    display_race_list( d );
    d->connected = CON_GET_NEW_RACE;
}


void nanny_get_new_class( DESCRIPTOR_DATA *d, char *argument )
{
    int iClass = class_lookup( argument );
    bool default_alignment = FALSE;
    CHAR_DATA *ch = d->character;
    bool first_alignment = TRUE;

    if ( iClass == -1 || !religion_table[GET_GOD(ch)].classes[iClass] )
    {
	write_to_buffer( d,
	    "That's not a class.\n\rWhat IS your class? ", 0 );
	return;
    }

    if ( !religion_table[GET_GOD(ch)].classes[iClass] )
    {
        write_to_buffer( d,
            "That class is not available to followers of your god.\n\r"
            "What IS your class? ", 0 );
        return;
    }

    ch->class = iClass;

    sprintf( log_buf, "%s@%s new player.", ch->name, d->host );
    log_string( log_buf );
    wiznet( "Newbie alert! $N sighted.", ch, NULL, WIZ_NEWBIE, 0, 0 );
    wiznet( log_buf, NULL, NULL, WIZ_SITES, 0, get_trust(ch) );

    write_to_buffer( d, "\n\r", 2 );

    if ( religion_table[GET_GOD(ch)].align_limits == ALIGN_GOOD )
    {
        ch->alignment       = 750;
        default_alignment   = TRUE;
    }
    else if ( religion_table[GET_GOD(ch)].align_limits == ALIGN_EVIL )
    {
        ch->alignment       = -750;
        default_alignment   = TRUE;
    }
    else if ( religion_table[GET_GOD(ch)].align_limits == ALIGN_NEUTRAL )
    {
        ch->alignment       = 0;
        default_alignment   = TRUE;
    }

    if ( default_alignment )
    {
	write_to_buffer( d, "You may settle in one of the following hometowns:\n\r", 0 );
	d->connected = CON_GET_NEW_HOMETOWN;
	pick_hometown( d );
	return;
    }

    write_to_buffer( d, "Please select your alignment [", 0 );
    if ( IS_SET(religion_table[GET_GOD(ch)].align_limits, ALIGN_GOOD) )
    {
	write_to_buffer( d, " good", 0 );
	first_alignment = FALSE;
    }
    if ( IS_SET(religion_table[GET_GOD(ch)].align_limits, ALIGN_NEUTRAL) )
    {
	if ( !first_alignment )
	{
	    write_to_buffer( d, ",", 0 );
	    first_alignment = TRUE;
	}
	write_to_buffer( d, " neutral", 0 );
    }
    if ( IS_SET(religion_table[GET_GOD(ch)].align_limits, ALIGN_EVIL) )
    {
	if ( !first_alignment )
	    write_to_buffer( d, ",", 0 );
	write_to_buffer( d, " evil", 0 );
    }
    write_to_buffer( d, " ] :", 0 );
    d->connected = CON_GET_ALIGNMENT;
}


void nanny_get_new_alignment( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;

    if ( (toupper(argument[0]) == 'G' && !str_prefix(argument, "good") 
    &&    !IS_SET(religion_table[GET_GOD(ch)].align_limits, ALIGN_GOOD))
    ||   (toupper(argument[0]) == 'N' && !str_prefix(argument, "neutral")
    &&    !IS_SET(religion_table[GET_GOD(ch)].align_limits, ALIGN_NEUTRAL))
    ||   (toupper(argument[0]) == 'E' && !str_prefix(argument, "evil")
    &&    !IS_SET(religion_table[GET_GOD(ch)].align_limits, ALIGN_EVIL)) )
    {
	write_to_buffer( d, "You cannot choose that alignment.\n\r"
                            "Enter your alignment: ", 0 );
	return;
    }
    
    switch( argument[0])
    {
	case 'g' : case 'G' : ch->alignment = 750;  break;
	case 'n' : case 'N' : ch->alignment = 0;    break;
	case 'e' : case 'E' : ch->alignment = -750; break;
	default:
	    write_to_buffer( d, "That's not a valid alignment.\n\r", 0 );
	    write_to_buffer( d, "Enter your alignment: ", 0 );
	    return;
    }

    write_to_buffer( d, "\n\rYou may settle in one of the following hometowns:\n\r", 0 );
    d->connected = CON_GET_NEW_HOMETOWN;
    pick_hometown( d );
}


void nanny_get_new_hometown( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char arg[MAX_STRING_LENGTH];
    int ht;

    one_argument( argument, arg );

    if ( !strcmp(arg, "help") )
    {
	argument = one_argument( argument, arg );   
	if ( argument[0] == '\0' )
	    do_help( ch, "hometown help" );
	else
	    do_help( ch, argument );
     
	write_to_buffer( d,
	    "Where do you wish to settle (help for more information)? ",0);
	return;
    }

    ht = hometown_lookup( argument );

    if ( (ht == 0) || (!hometown_table[ht].ht_avail)
	 || (hometown_table[ht].ht_restrict[ch->race] == 0)
	 || ((hometown_table[ht].ht_restrict[18] == 0) && (ch->alignment == 750))
	 || ((hometown_table[ht].ht_restrict[19] == 0) && (ch->alignment == 0))
	 || ((hometown_table[ht].ht_restrict[20] == 0) && (ch->alignment == -750)))
    {
        write_to_buffer( d,"That is not a valid hometown.\n\r", 0 );
        write_to_buffer( d,"You may settle in one of the following hometowns:\n\r  ", 0 );
        pick_hometown( d );
        return;
    }

    ch->hometown = ht;

    d->connected = CON_GET_NEW_STATS;
    generate_stats( d );
    return;
}

// For players who created before hometowns were put in. (22 Jul 99, Thollin)
void nanny_get_old_hometown( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char arg[MAX_STRING_LENGTH];
    int ht;
        
    one_argument( argument, arg );
    
    if ( !strcmp(arg, "help") )
    {
        argument = one_argument( argument, arg );
        if ( argument[0] == '\0' )
            do_help( ch, "hometown help" );
        else
            do_help( ch, argument );
        
        write_to_buffer( d,
            "Where do you wish to settle (help for more information)? ",0);
        return;
    }
            
    ht = hometown_lookup( argument );
     
    if ( (ht == 0) || (!hometown_table[ht].ht_avail)
         || (hometown_table[ht].ht_restrict[ch->race] == 0)
         || ((hometown_table[ht].ht_restrict[18] == 0) && (ch->alignment > 350))
         || ((hometown_table[ht].ht_restrict[19] == 0) && ((ch->alignment <= 350 && ch->alignment >= -350)))
         || ((hometown_table[ht].ht_restrict[20] == 0) && (ch->alignment <= -350)))
    {   
        write_to_buffer( d,"That is not a valid hometown.\n\r\n\r", 0 );
        write_to_buffer( d,"You may settle in one of the following hometowns:\n\r  ", 0 );
        pick_hometown( d );
        return;
    }
    
    ch->hometown = ht;

    sprintf( log_buf, "%s: hometown updated. Disconnecting.", ch->name );
    log_string( log_buf );
    wiznet( log_buf, NULL, NULL, WIZ_SITES, 0, get_trust(ch) );

    save_char_obj( ch, TRUE );
    write_to_buffer( d,"\n\rYour choice has been saved in your character file.\n\r", 0);
    write_to_buffer( d,"Please reconnect to ensure all changes are saved.\n\r", 0);
    extract_char( ch, TRUE );
    if ( d != NULL )
        close_socket( d, TRUE );
    return;
}


void nanny_get_new_stats( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char arg[MAX_STRING_LENGTH];
    char buf[MAX_STRING_LENGTH];
    int i;

    one_argument( argument, arg );
    
    switch ( argument[0] )
    {
    case 'Y':
    case 'y':
	break;
	
    case 'N':
    case 'n':
	generate_stats( d );
	return;
	
    default:
	write_to_buffer( d, "Yes or no: ", 0 );
	return;
    }

    group_add( ch, "rom basics", FALSE );
    ch->pcdata->learned[gsn_recall] = 50;
    
    if ( IS_SET(class_table[ch->class].flags, CLASS_NOCUST) )
    {
	group_add( ch, class_table[ch->class].base_group, TRUE );
	
	if ( IS_SET(class_table[ch->class].flags, CLASS_MARTIAL_ARTIST) )
	{
	    ch->pcdata->learned[gsn_hand_to_hand] = 40;
	    do_help( ch, "motd" );
	    
	    d->connected = CON_READ_MOTD;
	    return;
	}
	
	write_to_buffer( d,
	    "Please pick a weapon from the following choices:\n\r", 0 );
	buf[0] = '\0';
	for ( i = 0; weapon_table[i].name != NULL; i++ )
        {
	    if ( ch->pcdata->learned[*weapon_table[i].gsn] > 0 )
	    {
		strcat( buf, weapon_table[i].name );
		strcat( buf, " " );
	    }
        }

	strcat( buf, "\n\rYour choice? " );
	write_to_buffer( d, buf, 0 );
	d->connected = CON_PICK_WEAPON;
	return;
    }

    group_add( ch, class_table[ch->class].base_group, TRUE );

    write_to_buffer( d, "\n\rDo you wish to customize this character?\n\r", 0 );
    write_to_buffer( d, "Customization takes time, but allows a wider range of skills and abilities.\n\r", 0 );
    write_to_buffer( d, "Customize (Y/N)? ", 0 );
    d->connected = CON_DEFAULT_CHOICE;
}


void nanny_default_choice( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char buf[MAX_STRING_LENGTH];
    int i;

    write_to_buffer( d, "\n\r", 2 );
    
    switch ( argument[0] )
    {
    case 'y':
    case 'Y': 
	ch->gen_data = new_gen_data();
	ch->gen_data->points_chosen = ch->pcdata->points;
        do_help( ch, "'customization choice'" );
        do_help( ch, "'customization prompt'" );
        d->connected = CON_CUSTOMIZATION_CHOICE;
	break;

    case 'n':
    case 'N': 
	group_add( ch, class_table[ch->class].default_group, TRUE );
	write_to_buffer( d, "\n\r", 2 );
	
	if ( IS_SET(class_table[ch->class].flags, CLASS_MARTIAL_ARTIST) )
	{
	    ch->pcdata->learned[gsn_hand_to_hand] = 40;
	    do_help( ch, "motd" );
	    
	    d->connected = CON_READ_MOTD;
	    break;
	}

	write_to_buffer( d,
	    "Please pick a weapon from the following choices:\n\r", 0 );
	buf[0] = '\0';
	for ( i = 0; weapon_table[i].name != NULL; i++ )
        {
	    if (ch->pcdata->learned[*weapon_table[i].gsn] > 0)
	    {
		strcat( buf, weapon_table[i].name );
		strcat( buf, " " );
	    }
        }
	strcat( buf, "\n\rYour choice? " );
	write_to_buffer( d, buf, 0 );
	d->connected = CON_PICK_WEAPON;
	break;

    default:
	write_to_buffer( d, "Please answer (Y/N)? ", 0 );
	return;
    }
}


void nanny_customization_choice( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char arg[MAX_INPUT_LENGTH];

    write_to_buffer( d, "\n\r", 2 );

    if ( IS_NULLSTR(argument) )
    {
        write_to_buffer( d, "Invalid selection.\n\r", 0 );
        do_help( ch, "'customization prompt'" );
        return;
    }

    argument = one_argument( argument, arg );

    if ( str_prefix(arg, "help") == 0 )
    {
        if ( !IS_NULLSTR(argument) )
            do_help( ch, argument );
        else
            do_help( ch, "'customization choice'" );
        do_help( ch, "'customization prompt'" );
        return;
    }

    if ( str_prefix(arg, "skills") == 0 ||
         str_prefix(arg, "spells") == 0 )
    {
        skill_list( d );
        d->connected = CON_GEN_GROUPS;
        return;
    }

    if ( str_prefix(arg, "advantages") == 0 )
    {
        advantage_list( d );
        d->connected = CON_ADVANTAGES;
        return;
    }

    if ( str_prefix(arg, "disadvantages") == 0 )
    {
        disadvantage_list( d );
        d->connected = CON_DISADVANTAGES;
        return;
    }

    if ( str_prefix(arg, "ancestors") == 0 )
    {
        ancestor_list( d );
        d->connected = CON_ANCESTORS;
        return;
    }

    if ( str_prefix(arg, "done") == 0 )
    {
        char buf[MAX_STRING_LENGTH];
        int i;

        do_help( ch, "point cost" );
	if ( ch->pcdata->points < 40 )
	    ch->train = (40 - ch->pcdata->points + 1) / 2;
	free_gen_data( ch->gen_data );
	ch->gen_data = NULL;
	write_to_buffer( d, "\n\r", 2 );

	if ( IS_SET(class_table[ch->class].flags, CLASS_MARTIAL_ARTIST) )
	{
	    ch->pcdata->learned[gsn_hand_to_hand] = 40;
	    do_help( ch, "motd" );
	    
	    d->connected = CON_READ_MOTD;
	    return;
	}

	write_to_buffer(d,
	    "Please pick a weapon from the following choices:\n\r", 0 );
	buf[0] = '\0';
	for ( i = 0; weapon_table[i].name != NULL; i++ )
        {
	    if ( ch->pcdata->learned[*weapon_table[i].gsn] > 0 )
	    {
		strcat( buf, weapon_table[i].name );
		strcat( buf, " " );
	    }
        }
	strcat( buf, "\n\rYour choice? " );
	write_to_buffer( d, buf, 0 );
	d->connected = CON_PICK_WEAPON;
	return;
    }

    nanny_customization_choice( d, "" );
}


void generic_advantages( 
    DESCRIPTOR_DATA *d, char *argument, const char *msg, 
    const struct advantage_type *table, list_fn list )
{
    CHAR_DATA *ch = d->character;
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    CUST_DATA *cust;
    int type;

    write_to_buffer( d, "\n\r", 2 );
    argument = one_argument( argument, arg );
    if ( IS_NULLSTR(arg) )
    {
        advantage_prompt( d );
        return;
    }

    if ( str_cmp(arg, "done") == 0 )
    {
        do_help( ch, "'customization prompt'" );
        d->connected = CON_CUSTOMIZATION_CHOICE;
        return;
    }

    if ( str_cmp(arg, "help") == 0 )
    {
        do_help( ch, argument );
        return;
    }

    if ( str_cmp(arg, "list") == 0 )
    {
        list( d );
        return;
    }

    if ( str_cmp(arg, "add") == 0 )
    {
        if ( (type = advantage_lookup(table, argument, ch)) == -1 )
        {
            sprintf( buf, "That isn't a valid %s. Please try again:", msg );
            write_to_buffer( d, buf, 0 );
            return;
        }

        if ( has_customization(ch, table[type].value) )
        {
            send_to_char( "You have already added that. Please try again:", ch );
            return;
        }

        /* Close security hole */
        if ( ch->gen_data->points_chosen + table[type].points > MAX_POINTS )
        {
            send_to_char(
                "You cannot begin with so many creation points.\n\r", ch);
            return;
        }

        ch->pcdata->points         += table[type].points;
        ch->gen_data->points_chosen+= table[type].points;
        cust                        = new_cust_data();
        cust->type                  = table[type].value;
        cust->index                 = type;
        cust->affect.where          = table[type].where;
        if ( table[type].where != -1 )
        {
            cust->affect.type       = 0;
            cust->affect.level	    = 0;
            cust->affect.duration   = -1;
            cust->affect.location   = APPLY_NONE; // We typically hard code advantages
                                                  // and disadvantages where stats are
                                                  // queried to ensure they're not
                                                  // limited in any way.
            cust->affect.modifier   = 0;
            cust->affect.bitvector  = table[type].bitvector;
            cust->affect.procNo     = affect_proc_lookup( table[type].procName );
            cust->affect.flags      = table[type].flags;
            cust->affect.name       = "";
            cust->affect.appearance = "";
        }
        cust->next                  = ch->pcdata->customizations;
        ch->pcdata->customizations  = cust;
        
        advantage_prompt( d );
        return;
    }

    if ( str_cmp(arg, "drop") == 0 )
    {
        int index, type;
        if ( (index = advantage_lookup(table, argument, ch)) == -1 )
        {
            sprintf( buf, "That isn't a valid %s. Please try again: ", msg );
            write_to_buffer( d, buf, 0 );
            return;
        }

        if ( ch->pcdata->customizations == NULL )
        {
            sprintf( buf, "You don't have any %s to remove! Please try again: ", msg );
            write_to_buffer( d, buf, 0 );
            return;
        }

        type = table[index].value;

        cust = NULL;
        if ( ch->pcdata->customizations->type == type )
        {
            cust = ch->pcdata->customizations;
            ch->pcdata->customizations = ch->pcdata->customizations->next;
        }
        else
        {
            CUST_DATA *prev;
            for ( prev = ch->pcdata->customizations; prev != NULL; prev = prev->next )
            {
                if ( prev->next && prev->next->type == type )
                {
                    cust = prev->next;
                    prev->next = cust->next;
                    break;
                }
            }
        }
        
        if ( cust == NULL )
        {
            sprintf( buf, "You do not have nat %s to remove! Please try again: ", msg );
            write_to_buffer( d, buf, 0 );
            return;
        }

        ch->pcdata->points         -= table[index].points;
        ch->gen_data->points_chosen-= table[index].points;
        free_cust_data( cust );

        advantage_prompt( d );
        return;
    }

    write_to_buffer( d, "Invalid selection.\n\r", 0 );
    advantage_prompt( d );
}


void nanny_advantages( DESCRIPTOR_DATA *d, char *argument )
{
    generic_advantages( d, argument, "advantage", advantage_table, advantage_list );
}


void nanny_disadvantages( DESCRIPTOR_DATA *d, char *argument )
{
    generic_advantages( d, argument, "disadvantage", disadvantage_table, disadvantage_list );
}



void nanny_ancestors( DESCRIPTOR_DATA *d, char *argument )
{
    generic_advantages( d, argument, "ancestor", ancestor_table, ancestor_list );
}


void nanny_pick_weapon( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;
    char buf[MAX_STRING_LENGTH];
    int weapon;
    int i;

    write_to_buffer( d, "\n\r", 2 );
    weapon = weapon_lookup( argument );
    if ( weapon == -1 || ch->pcdata->learned[*weapon_table[weapon].gsn] <= 0 )
    {
	write_to_buffer( d,
	    "That's not a valid selection. Choices are:\n\r", 0 );
	buf[0] = '\0';
	for ( i = 0; weapon_table[i].name != NULL; i++ )
        {
	    if ( ch->pcdata->learned[*weapon_table[i].gsn] > 0 )
	    {
		strcat( buf,weapon_table[i].name );
		strcat( buf," ");
	    }
        }
	strcat( buf, "\n\rYour choice? " );
	write_to_buffer( d, buf, 0 );
	return;
    }

    ch->pcdata->learned[*weapon_table[weapon].gsn] = 40;
    write_to_buffer( d, "\n\r", 2 );    do_help( ch, "motd" );
    d->connected = CON_READ_MOTD;
}


void nanny_generate_groups( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;

    send_to_char( "\n\r", ch );
    if ( !str_cmp(argument, "done") )
    {
        do_help( ch, "'customization prompt'" );
        d->connected = CON_CUSTOMIZATION_CHOICE;
	return;
    }

    if ( !parse_gen_groups(ch, argument) )
    {
	send_to_char(
	    "Choices are: list,learned,premise,add,drop,info,help, and done.\n\r",
	    ch );
    }

    do_help( ch, "menu choice" );
}


void nanny_read_imotd( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;

    write_to_buffer( d, "\n\r", 2 );
    do_help( ch, "motd" );
    d->connected = CON_READ_MOTD;
}


void nanny_read_motd( DESCRIPTOR_DATA *d, char *argument )
{
    CHAR_DATA *ch = d->character;

    if ( ch->pcdata == NULL || ch->pcdata->pwd[0] == '\0')
    {
	write_to_buffer( d, "Warning! Null password!\n\r", 0 );
	write_to_buffer( d,
	    "Type 'password null <new password>' to fix.\n\r", 0 );
    }

    ch->next        = char_list;
    char_list       = ch;
    d->connected    = CON_PLAYING;
    reset_char( ch );

    if ( ch->hometown == 0)
    {
	write_to_buffer( d, "Since you last connected, the Labyrinth has added hometowns. Based upon your\n\r", 0 );
	write_to_buffer( d, "race and current alignment, a few cities are available for you. (If your\n\r", 0 );
	write_to_buffer( d, "alignment isn't where it should be, etc., contact an immortal and ask them\n\r", 0 );
	write_to_buffer( d, "to place you in the hometown of your choice.)\n\r\n\r", 0 );
	d->connected = CON_GET_OLD_HOMETOWN;
	pick_hometown( d );
	return;
    }

    if ( ch->level == 0 )
    {
	/* Now done as part of stat generation.
	 * ch->perm_stat[class_table[ch->class].attr_prime] += 12;
	 */

	ch->level    = 1;
	ch->exp      = exp_per_level(ch,ch->pcdata->points);
	ch->hit      = ch->max_hit;
	ch->mana     = ch->max_mana;
	ch->move     = ch->max_move;
	ch->train    = 3;
	ch->practice = 5;
	set_title( ch, ", lost wanderer of the maze." );

	do_outfit( ch, "" );
	obj_to_char( create_object(get_obj_index(OBJ_VNUM_MAP), 0, FALSE), ch );

	char_to_room( ch, get_room_index(ROOM_VNUM_SCHOOL) );
	send_to_char( "\n\r", ch );
	do_help( ch, "NEWBIE INFO" );
	send_to_char( "\n\r", ch );
    }
    else if ( ch->in_room != NULL )
    {
	char_to_room( ch, ch->in_room );
    }
    else if ( IS_IMMORTAL(ch) )
    {
	char_to_room( ch, get_room_index( ROOM_VNUM_CHAT ) );
    }
    else
    {
	char_to_room( ch, get_room_index( ROOM_VNUM_TEMPLE ) );
    }

    act( "$n has entered the game.", ch, NULL, NULL, TO_ROOM );
    do_look( ch, "auto" );

    mp_greet_trigger( ch );

    wiznet( "$N has left real life behind.", ch, NULL,
	    WIZ_LOGINS, 0/*WIZ_SITES*/, get_trust(ch) );

    if ( ch->pet != NULL )
    {
	char_to_room( ch->pet, ch->pet->in_room );
	act("$n has entered the game.",ch->pet,NULL,NULL,TO_ROOM);

	/* 
	 * If someone is following the char, these triggers get activated
	 * for the followers before the char, but it's safer this way...
	 */
	if ( HAS_TRIGGER(ch->pet, TRIG_ENTRY) )
	    mp_percent_trigger( ch->pet, NULL, NULL, NULL, TRIG_ENTRY );
    }

    do_unread(ch,"");
}


/*
 * Deal with sockets that haven't logged in yet.
 */
void nanny( DESCRIPTOR_DATA *d, char *argument )
{
    while ( isspace(*argument) )
	argument++;

    switch ( d->connected )
    {

    default:
	bug( "Nanny: bad d->connected %d.", d->connected );
	close_socket( d, TRUE );
	return;

    case CON_GET_NAME:
        nanny_get_name( d, argument );
	break;

    case CON_GET_OLD_PASSWORD:
        nanny_get_old_password( d, argument );
        break;

 
    case CON_BREAK_CONNECT:
        nanny_break_connect( d, argument );
        break;

    case CON_CONFIRM_NEW_NAME:
        nanny_confirm_new_name( d, argument );
        break;

    case CON_GET_NEW_PASSWORD:
        nanny_get_new_password( d, argument );
        break;

    case CON_CONFIRM_NEW_PASSWORD:
        nanny_confirm_new_password( d, argument );
        break;

    case CON_GET_NEW_RACE:
        nanny_get_new_race( d, argument );
        break;

    case CON_GET_NEW_SEX:
        nanny_get_new_sex( d, argument );
	break;
	
    case CON_GET_NEW_GOD:
        nanny_get_new_god( d, argument );
	break;
		
    case CON_GET_NEW_CLASS:
        nanny_get_new_class( d, argument );
        break;

    case CON_GET_ALIGNMENT:
        nanny_get_new_alignment( d, argument );
	break;
	
    case CON_GET_NEW_STATS:
        nanny_get_new_stats( d, argument );
        break;

    case CON_DEFAULT_CHOICE:
        nanny_default_choice( d, argument );
        break;

    case CON_CUSTOMIZATION_CHOICE:
        nanny_customization_choice( d, argument );
        break;

    case CON_ADVANTAGES:
        nanny_advantages( d, argument );
        break;

    case CON_DISADVANTAGES:
        nanny_disadvantages( d, argument );
        break;

    case CON_ANCESTORS:
        nanny_ancestors( d, argument );
        break;

    case CON_PICK_WEAPON:
        nanny_pick_weapon( d, argument );
	break;

    case CON_GEN_GROUPS:
        nanny_generate_groups( d, argument );
	break;

    case CON_READ_IMOTD:
        nanny_read_imotd( d, argument );
	break;

    case CON_READ_MOTD:
        nanny_read_motd( d, argument );
        break;

    case CON_GET_NEW_HOMETOWN:
	nanny_get_new_hometown( d, argument );
	break;

    case CON_GET_OLD_HOMETOWN:
	nanny_get_old_hometown( d, argument );
	break;
    }

    return;
}


/* equips a character */
void do_outfit( CHAR_DATA *ch, char *argument )
{
    OBJ_DATA *obj;
    int i,sn,vnum;

    if (ch->level > 5 || IS_NPC(ch))
    {
	send_to_char("Find it yourself!\n\r",ch);
	return;
    }
/*
 *  if ( ( obj = get_eq_char( ch, WEAR_LIGHT ) ) == NULL )
 *  {
 *	obj = create_object( get_obj_index(OBJ_VNUM_SCHOOL_BANNER), 0 );
 *	obj->cost = 0;
 *	obj_to_char( obj, ch );
 *	equip_char( ch, obj, WEAR_LIGHT );
 *  }
 */
    if ( ( obj = get_eq_char( ch, WEAR_BODY ) ) == NULL )
    {
	obj = create_object( get_obj_index(OBJ_VNUM_SCHOOL_VEST), 0, FALSE );
        convert_racial_equipment( race_table[ch->race].name, obj );
	obj->cost = 0;
        obj_to_char( obj, ch );
        equip_char( ch, obj, WEAR_BODY );
    }

    if ( class_table[ch->class].pMana )
    {
	if ( IS_SET(class_table[ch->class].flags, CLASS_NEEDS_SYMBOL)
	&&   religion_table[GET_GOD(ch)].symbol_vnum != 0 )
	{
	    int position = WEAR_NONE;

	    if ( get_eq_char(ch, WEAR_NECK_1) == NULL )
		position = WEAR_NECK_1;
	    else if ( get_eq_char(ch, WEAR_NECK_2) == NULL )
		position = WEAR_NECK_2;

	    if ( position != WEAR_NONE )
	    {
		obj = create_object( 
		    get_obj_index(religion_table[GET_GOD(ch)].symbol_vnum), 0, FALSE );
		obj->cost = 0;
		obj_to_char( obj, ch );
		equip_char( ch, obj, position );
	    }
	}
	else if ( !IS_SET(class_table[ch->class].flags, CLASS_NEEDS_SYMBOL)
	&&        religion_table[GET_GOD(ch)].orb_vnum != 0 )
	{
	    if ( get_eq_char(ch, WEAR_HOLD) == NULL )
	    {
		obj = create_object( 
		    get_obj_index(religion_table[GET_GOD(ch)].orb_vnum), 0, FALSE );
		obj->cost = 0;
		obj_to_char( obj, ch );
		equip_char( ch, obj, WEAR_HOLD );
	    }
	}
    }
    /* do the weapon thing */
    if ((obj = get_eq_char(ch,WEAR_WIELD)) == NULL
    &&  !IS_SET(class_table[ch->class].flags, CLASS_MARTIAL_ARTIST))
    {
    	sn = 0; 
    	vnum = OBJ_VNUM_SCHOOL_SWORD; /* just in case! */

    	for (i = 0; weapon_table[i].name != NULL; i++)
    	{
	    if (ch->pcdata->learned[sn] < 
		ch->pcdata->learned[*weapon_table[i].gsn])
	    {
	    	sn = *weapon_table[i].gsn;
	    	vnum = weapon_table[i].vnum;
	    }
    	}

    	obj = create_object(get_obj_index(vnum),0, FALSE);
     	convert_racial_equipment( race_table[ch->race].name, obj );
        obj_to_char(obj,ch);
    	equip_char(ch,obj,WEAR_WIELD);
    }
/*
 *  if (((obj = get_eq_char(ch,WEAR_WIELD)) == NULL 
 *  ||   !IS_WEAPON_STAT(obj,WEAPON_TWO_HANDS)) 
 *  &&  (obj = get_eq_char( ch, WEAR_SHIELD ) ) == NULL )
 *  {
 *      obj = create_object( get_obj_index(OBJ_VNUM_SCHOOL_SHIELD), 0 );
 *      obj->cost = 0;
 *      obj_to_char( obj, ch );
 *      equip_char( ch, obj, WEAR_SHIELD );
 *  }
 */
    act( "You have been equipped by $t.", 
    	ch, religion_table[GET_GOD(ch)].head, NULL, TO_CHAR );
}


void skill_list( DESCRIPTOR_DATA *d )
{
    CHAR_DATA *ch = d->character;
    do_help( ch, "group header" );
    list_group_costs( ch );
    write_to_buffer( d, "You already have the following skills:\n\r", 0 );
    do_skills( ch, "" );
    do_help( ch, "menu choice" );
    d->connected = CON_GEN_GROUPS;
}


void advantage_list( DESCRIPTOR_DATA *d )
{
    CHAR_DATA *ch = d->character;
    do_help( ch, "advantages" );
    list_advantages( d, advantage_table );
    do_help( ch, "point cost" );
    write_to_buffer( d, "You already have the following advantages:\n\r", 0 );
    list_advantages_gained( d, MIN_ADVANTAGE, MAX_ADVANTAGE, advantage_table );
    advantage_prompt( d );
}


void disadvantage_list( DESCRIPTOR_DATA *d )
{
    CHAR_DATA *ch = d->character;
    do_help( ch, "disadvantages" );
    list_advantages( d, disadvantage_table );
    do_help( ch, "point cost" );
    write_to_buffer( d, "You already have the following disadvantages:\n\r", 0 );
    list_advantages_gained( d, MIN_DISADVANTAGE, MAX_DISADVANTAGE, disadvantage_table );
    advantage_prompt( d );
}


void ancestor_list( DESCRIPTOR_DATA *d )
{
    CHAR_DATA *ch = d->character;
    do_help( ch, "ancestors" );
    list_advantages( d, ancestor_table );
    do_help( ch, "point cost" );
    write_to_buffer( d, "You already have the following ancestors:\n\r", 0 );
    list_advantages_gained( d, MIN_ANCESTOR, MAX_ANCESTOR, ancestor_table );
    advantage_prompt( d );
}


void advantage_prompt( DESCRIPTOR_DATA *d )
{
    write_to_buffer( d, "Choice (add, drop, list, help, done) ?", 0 );
}


void list_advantages( DESCRIPTOR_DATA *d, const struct advantage_type *table )
{
    char buf1[MAX_STRING_LENGTH];
    char buf2[MAX_STRING_LENGTH];
    int col = 0;
    int i;

    buf1[0] = '\0';
    for ( i = 0; !IS_NULLSTR(table[i].name); ++i )
    {
        if ( table[i].restrictions && char_matches(d->character, table[i].restrictions) )
            continue;

        if ( has_customization(d->character, table[i].value) )
            continue;

        sprintf( buf2, "%-20s %2d             ", table[i].name, table[i].points );
        if ( col % 2 != 0 )
            strcat( buf2, "\n\r" );
        ++col;
        strcat( buf1, buf2 );
    }
    if ( !IS_NULLSTR(buf1) )
    {
        strcat( buf1, "\n\r" );
        if ( col % 2 )
            strcat( buf1, "\n\r" );
    }
    write_to_buffer( d, buf1, 0 );
}


void list_advantages_gained( DESCRIPTOR_DATA *d, int min, int max, const struct advantage_type *table )
{
    char buf1[MAX_STRING_LENGTH];
    char buf2[MAX_STRING_LENGTH];
    CUST_DATA *current;
    int col = 1;         

    buf1[0] = '\0';
    for ( current = d->character->pcdata->customizations; current != NULL; current = current->next )
    {
        if ( current->type < min || current->type > max )
            continue;

        sprintf( buf2, "%-20s             ", table[current->index].name );
        if ( col % 2 == 0 )
            strcat( buf2, "\n\r" );
        ++col;
        strcat( buf1, buf2 );
    }
    if ( !IS_NULLSTR(buf1) )
    {
        strcat( buf1, "\n\r" );
        if ( col % 2 )
            strcat( buf1, "\n\r" );
    }
    write_to_buffer( d, buf1, 0 );
}

