/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

#if defined( WIN32 )
// Turn off password encryption.
#define NOCRYPT

// Turn off inconsistant DLL linkage warnings.
#pragma warning( disable : 4273 )
#endif

/*
 * Accommodate old non-Ansi compilers.
 */
#if defined(TRADITIONAL)
#define const
#define args( list )			()
#define DECLARE_DO_FUN( fun )		void		fun()
#define DECLARE_SPEC_FUN( fun )		bool		fun()
#define DECLARE_SPELL_FUN( fun )	void		fun()
#define DECLARE_AFF_PROC( fun )		void		fun()
#define DECLARE_DAM_FUN( fun )		char *		fun()
#define DECLARE_HELP_FUN( fun )         void            fun()
#else
#define args( list )			list
#define DECLARE_DO_FUN( fun )		DO_FUN		fun
#define DECLARE_SPEC_FUN( fun )		SPEC_FUN	fun
#define DECLARE_SPELL_FUN( fun )	SPELL_FUN	fun
#define DECLARE_AFF_PROC( fun )		AFFECT_PROC	fun
#define DECLARE_DAM_FUN( fun )		DAM_FUN		fun
#define DECLARE_HELP_FUN( fun )         void            fun
#endif


/* system calls */
int unlink();
int system();



/*
 * Short scalar types.
 * Diavolo reports AIX compiler has bugs with short types.
 */
#if	!defined(FALSE)
#define FALSE	 0
#endif

#if	!defined(TRUE)
#define TRUE	 1
#endif

#if	defined(_AIX)
#if	!defined(const)
#define const
#endif
typedef int				sh_int;
typedef int				bool;
#define unix
#else
typedef short   int			sh_int;
typedef unsigned char			bool;
#endif



/*
 * Structure types.
 */
typedef struct	affect_data			AFFECT_DATA;
typedef struct	area_data			AREA_DATA;
typedef struct	ban_data			BAN_DATA;
typedef struct  buf_type	 		BUFFER;
typedef struct	char_data			CHAR_DATA;
typedef struct	descriptor_data			DESCRIPTOR_DATA;
typedef struct	exit_data			EXIT_DATA;
typedef struct	extra_descr_data		EXTRA_DESCR_DATA;
typedef struct	help_data			HELP_DATA;
typedef struct	kill_data			KILL_DATA;
typedef struct	mem_data			MEM_DATA;
typedef struct	mob_index_data			MOB_INDEX_DATA;
typedef struct	note_data			NOTE_DATA;
typedef struct	obj_data			OBJ_DATA;
typedef struct	obj_index_data			OBJ_INDEX_DATA;
typedef struct	pc_data				PC_DATA;
typedef struct  cust_data                       CUST_DATA;
typedef struct	gen_data			GEN_DATA;
typedef struct	reset_data			RESET_DATA;
typedef struct	room_index_data			ROOM_INDEX_DATA;
typedef struct	shop_data			SHOP_DATA;
typedef struct	time_info_data			TIME_INFO_DATA;
typedef struct	weather_data			WEATHER_DATA;
typedef struct  bfs_queue_data  		BFS_QUEUE_DATA;
typedef struct  mprog_list			MPROG_LIST;
typedef struct  mprog_code			MPROG_CODE;
typedef struct  periodic_check_data		PERIODIC_CHECK_DATA;
typedef struct  use_msg_data			USE_MSG_DATA;
typedef struct  mud_event			MUD_EVENT;
typedef struct  bank_account			BANK_ACCOUNT;
typedef struct	crime_data			CRIME_DATA;
typedef struct  obj_skill_data                  OBJ_SKILL_DATA;


/*
 * Function types.
 */
typedef	void	DO_FUN		args( ( CHAR_DATA *ch, char *argument ) );
typedef bool	SPEC_FUN	args( ( CHAR_DATA *ch ) );
typedef void	SPELL_FUN	args( ( int sn, int level, CHAR_DATA *ch,
					void *vo, int target ) );
typedef void	AFFECT_PROC 	args( ( CHAR_DATA *ch, OBJ_DATA *obj,
					AFFECT_DATA *paf, int reason ) );
typedef char *	DAM_FUN		args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
typedef void    HELP_FUN        args( ( CHAR_DATA *ch, BUFFER *output, char *arg ) );


/*
 * String and memory management parameters.
 */
#define	MAX_KEY_HASH		1024
#define MAX_STRING_LENGTH	4608
#define MAX_INPUT_LENGTH	256
#define PAGELEN			22

/* I am lazy :) */
#define MSL MAX_STRING_LENGTH
#define MIL MAX_INPUT_LENGTH

/*
 * Game parameters.
 * Increase the max'es if you add more of something.
 * Adjust the pulse numbers to suit yourself.
 */
#define MAX_ADVERBS			  500
#define MAX_SOCIALS			  500
#define MAX_SKILL		  	  350
#define MAX_GROUP		   	   75
#define MAX_STYLES			   10
#define MAX_IN_GROUP			   26
#define MAX_COLOR		   	   31
#define MAX_ALIAS		   	   15
#define MAX_CLASS		   	   16
#define MAX_PC_RACE			   15
#define MAX_CLAN			    9
#define MAX_DAMAGE_MESSAGE		   41
#define MAX_STAT_NAME			   12
#define MAX_DONATION			    3
#define MAX_GODS              		    8
#define MAX_LEVEL			   60
#define MAX_MARTIAL_ARMOR		  100
#define MAX_PROFESSIONS			    3
#define MAX_SOCIAL_CLASS		   20
#define MAX_TERRITORIES			   20
#define MAX_PROFESSION_OPTION		    7		
#define MAX_POINTS                        300
#define MAX_HOMETOWN			   11
#define MAX_PC_FIGHT_RECORD                 5
#define MAX_ROOM_SAVE_OBJECTS             100

#define LEVEL_HERO	      (MAX_LEVEL - 9)
#define LEVEL_IMMORTAL	      (MAX_LEVEL - 8)

#define MAX_STAT_NAME			   12
#define AVG_STAT_NAME			    5	/* 4 below avg, 7 above */

#define PULSE_PER_SECOND		    4
#define PULSE_RCHECK   (1 * PULSE_PER_SECOND)
#define PULSE_VIOLENCE (3 * PULSE_PER_SECOND)
#define PULSE_MOBILE   (4 * PULSE_PER_SECOND)
#define PULSE_MUSIC    (6 * PULSE_PER_SECOND)
#define PULSE_TICK    (60 * PULSE_PER_SECOND)
#define PULSE_AREA   (120 * PULSE_PER_SECOND)

#define IMPLEMENTOR		    MAX_LEVEL
#define CREATOR		      (MAX_LEVEL - 1)
#define SUPREME		      (MAX_LEVEL - 2)
#define DEITY		      (MAX_LEVEL - 3)
#define GOD		      (MAX_LEVEL - 4)
#define IMMORTAL	      (MAX_LEVEL - 5)
#define DEMI		      (MAX_LEVEL - 6)
#define ANGEL		      (MAX_LEVEL - 7)
#define AVATAR		      (MAX_LEVEL - 8)
#define HERO			   LEVEL_HERO


/*
 * Site ban structure.
 */

#define BAN_SUFFIX			A
#define BAN_PREFIX			B
#define BAN_NEWBIES			C
#define BAN_ALL				D
#define BAN_PERMIT			E
#define BAN_PERMANENT			F

struct	ban_data
{
    BAN_DATA *	next;
    bool	valid;
    sh_int	ban_flags;
    sh_int	level;
    char *	name;
};

struct buf_type
{
    BUFFER *    next;
    bool        valid;
    sh_int      state;  /* error state of the buffer */
    sh_int      size;   /* size in k */
    char *      string; /* buffer's string */
};



/*
 * Time and weather stuff.
 */
#define SUN_DARK			0
#define SUN_RISE			1
#define SUN_LIGHT			2
#define SUN_SET				3

#define SKY_CLOUDLESS			0
#define SKY_CLOUDY			1
#define SKY_RAINING			2
#define SKY_LIGHTNING			3

struct	time_info_data
{
    int		hour;
    int		day;
    int		month;
    int		year;
    int		lunar_day;
};

struct	weather_data
{
    int		mmhg;
    int		change;
    int		sky;
    int		sunlight;
};



/*
 * Connected state for a channel.
 */
#define CON_PLAYING			 0
#define CON_GET_NAME			 1
#define CON_GET_OLD_PASSWORD		 2
#define CON_CONFIRM_NEW_NAME		 3
#define CON_GET_NEW_PASSWORD		 4
#define CON_CONFIRM_NEW_PASSWORD	 5
#define CON_GET_NEW_RACE		 6
#define CON_GET_NEW_SEX			 7
#define CON_GET_NEW_GOD			 8
#define CON_GET_NEW_CLASS		 9
#define CON_GET_ALIGNMENT		10
#define CON_GET_NEW_STATS		11
#define CON_DEFAULT_CHOICE		12 
#define CON_GEN_GROUPS			13 
#define CON_PICK_WEAPON			14
#define CON_READ_IMOTD			15
#define CON_READ_MOTD			16
#define CON_BREAK_CONNECT		17
#define CON_GET_NEW_HOMETOWN		18
#define CON_GET_OLD_HOMETOWN		19
#define CON_WARMBOOT_RECOVER		20
#define CON_CUSTOMIZATION_CHOICE        21
#define CON_ADVANTAGES                  22
#define CON_DISADVANTAGES               23
#define CON_ANCESTORS                   24


/*
 * Descriptor (channel) structure.
 */
struct	descriptor_data
{
    DESCRIPTOR_DATA *	next;
    DESCRIPTOR_DATA *	snoop_by;
    CHAR_DATA *		character;
    CHAR_DATA *		original;
    bool		valid;
    char *		host;
    sh_int		descriptor;
    sh_int		connected;
    bool		fcommand;
    char		inbuf		[4 * MAX_INPUT_LENGTH];
    char		incomm		[MAX_INPUT_LENGTH];
    char		inlast		[MAX_INPUT_LENGTH];
    int			repeat;
    char *		outbuf;
    int			outsize;
    int			outtop;
    char *		showstr_head;
    char *		showstr_point;

#if defined(unix)
    int			ifd;
    pid_t		ipid;
    char *		ident;
    int			port;
    int			ip;
#endif
};



/*
 * Attribute bonus structures.
 */

/* Struct modified by Avvrax 28 July, 2001 to include todam_mob field */
struct	str_app_type
{
    sh_int	tohit;
    sh_int  tohit_mob;
    sh_int	todam;
    sh_int	todam_mob;
    sh_int	carry;
    sh_int	wield;
};

struct	int_app_type
{
    sh_int	learn;
    sh_int	int_spell_modifier;
};

struct	wis_app_type
{
    sh_int	practice;
    sh_int	wis_spell_modifier;
};

struct	dex_app_type
{
    sh_int	defensive;
};

struct	con_app_type
{
    sh_int	hitp;
    sh_int	shock;
};

struct  per_app_type
{
    bool        secondary_defense;
    sh_int      defense_bonus;
};



/*
 * TO types for act.
 */
#define TO_ROOM                 0
#define TO_NOTVICT              1
#define TO_VICT                 2
#define TO_CHAR                 3
#define TO_ALL                  4



/*
 * Help table types.
 */
struct	help_data
{
    HELP_DATA *	next;
    sh_int	level;
    char *	keyword;
    char *	text;
};



/*
 * Shop types.
 */
#define MAX_TRADE	 5

struct	shop_data
{
    SHOP_DATA *	next;                   /* Next shop in list            */
    sh_int      keeper;                 /* Vnum of shop keeper mob      */
    sh_int      buy_type [MAX_TRADE];   /* Item types shop will buy     */
    sh_int      profit_buy;             /* Cost multiplier for buying   */
    sh_int      profit_sell;            /* Cost multiplier for selling  */
    sh_int      open_hour;              /* First opening hour           */
    sh_int      close_hour;             /* First closing hour           */
    
    bool valid;
};



/*
 * Per-class stuff.
 */

#define MAX_GUILD 			2
#define MAX_STATS 			7
#define STAT_STR 			0
#define STAT_INT			1
#define STAT_WIS			2
#define STAT_DEX			3
#define STAT_CON			4
#define STAT_PER			5
#define STAT_CHA			6

#define AVERAGE_STAT    69

#define PURE_MAGIC			80
#define NON_MAGIC			40

#define CLASS_NOCUST			(A)	/* Class cannot be customized.	*/
#define CLASS_OUTDOORS			(B)	/* Magic more powerful outdoors.*/
#define CLASS_MARTIAL_ARTIST		(C)	/* Class good at martial arts.	*/
#define CLASS_NEEDS_SYMBOL		(D)	/* Class needs symbol of their	*/
						/* god to cast.			*/
#define CLASS_SNEAKY			(E)	/* Can sneak out of combat.	*/
#define CLASS_RELIGIOUS			(F)	/* Closely associated with god. */

struct	class_type
{
    char *	name;				/* the full name of the class	*/
    char 	who_name	[4];		/* Three-letter name for 'who'	*/
    sh_int	attr_prime;			/* Prime attribute		*/
    sh_int	weapon;				/* First weapon			*/
    sh_int	guild[MAX_GUILD];		/* Vnum of guild rooms		*/
    sh_int	skill_adept;			/* Maximum skill level		*/
    sh_int	thac0_00;			/* Thac0 for level  0		*/
    sh_int	thac0_32;			/* Thac0 for level 32		*/
    sh_int	hp_min;				/* Min hp gained on leveling	*/
    sh_int	hp_max;				/* Max hp gained on leveling	*/
    bool	pMana;				/* Percentage mana gain on level*/
    char *	base_group;			/* base skills gained		*/
    char *	default_group;			/* default skills gained	*/
    
    int		flags;
};

struct item_type
{
    int		type;
    char *	name;
};

struct weapon_type
{
    char *	name;
    sh_int	vnum;
    sh_int	type;
    sh_int	*gsn;
};

struct poison_type
{
	 sh_int	type;
    char *	name;
};

struct wiznet_type
{
    char *	name;
    long 	flag;
    int		level;
};

struct game_type
{
    char *	name;
    DO_FUN *	function;
};

struct attack_type
{
    char *	name;					/* name */
    char *	noun;					/* message */
    int   	damage;					/* damage class */
    DAM_FUN *	fun;					/* message modifier */
    sh_int *	gdt;					/* global damage type */
};

struct race_type
{
    char *	name;					/* call name of the race */
    bool	pc_race;				/* can be chosen by pcs */
    long	act;					/* act bits for the race */
    long	aff;					/* aff bits for the race */
    long	aff2;					/* aff bits for the race */
    long	off;					/* off bits for the race */
    long	imm;					/* imm bits for the race */
    long	res;					/* res bits for the race */
    long	vuln;					/* vuln bits for the race */
    long	form;					/* default form flag for the race */
    long	parts;					/* default parts for the race */
    
    long	char_flags;				/* race flags for restrictions */
};


#define SEX_FLAG_MALE    (A)
#define SEX_FLAG_FEMALE  (B)
#define SEX_FLAG_NEUTRAL (C)

struct pc_race_type  					/* additional data for pc races */
{
    char *	name;					/* MUST be in race_type */
    char 	who_name[6];
    sh_int	points;					/* cost in points of the race */
    sh_int	class_mult[MAX_CLASS];			/* exp multiplier for class, * 100 */
    char *	skills[5];				/* bonus skills for the race */
    sh_int 	stats[MAX_STATS];			/* starting stats */
    sh_int	max_stats[MAX_STATS];			/* maximum stats */
    sh_int	size;					/* aff bits for the race */
    sh_int	race_age;				/* supposed to add age modifiers */
    sh_int      sexes;                                  /* available sexes. */
    bool        ok_rel[4];                              /* allowable religions. */
};


struct spec_type
{
    char * 	name;					/* special function name */
    SPEC_FUN *	function;				/* the function */
};



/*
 * Data structure for notes.
 */

#define NOTE_NOTE	0
#define NOTE_IDEA	1
#define NOTE_PENALTY	2
#define NOTE_NEWS	3
#define NOTE_CHANGES	4
#define NOTE_BUGS	5
struct	note_data
{
    NOTE_DATA *	next;
    bool 	valid;
    sh_int	type;
    char *	sender;
    char *	date;
    char *	to_list;
    char *	subject;
    char *	text;
    time_t  	date_stamp;
};



/*
 * An affect.
 */
struct	affect_data
{
    AFFECT_DATA *	next;
    bool		valid;
    sh_int		where;
    sh_int		type;
    sh_int		level;
    sh_int		duration;
    sh_int		location;
    sh_int		modifier;
    sh_int		procNo;
    int			flags;
    int			bitvector;
    char *		name;
    char *		appearance;
};

/* where definitions */
#define TO_AFFECTS		0
#define TO_OBJECT		1
#define TO_IMMUNE		2
#define TO_RESIST		3
#define TO_VULN			4
#define TO_WEAPON		5
#define TO_AFFECTS2		6
#define TO_SKILL		7
#define TO_POLYMORPH            8

/* flag definitions */
#define AFF_CONT_UPDATE		(A)	/* Affect proc is called every tick. */
#define AFF_INVIS		(B)	/* Player cannot see this affect.    */
#define AFF_BARD_SONG		(C)	/* Affect is due to bard song.       */
#define AFF_EXTENDED            (D)     /* Spell duration has been extended. */

#define AFF_PRI_LOW		(aa)	/* Determines whether an affects     */
#define AFF_PRI_MEDIUM		(bb)	/* appearance replaces a characters  */
#define AFF_PRI_HIGH		(cc)	/* appearance.                       */

#define AFF_PRIORITY_MASK	(AFF_PRI_LOW|AFF_PRI_MEDIUM|AFF_PRI_HIGH)

#define AFFECT_PRIORITY(flags)	(flags & AFF_PRIORITY_MASK)


/* affect proc execution reasons */
#define AFF_PROC_PERIODIC	0
#define AFF_PROC_FINISHED	1

/* affect procedure <-> name mapping */
struct affect_proc_name {
	char		*name;
	AFFECT_PROC	*fn;
};


/*
 * A kill structure (indexed by level).
 */
struct	kill_data
{
    sh_int		number;
    sh_int		killed;
};


/*
 * Tracking results.
 */
#define BFS_FOUND	(-1)
#define BFS_ERROR	(-2)
#define BFS_NO_PATH	(-3)


/*
 * Tracking target types.
 */
#define TRACK_NAME		0
#define TRACK_PC_ID		1
#define TRACK_NPC_ID		2
#define TRACK_PC_ID_BLIND	3
#define TRACK_NPC_ID_BLIND	4


/*
 * Act trigger result types.
 */
#define TRIGGERED_CHAR	(A)
#define TRIGGERED_VICT	(B)
#define TRIGGERED_ROOM	(C)


/*
 * Periodic room/object update list data.
 */
struct periodic_check_data
{
    PERIODIC_CHECK_DATA	*next;
    void *		 data;
    bool		 valid;
};


/*
 * Mud event messages.
 */
struct mud_event
{
    char *		message;
    time_t		date;
    bool		valid;
    
    MUD_EVENT *		next;
};


struct bank_account
{
    char *		name;
    long		balance;
    bool		valid;
    
    BANK_ACCOUNT *	next;
};


/***************************************************************************
 *                                                                         *
 *                   VALUES OF INTEREST TO AREA BUILDERS                   *
 *                   (Start of section ... start here)                     *
 *                                                                         *
 ***************************************************************************/

/*
 * Well known mob virtual numbers.
 * Defined in #MOBILES.
 */
#define MOB_VNUM_SWARM		      1
#define MOB_VNUM_STONE_ELEMENTAL      2
#define MOB_VNUM_SKELETAL_WARRIOR     3
#define MOB_VNUM_ACTOR		      4
#define MOB_VNUM_DEMON_1	      5
#define MOB_VNUM_DEMON_2	      6
#define MOB_VNUM_DEMON_3	      7
#define MOB_VNUM_DEMON_4	      8
#define MOB_VNUM_DEMON_5	      9
#define MOB_VNUM_DEMON_6	     10
#define MOB_VNUM_FIRE_TRACKER        11
#define MOB_VNUM_SPIDER              12
#define MOB_VNUM_SPIDER_FAMILIER     13
 
#define MOB_VNUM_FIDO		  12013
#define MOB_VNUM_CITYGUARD	   3060
#define MOB_VNUM_VAMPIRE	   3404

#define MOB_VNUM_PATROLMAN	   2106
#define GROUP_VNUM_TROLLS	   2100
#define GROUP_VNUM_OGRES	   2101


/* RT ASCII conversions -- used so we can have letters in this file */

#define A		  	1
#define B			2
#define C			4
#define D			8
#define E			16
#define F			32
#define G			64
#define H			128

#define I			256
#define J			512
#define K		        1024
#define L		 	2048
#define M			4096
#define N		 	8192
#define O			16384
#define P			32768

#define Q			65536
#define R			131072
#define S			262144
#define T			524288
#define U			1048576
#define V			2097152
#define W			4194304
#define X			8388608

#define Y			16777216
#define Z			33554432
#define aa			67108864 	/* doubled due to conflicts */
#define bb			134217728
#define cc			268435456    
#define dd			536870912
#define ee			1073741824
#define ff			2147483648

/*
 * ACT bits for mobs.
 * Used in #MOBILES.
 */
#define ACT_IS_NPC		(A)		/* Auto set for mobs	*/
#define ACT_SENTINEL	    	(B)		/* Stays in one room	*/
#define ACT_SCAVENGER	      	(C)		/* Picks up objects	*/
#define ACT_MOUNT		(D)		/* Can be mounted	*/
#define ACT_META		(E)		/* Meta-physician.	*/
#define ACT_AGGRESSIVE		(F)    		/* Attacks PC's		*/
#define ACT_STAY_AREA		(G)		/* Won't leave area	*/
#define ACT_WIMPY		(H)
#define ACT_PET			(I)		/* Auto set for pets	*/
#define ACT_TRAIN		(J)		/* Can train PC's	*/
#define ACT_PRACTICE		(K)		/* Can practice PC's	*/
#define ACT_CRIER		(L)
#define ACT_SURRENDERS		(M)
#define ACT_NO_SCAN		(N)
#define ACT_UNDEAD		(O)
#define ACT_GUARD               (P)
#define ACT_CLERIC		(Q)
#define ACT_MAGE		(R)
#define ACT_THIEF		(S)
#define ACT_WARRIOR		(T)
#define ACT_NOALIGN		(U)
#define ACT_NOPURGE		(V)
#define ACT_OUTDOORS		(W)
#define ACT_INDOORS		(Y)
#define ACT_FAMILIER            (Z)
#define ACT_IS_HEALER		(aa)
#define ACT_GAIN		(bb)
#define ACT_UPDATE_ALWAYS	(cc)
#define ACT_IS_CHANGER		(dd)
#define ACT_IS_BANKER		(ee)

/* damage classes */
#define DAM_NONE		0
#define DAM_BASH		1
#define DAM_PIERCE		2
#define DAM_SLASH		3
#define DAM_FIRE		4
#define DAM_COLD		5
#define DAM_LIGHTNING		6
#define DAM_ACID		7
#define DAM_POISON		8
#define DAM_NEGATIVE		9
#define DAM_HOLY		10
#define DAM_ENERGY		11
#define DAM_MENTAL		12
#define DAM_DISEASE		13
#define DAM_DROWNING		14
#define DAM_LIGHT		15
#define DAM_OTHER		16
#define DAM_HARM		17
#define DAM_CHARM		18
#define DAM_SOUND		19
#define DAM_SLAY		20

/* OFF bits for mobiles */
#define OFF_AREA_ATTACK		(A)
#define OFF_BACKSTAB		(B)
#define OFF_BASH		(C)
#define OFF_BERSERK		(D)
#define OFF_DISARM		(E)
#define OFF_DODGE		(F)
#define OFF_FADE		(G)
#define OFF_FAST		(H)
#define OFF_KICK		(I)
#define OFF_KICK_DIRT		(J)
#define OFF_PARRY		(K)
#define OFF_RESCUE		(L)
#define OFF_TAIL		(M)
#define OFF_TRIP		(N)
#define OFF_CRUSH		(O)
#define ASSIST_ALL		(P)
#define ASSIST_ALIGN		(Q)
#define ASSIST_RACE		(R)
#define ASSIST_PLAYERS		(S)
#define ASSIST_GUARD		(T)
#define ASSIST_VNUM		(U)
#define OFF_HUNTER		(V)
#define OFF_UNMOUNT		(W)
#define OFF_NASTY_HUNTER        (X)

/* return values for check_imm */
#define IS_NORMAL		0
#define IS_IMMUNE		1
#define IS_RESISTANT		2
#define IS_VULNERABLE		3

/* IMM bits for mobs */
#define IMM_SUMMON		(A)
#define IMM_CHARM		(B)
#define IMM_MAGIC		(C)
#define IMM_WEAPON		(D)
#define IMM_BASH		(E)
#define IMM_PIERCE		(F)
#define IMM_SLASH		(G)
#define IMM_FIRE		(H)
#define IMM_COLD		(I)
#define IMM_LIGHTNING		(J)
#define IMM_ACID		(K)
#define IMM_POISON		(L)
#define IMM_NEGATIVE		(M)
#define IMM_HOLY		(N)
#define IMM_ENERGY		(O)
#define IMM_MENTAL		(P)
#define IMM_DISEASE		(Q)
#define IMM_DROWNING		(R)
#define IMM_LIGHT		(S)
#define IMM_SOUND		(T)
#define IMM_WOOD		(X)
#define IMM_SILVER		(Y)
#define IMM_IRON		(Z)
#define NUM_IMMUNITIES          23

/* RES bits for mobs */
#define RES_SUMMON		(A)
#define RES_CHARM		(B)
#define RES_MAGIC		(C)
#define RES_WEAPON		(D)
#define RES_BASH		(E)
#define RES_PIERCE		(F)
#define RES_SLASH		(G)
#define RES_FIRE		(H)
#define RES_COLD		(I)
#define RES_LIGHTNING		(J)
#define RES_ACID		(K)
#define RES_POISON		(L)
#define RES_NEGATIVE		(M)
#define RES_HOLY		(N)
#define RES_ENERGY		(O)
#define RES_MENTAL		(P)
#define RES_DISEASE		(Q)
#define RES_DROWNING		(R)
#define RES_LIGHT		(S)
#define RES_SOUND		(T)
#define RES_WOOD		(X)
#define RES_SILVER		(Y)
#define RES_IRON		(Z)
 
/* VULN bits for mobs */
#define VULN_SUMMON		(A)
#define VULN_CHARM		(B)
#define VULN_MAGIC		(C)
#define VULN_WEAPON		(D)
#define VULN_BASH		(E)
#define VULN_PIERCE		(F)
#define VULN_SLASH		(G)
#define VULN_FIRE		(H)
#define VULN_COLD		(I)
#define VULN_LIGHTNING		(J)
#define VULN_ACID		(K)
#define VULN_POISON		(L)
#define VULN_NEGATIVE		(M)
#define VULN_HOLY		(N)
#define VULN_ENERGY		(O)
#define VULN_MENTAL		(P)
#define VULN_DISEASE		(Q)
#define VULN_DROWNING		(R)
#define VULN_LIGHT		(S)
#define VULN_SOUND		(T)
#define VULN_WOOD		(X)
#define VULN_SILVER		(Y)
#define VULN_IRON		(Z)
 
/* body form */
#define FORM_EDIBLE		(A)
#define FORM_POISON		(B)
#define FORM_MAGICAL		(C)
#define FORM_INSTANT_DECAY	(D)
#define FORM_OTHER		(E)  /* defined by material bit */
 
/* actual form */
#define FORM_ANIMAL		(G)
#define FORM_SENTIENT		(H)
#define FORM_UNDEAD		(I)
#define FORM_CONSTRUCT		(J)
#define FORM_MIST		(K)
#define FORM_INTANGIBLE		(L)
 
#define FORM_BIPED		(M)
#define FORM_CENTAUR		(N)
#define FORM_INSECT		(O)
#define FORM_SPIDER		(P)
#define FORM_CRUSTACEAN		(Q)
#define FORM_WORM		(R)
#define FORM_BLOB		(S)
 
#define FORM_MAMMAL		(V)
#define FORM_BIRD		(W)
#define FORM_REPTILE		(X)
#define FORM_SNAKE		(Y)
#define FORM_DRAGON		(Z)
#define FORM_AMPHIBIAN		(aa)
#define FORM_FISH		(bb)
#define FORM_COLD_BLOOD		(cc)
 
/* body parts */
#define PART_HEAD		(A)
#define PART_ARMS		(B)
#define PART_LEGS		(C)
#define PART_HEART		(D)
#define PART_BRAINS		(E)
#define PART_GUTS		(F)
#define PART_HANDS		(G)
#define PART_FEET		(H)
#define PART_FINGERS		(I)
#define PART_EAR		(J)
#define PART_EYE		(K)
#define PART_LONG_TONGUE	(L)
#define PART_EYESTALKS		(M)
#define PART_TENTACLES		(N)
#define PART_FINS		(O)
#define PART_WINGS		(P)
#define PART_TAIL		(Q)
/* for combat */
#define PART_CLAWS		(U)
#define PART_FANGS		(V)
#define PART_HORNS		(W)
#define PART_SCALES		(X)
#define PART_TUSKS		(Y)


/*
 * Bits for 'affected_by'.
 * Used in #MOBILES.
 */
#define AFF_BLIND		(A)
#define AFF_INVISIBLE		(B)
#define AFF_DETECT_EVIL		(C)
#define AFF_DETECT_INVIS	(D)
#define AFF_DETECT_MAGIC	(E)
#define AFF_DETECT_HIDDEN	(F)
#define AFF_DETECT_GOOD		(G)
#define AFF_SANCTUARY		(H)
#define AFF_FAERIE_FIRE		(I)
#define AFF_INFRARED		(J)
#define AFF_CURSE		(K)
#define AFF_PARALYSIS		(L)
#define AFF_POISON		(M)
#define AFF_PROTECT_EVIL	(N)
#define AFF_PROTECT_GOOD	(O)
#define AFF_SNEAK		(P)
#define AFF_HIDE		(Q)
#define AFF_SLEEP		(R)
#define AFF_CHARM		(S)
#define AFF_FLYING		(T)
#define AFF_PASS_DOOR		(U)
#define AFF_HASTE		(V)
#define AFF_CALM		(W)
#define AFF_PLAGUE		(X)
#define AFF_ANIMAL_CALL		(Y)
#define AFF_DARK_VISION		(Z)
#define AFF_BERSERK		(aa)
#define AFF_SWIM		(bb)
#define AFF_REGENERATION	(cc)
#define AFF_SLOW		(dd)
#define AFF_DETECT_TRAPS	(ee)

#define AFF2_DARKNESS_CLOUD	(A)
#define AFF2_FIX_SOUL		(B)
#define AFF2_MARK_TREE		(C)
#define AFF2_WATER_SPEECH	(D)
#define AFF2_WATER_BREATHING	(E)
#define AFF2_WATERS_WAYS	(F)
#define AFF2_SMOKE_PARASITE	(G)
#define AFF2_SPELL_STEAL	(H)
#define AFF2_STOLEN_SPELL	(I)
#define AFF2_REFLECTION		(J)
#define AFF2_STABILIZE_MANA	(K)
#define AFF2_DOMINATION		(L)
#define AFF2_HALLUCINATION	(M)
#define AFF2_DETECT_ILLUSION	(N)
#define AFF2_PACIFIST		(O)
#define AFF2_MIRROR_IMAGE	(P)
#define AFF2_DELUDE		(Q)
#define AFF2_IMPROVED_INVIS	(R)
#define AFF2_ALKAR		(S)
#define AFF2_DEATH_TRANCE	(T)
#define AFF2_CORPSE_FORM	(U)
#define AFF2_TRACELESS_TRAVEL   (V)
#define AFF2_FIRE_TRACK         (W)
#define AFF2_CONTINGENCY        (X)
#define AFF2_SPELL_HASTE        (Y)
#define AFF2_BACKLASH           (Z)
#define AFF2_NO_EQUIPMENT       (aa)
#define AFF2_CANT_CAST          (bb)
#define AFF2_HALF_XP            (cc)

/*
 * Sex.
 * Used in #MOBILES.
 */
#define SEX_NEUTRAL		0
#define SEX_MALE		1
#define SEX_FEMALE		2

/* AC types */
#define AC_PIERCE		0
#define AC_BASH			1
#define AC_SLASH		2
#define AC_EXOTIC		3

/* dice */
#define DICE_NUMBER		0
#define DICE_TYPE		1
#define DICE_BONUS		2

/* size */
#define SIZE_TINY		0
#define SIZE_SMALL		1
#define SIZE_MEDIUM		2
#define SIZE_LARGE		3
#define SIZE_HUGE		4
#define SIZE_GIANT		5



/*
 * Well known object virtual numbers.
 * Defined in #OBJECTS.
 */
#define OBJ_VNUM_SILVER_ONE	      1
#define OBJ_VNUM_GOLD_ONE	      2
#define OBJ_VNUM_GOLD_SOME	      3
#define OBJ_VNUM_SILVER_SOME	      4
#define OBJ_VNUM_COINS		      5

#define OBJ_VNUM_CORPSE_NPC	     10
#define OBJ_VNUM_CORPSE_PC	     11
#define OBJ_VNUM_SEVERED_HEAD	     12
#define OBJ_VNUM_TORN_HEART	     13
#define OBJ_VNUM_SLICED_ARM	     14
#define OBJ_VNUM_SLICED_LEG	     15
#define OBJ_VNUM_GUTS		     16
#define OBJ_VNUM_BRAINS		     17

#define OBJ_VNUM_MUSHROOM	     20
#define OBJ_VNUM_LIGHT_BALL	     21
#define OBJ_VNUM_SPRING		     22
#define OBJ_VNUM_DISC		     23
#define OBJ_VNUM_PORTAL		     25

#define OBJ_VNUM_VAL_SYM	     26
#define OBJ_VNUM_VAL_ORB	     27
#define OBJ_VNUM_MYR_SYM	     28
#define OBJ_VNUM_MYR_ORB	     29
#define OBJ_VNUM_ARI_SYM	     30
#define OBJ_VNUM_ARI_ORB	     31
#define OBJ_VNUM_REN_SYM	     32
#define OBJ_VNUM_REN_ORB	     33

#define OBJ_VNUM_ROSE		     34
#define OBJ_VNUM_WING		     35
#define OBJ_VNUM_DRUID_STAFF	     36

#define OBJ_VNUM_TRAP		     37
#define OBJ_VNUM_CEILING_BLOCK	     38
#define OBJ_VNUM_SHADOWBLADE	     39
#define OBJ_VNUM_DEFENDER	     40

/* commented out lines have no unique corpse but are duplicates of some other damage kind */
//#define OBJ_VNUM_CORPSE_NPC_NONE     10	
#define OBJ_VNUM_CORPSE_NPC_BASH     41	
//#define OBJ_VNUM_CORPSE_NPC_PIERCE   41	
//#define OBJ_VNUM_CORPSE_NPC_SLASH    41
#define OBJ_VNUM_CORPSE_NPC_FIRE     42
#define OBJ_VNUM_CORPSE_NPC_COLD     43
#define OBJ_VNUM_CORPSE_NPC_LIGHTNING 44
#define OBJ_VNUM_CORPSE_NPC_ACID     45
#define OBJ_VNUM_CORPSE_NPC_POISON   46
#define OBJ_VNUM_CORPSE_NPC_NEGATIVE 47
#define OBJ_VNUM_CORPSE_NPC_HOLY     48
#define OBJ_VNUM_CORPSE_NPC_ENERGY   49
//#define OBJ_VNUM_CORPSE_NPC_MENTAL   10
#define OBJ_VNUM_CORPSE_NPC_DISEASE  50
#define OBJ_VNUM_CORPSE_NPC_DROWNING 51
//#define OBJ_VNUM_CORPSE_NPC_LIGHT    49
//#define OBJ_VNUM_CORPSE_NPC_OTHER    10
//#define OBJ_VNUM_CORPSE_NPC_HARM     10
//#define OBJ_VNUM_CORPSE_NPC_CHARM    10
//#define OBJ_VNUM_CORPSE_NPC_SOUND    10
#define OBJ_VNUM_CORPSE_NPC_SLAY     52

//#define OBJ_VNUM_CORPSE_PC_NONE      11	
#define OBJ_VNUM_CORPSE_PC_BASH	     55	
//#define OBJ_VNUM_CORPSE_PC_PIERCE    55	
//#define OBJ_VNUM_CORPSE_PC_SLASH     55
#define OBJ_VNUM_CORPSE_PC_FIRE	     56
#define OBJ_VNUM_CORPSE_PC_COLD	     57
#define OBJ_VNUM_CORPSE_PC_LIGHTNING 58
#define OBJ_VNUM_CORPSE_PC_ACID	     59
#define OBJ_VNUM_CORPSE_PC_POISON    60
#define OBJ_VNUM_CORPSE_PC_NEGATIVE  61
#define OBJ_VNUM_CORPSE_PC_HOLY	     62
#define OBJ_VNUM_CORPSE_PC_ENERGY    63
//#define OBJ_VNUM_CORPSE_PC_MENTAL    11
#define OBJ_VNUM_CORPSE_PC_DISEASE   64
#define OBJ_VNUM_CORPSE_PC_DROWNING  65
//#define OBJ_VNUM_CORPSE_PC_LIGHT     63
//#define OBJ_VNUM_CORPSE_PC_OTHER     11
//#define OBJ_VNUM_CORPSE_PC_HARM      11
//#define OBJ_VNUM_CORPSE_PC_CHARM     11
//#define OBJ_VNUM_CORPSE_PC_SOUND     11
#define OBJ_VNUM_CORPSE_PC_SLAY      66
#define OBJ_VNUM_SOCKETED_GEM		78

/* alternative food items for the create food spell */
#define OBJ_VNUM_FOOD1		     69
#define OBJ_VNUM_FOOD2		     70
#define OBJ_VNUM_FOOD3		     71
#define OBJ_VNUM_FOOD4		     72
#define OBJ_VNUM_FOOD5		     73
#define OBJ_VNUM_FOOD6		     74
#define OBJ_VNUM_FOOD7		     75
#define OBJ_VNUM_FOOD8		     76
#define OBJ_VNUM_FOOD9		     77

#define OBJ_VNUM_ARROW		     80

#define OBJ_VNUM_PIT		   3010

#define OBJ_VNUM_SCHOOL_MACE	  12917
#define OBJ_VNUM_SCHOOL_DAGGER	  12918
#define OBJ_VNUM_SCHOOL_SWORD	  12919
#define OBJ_VNUM_SCHOOL_SPEAR	  12920
#define OBJ_VNUM_SCHOOL_STAFF	  12921
#define OBJ_VNUM_SCHOOL_AXE	  12922
#define OBJ_VNUM_SCHOOL_FLAIL	  12923
#define OBJ_VNUM_SCHOOL_WHIP	  12924
#define OBJ_VNUM_SCHOOL_POLEARM   12925
#define OBJ_VNUM_SCHOOL_BOW	  12926

#define OBJ_VNUM_SCHOOL_VEST	  12903
#define OBJ_VNUM_SCHOOL_SHIELD	   3704
#define OBJ_VNUM_SCHOOL_BANNER     3716
#define OBJ_VNUM_MAP		  12164

#define OBJ_VNUM_WHISTLE	   2116



/*
 * Item types.
 * Used in #OBJECTS.
 */
#define ITEM_LIGHT		      1
#define ITEM_SCROLL		      2
#define ITEM_WAND		      3
#define ITEM_STAFF		      4
#define ITEM_WEAPON		      5
#define ITEM_TREASURE		      8
#define ITEM_ARMOR		      9
#define ITEM_POTION		     10
#define ITEM_CLOTHING		     11
#define ITEM_FURNITURE		     12
#define ITEM_TRASH		     13
#define ITEM_CONTAINER		     15
#define ITEM_DRINK_CON		     17
#define ITEM_KEY		     18
#define ITEM_FOOD		     19
#define ITEM_MONEY		     20
#define ITEM_BOAT		     22
#define ITEM_CORPSE_NPC		     23
#define ITEM_CORPSE_PC		     24
#define ITEM_FOUNTAIN		     25
#define ITEM_PILL		     26
#define ITEM_PROTECT		     27
#define ITEM_MAP		     28
#define ITEM_PORTAL		     29
#define ITEM_WARP_STONE		     30
#define ITEM_ROOM_KEY		     31
#define ITEM_GEM		     32
#define ITEM_JEWELRY		     33
#define ITEM_JUKEBOX		     34
#define ITEM_SYMBOL		     35
#define ITEM_FOCUS		     36
#define ITEM_TRAP		     37
#define ITEM_POISON		     38
#define ITEM_INSTRUMENT		     39
#define ITEM_CHECKERS_BOARD	     40
#define ITEM_QUIVER		     41
#define ITEM_ARROW		     42
#define ITEM_SOCKETED_GEM	     43

/*
 * Extra flags.
 * Used in #OBJECTS.
 */
#define ITEM_GLOW		(A)
#define ITEM_HUM		(B)
#define ITEM_DARK		(C)
#define ITEM_LOCK		(D)
#define ITEM_EVIL		(E)
#define ITEM_INVIS		(F)
#define ITEM_MAGIC		(G)
#define ITEM_NODROP		(H)
#define ITEM_BLESS		(I)
#define ITEM_ANTI_GOOD		(J)
#define ITEM_ANTI_EVIL		(K)
#define ITEM_ANTI_NEUTRAL	(L)
#define ITEM_NOREMOVE		(M)
#define ITEM_INVENTORY		(N)
#define ITEM_NOPURGE		(O)
#define ITEM_ROT_DEATH		(P)
#define ITEM_VIS_DEATH		(Q)
#define ITEM_DISPELLED		(R)
#define ITEM_NONMETAL		(S)
#define ITEM_NOLOCATE		(T)
#define ITEM_MELT_DROP		(U)
#define ITEM_HAD_TIMER		(V)
#define ITEM_SELL_EXTRACT	(W)
#define ITEM_FIRST_SOCKET	(X)
#define ITEM_BURN_PROOF		(Y)
#define ITEM_NOUNCURSE		(Z)
#define ITEM_NO_SAC		(aa)
#define ITEM_MIRROR		(bb)
#define ITEM_LODGED		(cc)
#define ITEM_EXTINGUISHED       (dd)
#define ITEM_SECOND_SOCKET	(ee)
#define ITEM_THIRD_SOCKET	(ff)

/*
 * Wear flags.
 * Used in #OBJECTS.
 */
#define ITEM_TAKE		(A)
#define ITEM_WEAR_FINGER	(B)
#define ITEM_WEAR_NECK		(C)
#define ITEM_WEAR_BODY		(D)
#define ITEM_WEAR_HEAD		(E)
#define ITEM_WEAR_LEGS		(F)
#define ITEM_WEAR_FEET		(G)
#define ITEM_WEAR_HANDS		(H)
#define ITEM_WEAR_ARMS		(I)
#define ITEM_WEAR_SHIELD	(J)
#define ITEM_WEAR_ABOUT		(K)
#define ITEM_WEAR_WAIST		(L)
#define ITEM_WEAR_WRIST		(M)
#define ITEM_WIELD		(N)
#define ITEM_HOLD		(O)
#define ITEM_OLD_NO_SAC		(P)
#define ITEM_WEAR_FLOAT		(Q)
#define ITEM_WEAR_HAIR		(R)
#define ITEM_WEAR_FACE          (S)
#define ITEM_WEAR_EARS          (T)
#define ITEM_WEAR_SHOULDER	(U)
#define ITEM_LODGE_LEG		(V)
#define ITEM_LODGE_ARM		(W)
#define ITEM_LODGE_RIB		(X)

/* weapon class */
#define WEAPON_EXOTIC		0
#define WEAPON_SWORD		1
#define WEAPON_DAGGER		2
#define WEAPON_SPEAR		3
#define WEAPON_MACE		4
#define WEAPON_AXE		5
#define WEAPON_FLAIL		6
#define WEAPON_WHIP		7	
#define WEAPON_POLEARM		8
#define WEAPON_BOW		9

/* weapon types */
#define WEAPON_FLAMING		(A)
#define WEAPON_FROST		(B)
#define WEAPON_VAMPIRIC		(C)
#define WEAPON_SHARP		(D)
#define WEAPON_VORPAL		(E)
#define WEAPON_TWO_HANDS	(F)
#define WEAPON_SHOCKING		(G)
#define WEAPON_POISON		(H)
#define WEAPON_FADING		(I)
#define WEAPON_DEFENDER		(J)
#define WEAPON_CURSE            (K)
#define WEAPON_DISPEL           (L)

/* gate flags */
#define GATE_NORMAL_EXIT	(A)
#define GATE_NOCURSE		(B)
#define GATE_GOWITH		(C)
#define GATE_BUGGY		(D)
#define GATE_RANDOM		(E)
#define GATE_SENDHOME		(F)

/* furniture flags */
#define STAND_AT		(A)
#define STAND_ON		(B)
#define STAND_IN		(C)
#define SIT_AT			(D)
#define SIT_ON			(E)
#define SIT_IN			(F)
#define REST_AT			(G)
#define REST_ON			(H)
#define REST_IN			(I)
#define SLEEP_AT		(J)
#define SLEEP_ON		(K)
#define SLEEP_IN		(L)
#define PUT_AT			(M)
#define PUT_ON			(N)
#define PUT_IN			(O)
#define PUT_INSIDE		(P)

/*
 * Focus flags.
 */
#define FOCUS_OVERLOAD_PROTECTED        (A)
#define FOCUS_HARDENED                  (B)




/*
 * Apply types (for affects).
 * Used in #OBJECTS.
 */
#define APPLY_NONE		      0
#define APPLY_STR		      1
#define APPLY_DEX		      2
#define APPLY_INT		      3
#define APPLY_WIS		      4
#define APPLY_CON		      5
#define APPLY_SEX		      6
#define APPLY_CLASS		      7
#define APPLY_LEVEL		      8
#define APPLY_AGE		      9
#define APPLY_HEIGHT		     10
#define APPLY_WEIGHT		     11
#define APPLY_MANA		     12
#define APPLY_HIT		     13
#define APPLY_MOVE		     14
#define APPLY_GOLD		     15
#define APPLY_EXP		     16
#define APPLY_AC		     17
#define APPLY_HITROLL		     18
#define APPLY_DAMROLL		     19
#define APPLY_SAVES		     20
#define APPLY_SAVING_PARA	     20
#define APPLY_SAVING_ROD	     21
#define APPLY_SAVING_PETRI	     22
#define APPLY_SAVING_BREATH	     23
#define APPLY_SAVING_SPELL	     24
#define APPLY_SPELL_AFFECT	     25
#define APPLY_PER		     26
#define APPLY_CHA		     27


/*
 * Values for containers (value[1]).
 * Used in #OBJECTS.
 */
#define CONT_CLOSEABLE		      1
#define CONT_PICKPROOF		      2
#define CONT_CLOSED		      4
#define CONT_LOCKED		      8
#define CONT_PUT_ON		     16



/*
 * Well known room virtual numbers.
 * Defined in #ROOMS.
 */
#define ROOM_VNUM_LIMBO		      2
#define ROOM_VNUM_EMBED               3
#define ROOM_VNUM_CHAT		   1200
#define ROOM_VNUM_TEMPLE	  12000
#define ROOM_VNUM_ALTAR		  12000
#define ROOM_VNUM_SCHOOL	  12900



/*
 * Room flags.
 * Used in #ROOMS.
 */
#define ROOM_DARK		(A)
#define ROOM_COURT		(B)
#define ROOM_NO_MOB		(C)
#define ROOM_INDOORS		(D)
#define ROOM_NO_SCAN		(E)

#define ROOM_PRIVATE		(J)
#define ROOM_SAFE		(K)
#define ROOM_SOLITARY		(L)
#define ROOM_PET_SHOP		(M)
#define ROOM_NO_RECALL		(N)
#define ROOM_IMP_ONLY		(O)
#define ROOM_GODS_ONLY		(P)
#define ROOM_HEROES_ONLY	(Q)
#define ROOM_NEWBIES_ONLY	(R)
#define ROOM_LAW		(S)
#define ROOM_NOWHERE		(T)
#define ROOM_NO_CAST_MAGE	(U)
#define ROOM_NO_CAST_CLERIC	(V)
#define ROOM_NO_AMUSIC          (W)
#define ROOM_EQUIPMENT_LOADED   (X)


/*
 * Directions.
 * Used in #ROOMS.
 */
#define DIR_NORTH		      0
#define DIR_EAST		      1
#define DIR_SOUTH		      2
#define DIR_WEST		      3
#define DIR_UP			      4
#define DIR_DOWN		      5
#define DIR_NORTHEAST		      6
#define DIR_SOUTHEAST		      7
#define DIR_SOUTHWEST		      8
#define DIR_NORTHWEST		      9
#define DIR_CLOCKWISE		     10
#define DIR_COUNTERCLOCKWISE	     11



/*
 * Exit flags.
 * Used in #ROOMS.
 */
#define EX_ISDOOR		      (A)
#define EX_CLOSED		      (B)
#define EX_LOCKED		      (C)
#define EX_PICKPROOF		      (F)
#define EX_NOPASS		      (G)
#define EX_EASY			      (H)
#define EX_HARD			      (I)
#define EX_INFURIATING		      (J)
#define EX_NOCLOSE		      (K)
#define EX_NOLOCK		      (L)
#define EX_NGBACK                     (M)



/*
 * Sector types.
 * Used in #ROOMS.
 */
#define SECT_INSIDE		      0
#define SECT_CITY		      1
#define SECT_FIELD		      2
#define SECT_FOREST		      3
#define SECT_HILLS		      4
#define SECT_MOUNTAIN		      5
#define SECT_WATER_SWIM		      6
#define SECT_WATER_NOSWIM	      7
#define SECT_UNUSED		      8
#define SECT_AIR		      9
#define SECT_DESERT		     10
#define SECT_UNDERWATER		     11
#define SECT_UNDERWATER_BOTTOM	     12	     
#define SECT_MAX		     13



/*
 * Equpiment wear locations.
 * Used in #RESETS.
 */
#define WEAR_NONE		     -1
#define WEAR_LIGHT		      0
#define WEAR_HEAD		      1
#define WEAR_HAIR		      2
#define WEAR_FACE		      3
#define WEAR_EARS		      4
#define WEAR_NECK_1		      5
#define WEAR_NECK_2		      6
#define WEAR_SHOULDER		      7
#define WEAR_ABOUT		      8
#define WEAR_BODY		      9
#define WEAR_LODGED_RIB		     10
#define WEAR_WAIST		     11
#define WEAR_ARMS		     12
#define WEAR_LODGED_ARM		     13
#define WEAR_WRIST_L		     14
#define WEAR_WRIST_R		     15
#define WEAR_HANDS		     16
#define WEAR_FINGER_L		     17
#define WEAR_FINGER_R		     18
#define WEAR_SHIELD		     19
#define WEAR_WIELD		     20
#define WEAR_SECONDARY		     21
#define WEAR_HOLD		     22
#define WEAR_LEGS		     23
#define WEAR_LODGED_LEG		     24
#define WEAR_FEET		     25
#define WEAR_FLOAT		     26
#define MAX_WEAR		     27



/*
 * Area flags.
 * Used in #OLCAREA.
 */
#define AREA_DIRTY		(A)	/* Used internally by mud.	*/
#define AREA_OPEN_SLATHER	(C)	/* Any creator can edit.	*/
#define AREA_VIRTUAL		(D)	/* Area is virtual.		*/
#define AREA_INVIS		(E)	/* Not shown in areas.		*/
#define AREA_ARENA		(F)	/* Area is an arena.		*/
#define AREA_EVERLOAD		(G)	/* Area should not idle out.    */
#define AREA_FREE		(H)	/* Area is out of memory.       */
#define AREA_QUIET		(I)	/* Area is idle 1 repop.        */
#define AREA_REVAMP		(J)	/* Area is to be revamped.      */

#define AREA_LAWLESS		(B)	/* Obsolete - area version 1.	*/


/*
 * Restriction and aggression flags.
 */
#define CHAR_CAST_MAGE		(A)
#define CHAR_CAST_CLERIC	(B)
#define CHAR_NON_CASTER		(C)
#define CHAR_SEMI_CASTER	(D)
#define CHAR_PURE_CASTER	(E)
#define CHAR_MALE		(F)
#define CHAR_FEMALE		(G)
#define CHAR_EUNICH		(H)
#define CHAR_GOOD		(I)
#define CHAR_NEUTRAL		(J)
#define CHAR_EVIL		(K)
#define CHAR_HUMAN		(L)
#define CHAR_ELF		(M)
#define CHAR_DWARF		(N)
#define CHAR_GIANT		(O)
#define CHAR_CENTAUR		(P)
#define CHAR_GNOME		(Q)
#define CHAR_ORC		(R)
#define CHAR_CAMBION		(S)
#define CHAR_DEMON		(T)
#define CHAR_NON_RULER		(U)
#define CHAR_NOBLE		(V)
#define CHAR_PEASANT		(W)
#define CHAR_LIZARD_MAN         (X)

#define AGG_EVERYONE		(cc)	/* Aggression flags only */
#define AGG_CHICKEN		(dd)
#define AGG_PSYCHO		(ee)

#define RESTRICT_HARMFUL	(cc)	/* Restriction only. */
#define RESTRICT_WASTING	(dd)
#define RESTRICT_CORRUPTING	(ee)


/*
 * Fit flags.
 */
#define FIT_NO_TINY		(A)	
#define FIT_NO_SMALL		(B)	
#define FIT_NO_MEDIUM		(C)
#define FIT_NO_LARGE		(D)
#define FIT_NO_HUGE		(E)
#define FIT_NO_GIANT		(F)

#define FIT_NO_HUMAN		(CHAR_HUMAN)
#define FIT_NO_ELF		(CHAR_ELF)
#define FIT_NO_DWARF		(CHAR_DWARF)
#define FIT_NO_GIANT_RACE	(CHAR_GIANT)
#define FIT_NO_CENTAUR		(CHAR_CENTAUR)
#define FIT_NO_GNOME		(CHAR_GNOME)
#define FIT_NO_ORC		(CHAR_ORC)
#define FIT_NO_CAMBION		(CHAR_CAMBION)
#define FIT_NO_LIZARD_MAN       (CHAR_NO_LIZARD_MAN)


/*
 * Trap types.
 */
#define TRAP_TYPE_ARROW			 0
#define TRAP_TYPE_POISONED_ARROW	 1
#define TRAP_TYPE_CEILING_BLOCK		 2
#define TRAP_TYPE_CHUTE			 3
#define TRAP_TYPE_GAS_BLINDING		 4
#define TRAP_TYPE_GAS_POISON		 5
#define TRAP_TYPE_GAS_SLEEP		 6
#define TRAP_TYPE_GAS_SLOW		 7
#define TRAP_TYPE_GAS_WEAKNESS		 8
#define TRAP_TYPE_LIGHTNING		 9
#define TRAP_TYPE_BLADE			10
#define TRAP_TYPE_TELEPORTER		11
#define TRAP_TYPE_VENT_ACID		12
#define TRAP_TYPE_VENT_FIRE		13
#define TRAP_TYPE_DART			14
#define TRAP_TYPE_POISON_DART		15
#define TRAP_TYPE_POISON_NEEDLE		16
#define TRAP_TYPE_SEX_CHANGE		17
#define TRAP_TYPE_PETRIFICATION		18


/*
 * Trap triggers.
 */
#define TRAP_OBJ			(A)	/* Traps an object. */
#define TRAP_ROOM			(B)	/* Traps a room.    */

#define TRAP_ENTER			(C)
#define TRAP_LEAVE			(D)
#define TRAP_OPEN			(E)
#define TRAP_CLOSE			(F)
#define TRAP_UNLOCK			(G)
#define TRAP_PICK			(H)
#define TRAP_GET			(I)
#define TRAP_PUT			(J)
#define TRAP_EXAMINE			(K)
#define TRAP_N				(L)
#define TRAP_S				(M)
#define TRAP_E				(N)
#define TRAP_W				(O)
#define TRAP_U				(P)
#define TRAP_D				(Q)
#define TRAP_NE				(R)
#define TRAP_SE				(S)
#define TRAP_SW				(T)
#define TRAP_NW				(U)
#define TRAP_CW				(V)
#define TRAP_CCW			(W)

#define TRAP_EASY			(aa)	/* Trap difficulty. */
#define TRAP_HARD			(bb)
#define TRAP_INFURIATING		(cc)
#define TRAP_IMPOSSIBLE			(dd)	/* Cannot be disarmed at all. */
#define TRAP_MAGICAL			(ee)	/* Can only be disarmed
						   by magic. */

/*
 * Poison types.
 */
#define POISON_NORMAL			0
#define POISON_WEAKNESS			1
#define POISON_NAUSEA			2
#define POISON_BLINDNESS		3
#define POISON_BLEEDING			4
#define POISON_PARALYSIS		5
#define POISON_HALLUCINATION		6
#define POISON_COMA			7
#define POISON_MADNESS			8
#define POISON_WITHER			9
#define POISON_DEATH			10

/*
 * Contingencies.
 */
#define CONTIN_ATTACKED			1
#define CONTIN_ROBBED			2
#define CONTIN_DROWNING                 3


/***************************************************************************
 *                                                                         *
 *                   VALUES OF INTEREST TO AREA BUILDERS                   *
 *                   (End of this section ... stop here)                   *
 *                                                                         *
 ***************************************************************************/

/*
 * Conditions.
 */
#define COND_DRUNK		      0
#define COND_FULL		      1
#define COND_THIRST		      2
#define COND_HUNGER		      3



/*
 * Positions.
 */
#define POS_DEAD		      0
#define POS_MORTAL		      1
#define POS_INCAP		      2
#define POS_STUNNED		      3
#define POS_SLEEPING		      4
#define POS_RESTING		      5
#define POS_SITTING		      6
#define POS_FIGHTING		      7
#define POS_STANDING		      8



/*
 * ACT bits for players.
 */
#define PLR_IS_NPC		(A)		/* Don't EVER set.	*/

#define PLR_JUSTICAR		(B)

/* RT auto flags */
#define PLR_AUTOASSIST		(C)
#define PLR_AUTOEXIT		(D)
#define PLR_AUTOLOOT		(E)
#define PLR_AUTOSAC             (F)
#define PLR_AUTOGOLD		(G)
#define PLR_AUTOSPLIT		(H)

/* media settings */
#define PLR_SOUNDS              (I)
#define PLR_MUSIC               (J)

/* action flags */
#define PLR_SINGING		(K)

/* security flags */
#define PLR_NODELETE            (L)

/* RT personal flags */
#define PLR_HOLYLIGHT		(N)
#define PLR_HOMEHIDE		(O)
#define PLR_CANLOOT		(P)
#define PLR_NOSUMMON		(Q)
#define PLR_NOFOLLOW		(R)
#define PLR_NOMERCY		(S)
#define PLR_NOCANCEL		(T)

/* penalty flags */
#define PLR_PERMIT		(U)
#define PLR_PRESERVE            (V)
#define PLR_LOG			(W)
#define PLR_DENY		(X)
#define PLR_FREEZE		(Y)
/*#define PLR_THIEF		(Z)*/
/*#define PLR_KILLER		(aa)*/

#define PLR_KILLED		(ee)		/* Don't ever set. */


/* RT comm flags -- may be used on both mobs and chars */
#define COMM_QUIET              (A)
#define COMM_DEAF            	(B)
#define COMM_NOWIZ              (C)
#define COMM_NOAUCTION          (D)
#define COMM_NOGOSSIP           (E)
#define COMM_NOQUESTION         (F)
#define COMM_NOMUSIC            (G)
#define COMM_NOCLAN		(H)
#define COMM_NOQUOTE		(I)
#define COMM_SHOUTSOFF		(J)
#define COMM_NOORATE		(K)

/* display flags */
#define COMM_COMPACT		(L)
#define COMM_BRIEF		(M)
#define COMM_PROMPT		(N)
#define COMM_COMBINE		(O)
#define COMM_TELNET_GA		(P)
#define COMM_SHOW_AFFECTS	(Q)
#define COMM_NOGRATS		(R)

/* penalties */
#define COMM_NOEMOTE		(T)
#define COMM_NOSHOUT		(U)
#define COMM_NOTELL		(V)
#define COMM_NOCHANNELS		(W) 
#define COMM_SNOOP_PROOF	(Y)
#define COMM_AFK		(Z)

/* additional channels */
#define COMM_NOIMP          	(aa)
#define COMM_NORELIGION     	(bb)
#define COMM_PRIORITY		(cc)
#define COMM_COLOR		(dd)
#define COMM_NOCRETALK		(ee)

/* WIZnet flags */
#define WIZ_ON			(A)
#define WIZ_TICKS		(B)
#define WIZ_LOGINS		(C)
#define WIZ_SITES		(D)
#define WIZ_LINKS		(E)
#define WIZ_DEATHS		(F)
#define WIZ_RESETS		(G)
#define WIZ_MOBDEATHS		(H)
#define WIZ_FLAGS		(I)
#define WIZ_PENALTIES		(J)
#define WIZ_SACCING		(K)
#define WIZ_LEVELS		(L)
#define WIZ_SECURE		(M)
#define WIZ_SWITCHES		(N)
#define WIZ_SNOOPS		(O)
#define WIZ_RESTORE		(P)
#define WIZ_LOAD		(Q)
#define WIZ_NEWBIE		(R)
#define WIZ_PREFIX		(S)
#define WIZ_SPAM		(T)
#define WIZ_MOBACTIONS		(U)

/* Territory flags */
#define TERR_CAPTAIN_GUARD      (A)
#define TERR_GUARD              (B)
#define TERR_TREASURER          (C)

/* Player advantages/disadvantages/ancestors */
#define MIN_ADVANTAGE                       1
#define ADVANTAGE_RENSHAIS_BLESSING         1
#define ADVANTAGE_BLAND                     2
#define ADVANTAGE_BLOOD_OF_MTAVIAR          3
#define ADVANTAGE_CLEAR_THINKER             4
#define ADVANTAGE_NATURAL_FIGHTER           5
#define ADVANTAGE_CRAFTY                    6
#define ADVANTAGE_DANGEROUS_BEAUTY          7
#define ADVANTAGE_EIDETIC_MEMORY            8
#define ADVANTAGE_MAGICAL_ATTUNEMENT        9
#define ADVANTAGE_TOUGH                    10
#define ADVANTAGE_HANDS_OF_STONE           11
#define ADVANTAGE_DANGER_SENSE             12
#define ADVANTAGE_ANIMAL_EMPATHY           13
#define ADVANTAGE_LARGE                    14
#define ADVANTAGE_LUCK                     15
#define ADVANTAGE_MEEK                     16
#define ADVANTAGE_QUICK_HEALER             17
#define ADVANTAGE_HIGH_PAIN_THRESHOLD      18
#define ADVANTAGE_STRONG_WILL              19
#define MAX_ADVANTAGE                     999

#define MIN_DISADVANTAGE                 1000
#define DISADVANTAGE_LIGHT_INTOLERANCE   1000
#define DISADVANTAGE_AGROPHOBIA          1001
#define DISADVANTAGE_CLAUSTROPHOBIA      1002
#define DISADVANTAGE_MELANCHOLIA         1003
#define DISADVANTAGE_ELDERLY             1004
#define DISADVANTAGE_INTROVERSION        1005
#define DISADVANTAGE_MANIA               1006
#define DISADVANTAGE_BAD_HEALTH          1007
#define DISADVANTAGE_BAD_EYESIGHT        1008
#define DISADVANTAGE_RENSHAIS_CURSE      1009
#define DISADVANTAGE_ALCOHOLIC           1010
#define DISADVANTAGE_WEAK_WILLED         1011
#define DISADVANTAGE_LAME                1012
#define DISADVANTAGE_LOW_PAIN_THRESHOLD  1013
#define DISADVANTAGE_OVERCONFIDENT       1014
#define DISADVANTAGE_PERMANENT_WOUND     1015
#define DISADVANTAGE_SCARED              1016
#define DISADVANTAGE_HIDEOUSLY_SCARED    1017
#define DISADVANTAGE_SMALL               1018
#define DISADVANTAGE_BAD_BACK            1019
#define DISADVANTAGE_MUTE                1020
#define DISADVANTAGE_KLUTZ               1021
#define DISADVANTAGE_EUNUCH              1022
#define MAX_DISADVANTAGE                 1999

#define MIN_ANCESTOR                     2000
#define ANCESTOR_YRNGRATH                2000
#define ANCESTOR_XYLLIAN                 2001
#define ANCESTOR_ANDARAS                 2002
#define ANCESTOR_BATON                   2003
#define ANCESTOR_LORANHIR                2004
#define ANCESTOR_ESLAINE                 2005
#define ANCESTOR_FIONAVAR                2006
#define ANCESTOR_SUMANDAR                2007
#define ANCESTOR_ONDOVAL                 2008
#define ANCESTOR_AILAS                   2009
#define ANCESTOR_DMOON                   2010
#define ANCESTOR_RYNA                    2011
#define MAX_ANCESTOR                     2999


struct  cust_data
{
    int                 type;
    int                 index;
    CUST_DATA *         next;
    AFFECT_DATA         affect;
};

struct advantage_type
{
    char *              name;
    int                 points;
    int                 value;
    sh_int              where;
    int                 restrictions;
    int                 bitvector;
    char *              procName;
    int                 flags;
};


/*
 * Prototype for a mob.
 * This is the in-memory version of #MOBILES.
 */
struct	mob_index_data
{
    MOB_INDEX_DATA *	next;
    SPEC_FUN *		spec_fun;
    SHOP_DATA *		pShop;
    MPROG_LIST *        mprogs;
    CHAR_DATA *		instances;
    AREA_DATA *		area;
    sh_int		vnum;
    sh_int		group;
    bool		new_format;
    sh_int		count;
    sh_int		killed;
    char *		player_name;
    char *		short_descr;
    char *		long_descr;
    char *		description;
    long		act;
    long		affected_by;
    long		affected_by2;
    long		aggression;
    sh_int		alignment;
    sh_int		level;
    sh_int		hitroll;
    sh_int		hit[3];
    sh_int		mana[3];
    sh_int		damage[3];
    sh_int		ac[4];
    sh_int 		dam_type;
    long		off_flags;
    long		imm_flags;
    long		res_flags;
    long		vuln_flags;
    sh_int		start_pos;
    sh_int		default_pos;
    sh_int		sex;
    sh_int		race;
    long		wealth;
    long		form;
    long		parts;
    sh_int		size;
    char *		material;
    long		mprog_flags;
};


/* memory settings */
#define MEM_CUSTOMER		A	
#define MEM_SELLER		B
#define MEM_HOSTILE		C
#define MEM_AFRAID		D
#define MEM_SUMMONED_PC		E
#define MEM_SUMMONED_NPC	F

/* memory for mobs */
struct mem_data
{
    MEM_DATA 	*next;
    bool	valid;
    int		id; 	
    int 	reaction;
    int 	duration;
};


/*
 * One character (PC or NPC).
 */
struct	char_data
{
    CHAR_DATA *		next;
    CHAR_DATA *		next_in_room;
    CHAR_DATA *		master;
    CHAR_DATA *		leader;
    CHAR_DATA *		fighting;
    CHAR_DATA *		reply;
    CHAR_DATA *		pet;
    CHAR_DATA *		next_instance;
    CHAR_DATA *		riding;
    CHAR_DATA *		mounted_by;
    CHAR_DATA *		mprog_target;
    MEM_DATA *		memory;
    SPEC_FUN *		spec_fun;
    MOB_INDEX_DATA *	pIndexData;
    DESCRIPTOR_DATA *	desc;
    AFFECT_DATA *	affected;
    NOTE_DATA *		pnote;
    OBJ_DATA *		carrying;
    OBJ_DATA *		on;
    ROOM_INDEX_DATA *	in_room;
    ROOM_INDEX_DATA *	was_in_room;
    AREA_DATA *		zone;
    PC_DATA *		pcdata;
    GEN_DATA *		gen_data;
    MOB_INDEX_DATA *    polymorphed;
    bool		valid;
    char *		name;
    long		id;
    sh_int		version;
    char *		short_descr;
    char *		long_descr;
    char *		description;
    char *		prompt;
    char *		prefix;
    sh_int		group;
    sh_int		clan;
    sh_int		sex;
    sh_int		class;
    sh_int		race;
    sh_int		level;
    sh_int		trust;
    sh_int		hometown;
    sh_int              homevnum;
    int			played;
    int			lines;  /* for the pager */
    time_t		logon;
    sh_int		timer;
    sh_int		wait;
    sh_int		daze;
    sh_int		hit;
    sh_int		max_hit;
    sh_int		mana;
    sh_int		max_mana;
    sh_int		move;
    sh_int		max_move;
    long		gold;
    long		silver;
    int			exp;
    long		act;
    long		comm;   /* RT added to pad the vector */
    long		wiznet; /* wiz stuff */
    long		imm_flags;
    long		res_flags;
    long		vuln_flags;
    sh_int		invis_level;
    sh_int		incog_level;
    long		affected_by;
    long		affected_by2;
    sh_int		position;
    sh_int		practice;
    sh_int		train;
    sh_int		carry_weight;
    sh_int		carry_number;
    sh_int		armor_weight;
    sh_int		saving_throw;
    sh_int		alignment;
    sh_int		hitroll;
    sh_int		damroll;
    sh_int		armor[4];
    sh_int		wimpy;
    /* stats */
    sh_int		perm_stat[MAX_STATS];
    sh_int		mod_stat[MAX_STATS];
    /* parts stuff */
    long		form;
    long		parts;
    sh_int		size;
    char*		material;
    /* mobile stuff */
    long		off_flags;
    sh_int		damage[3];
    sh_int		dam_type;
    sh_int		start_pos;
    sh_int		default_pos;
    sh_int		mprog_delay;
    /* appearance stuff */
    char *		appearance;
    int			priority;
};



/*
 * Data which only PC's have.
 */
struct	pc_data
{
    PC_DATA *		next;
    BUFFER *		buffer;
    bool		valid;
    char *		pwd;
    char *		bamfin;
    char *		bamfout;
    char *		title;
    time_t		last_note;
    time_t		last_idea;
    time_t		last_penalty;
    time_t		last_news;
    time_t		last_changes;
    time_t		last_bug;
    sh_int		perm_hit;
    sh_int		perm_mana;
    sh_int		perm_move;
    sh_int		true_sex;
    int			last_level;
    sh_int		condition	[4];
    sh_int		learned		[MAX_SKILL];
    sh_int              skill_mods      [MAX_SKILL];
    bool		group_known	[MAX_GROUP];
    bool		styles		[MAX_STYLES];
    sh_int		points;
    bool		confirm_delete;
    char *		alias[MAX_ALIAS];
    char *		alias_sub[MAX_ALIAS];

    char *		transin;
    char *		transout;
    char *		transvict;
    long		balance;	/* Bank balance in silver */
    long		style;
    char *		colors[MAX_COLOR];
    char *		who_name;
    char *		appearance;
    sh_int		leader;
    sh_int		petition;
    sh_int		olc_level;
    sh_int		former_professions[MAX_PROFESSIONS - 1];
    sh_int		true_level;
    sh_int 		religion;
    sh_int 		heresy;
    sh_int		renown;
    sh_int		social_classes  [MAX_TERRITORIES];
    long                territory_flags [MAX_TERRITORIES];
    CRIME_DATA *	crimes          [MAX_TERRITORIES];
    bool		meta_purchases;
    long                fight_records   [MAX_PC_FIGHT_RECORD];
    CUST_DATA *         customizations;
};

/* Data for generating characters -- only used during generation */
struct gen_data
{
    GEN_DATA	*next;
    bool	valid;
    bool	skill_chosen[MAX_SKILL];
    bool	group_chosen[MAX_GROUP];
    bool	style_chosen[MAX_STYLES];
    int		points_chosen;
};

/* Heresy levels. */
#define HERESY_NOCHANNEL	1 
#define HERESY_NOSAC		2
#define HERESY_NOHEALING	3
#define HERESY_NORECALL		4
#define HERESY_CURSED		5



/*
 * Liquids.
 */
#define LIQ_WATER        0

struct	liq_type
{
    char *	liq_name;
    char *	liq_color;
    sh_int	liq_affect[5];
};

/*
 * Hometowns.
 */

struct hometown_type
{
    char *	ht_name;
    sh_int	ht_loadroom;
    bool	ht_avail;
    int		ht_restrict[21];
};


/*
 * Extra description data for a room or object.
 */
struct	extra_descr_data
{
    EXTRA_DESCR_DATA *next;	/* Next in list                     */
    bool valid;
    char *keyword;              /* Keyword in look/examine          */
    char *description;          /* What to see                      */
};


/*
 * Object use messages.
 */
#define USE_WEAR_LOC			0
#define USE_WEAR_SELF			1
#define USE_WEAR_ROOM			2
#define USE_REMOVE_SELF			3
#define USE_REMOVE_ROOM			4
#define USE_ZAP_SELF			5
#define USE_ZAP_VICT			6
#define USE_ZAP_ROOM			7
#define USE_ZAP_OBJ_SELF		8
#define USE_ZAP_OBJ_ROOM		9
#define USE_BRANDISH_SELF	       10
#define USE_BRANDISH_ROOM	       11
#define USE_CONTAIN_OPEN_SELF	       12
#define USE_CONTAIN_OPEN_ROOM	       13
#define USE_CONTAIN_CLOSE_SELF	       14
#define USE_CONTAIN_CLOSE_ROOM	       15
#define USE_CONTAIN_LOCK_SELF	       16
#define USE_CONTAIN_LOCK_ROOM	       17
#define USE_CONTAIN_UNLOCK_SELF	       18
#define USE_CONTAIN_UNLOCK_ROOM	       19
#define USE_FURN_SLEEP_SELF	       20
#define USE_FURN_SLEEP_ROOM	       21
#define USE_FURN_REST_SELF	       22
#define USE_FURN_REST_ROOM	       23
#define USE_FURN_SIT_SELF	       24
#define USE_FURN_SIT_ROOM	       25
#define USE_FURN_STAND_SELF	       26
#define USE_FURN_STAND_ROOM	       27


struct  use_msg_data
{
    USE_MSG_DATA *	next;
    char *		msg;
    sh_int		tag;
    bool		valid;
};

struct	use_msg_type
{
    char *		type;
    int			tag;
    sh_int		item_type;
};


/*
 * Prototype for an object.
 */
struct	obj_index_data
{
    OBJ_INDEX_DATA *            next;
    OBJ_DATA *                  instances;
    EXTRA_DESCR_DATA *          extra_descr;
    AFFECT_DATA *               affected;
    AREA_DATA *                 area;
    MPROG_LIST *	        mprogs;
    USE_MSG_DATA *              use_msgs;
    bool                        new_format;
    char *                      name;
    char *                      short_descr;
    char *                      description;
    sh_int                      vnum;
    sh_int                      reset_num;
    char *                      material;
    sh_int                      item_type;
    int                         extra_flags;
    int                         wear_flags;
    int                         restrictions;
    int                         fit_flags;
    sh_int                      level;
    sh_int                      condition;
    sh_int                      count;
    sh_int                      weight;
    int                         cost;
    int                         value[5];

/*    
 *  char *		wear_loc;
 *  char *		wear_self;
 *  char *		wear_room;
 *  char *		remove_self;
 *  char *		remove_room;
 */    
    long                        mprog_flags;
};



/*
 * One object.
 */
struct	obj_data
{
    OBJ_DATA *	    	next;
    OBJ_DATA *	    	next_content;
    OBJ_DATA *	    	contains;
    OBJ_DATA *	    	in_obj;
    OBJ_DATA *	    	on;
    OBJ_DATA *	    	next_instance;
    CHAR_DATA *         carried_by;
    EXTRA_DESCR_DATA *	extra_descr;
    AFFECT_DATA *       affected;
    OBJ_INDEX_DATA *	pIndexData;
    ROOM_INDEX_DATA *	in_room;
    bool	        valid;
    bool	        enchanted;
    char *	        owner;
    char *		name;
    char *		short_descr;
    char *		description;
    sh_int		item_type;
    int			extra_flags;
    int			wear_flags;
    sh_int		wear_loc;
    sh_int		weight;
    int			cost;
    sh_int		level;
    sh_int 		condition;
    char *		material;
    sh_int		timer;
    int	  		value[5];
};



/*
 * Exit data.
 */
struct	exit_data
{
    union
    {
	ROOM_INDEX_DATA *	to_room;
	sh_int			vnum;
    } u1;
    sh_int		exit_info;
    sh_int		key;
    char *		keyword;
    char *		description;
};



/*
 * Reset commands:
 *   '*': comment
 *   'M': read a mobile 
 *   'O': read an object
 *   'P': put object in object
 *   'G': give object to mobile
 *   'E': equip object to mobile
 *   'D': set state of door
 *   'R': randomize room exits
 *   'T': trap
 *   'S': stop (end of list)
 */

/*
 * Area-reset definition.
 */
struct	reset_data
{
    RESET_DATA *	next;
    char		command;
    sh_int		arg1;
    sh_int		arg2;
    sh_int		arg3;
    sh_int		arg4;
    sh_int		arg5;

    bool		valid;
};



/*
 * Area definition.
 */
struct	area_data
{
    AREA_DATA *		next;
    RESET_DATA *	reset_first;
    RESET_DATA *	reset_last;
    char *		file_name;
    char *		name;
    char *		credits;
    sh_int		age;
    sh_int		nplayer;
    sh_int		low_range;
    sh_int		high_range;
    sh_int 		min_vnum;
    sh_int		max_vnum;
    sh_int		territory;
    bool		empty;
    
    char *		creator;
    int			flags;
    sh_int		version;
    char *              sound_track;
};



/*
 * Room type.
 */
struct	room_index_data
{
    ROOM_INDEX_DATA *	next;
    CHAR_DATA *		people;
    OBJ_DATA *		contents;
    EXTRA_DESCR_DATA *	extra_descr;
    AREA_DATA *		area;
    EXIT_DATA *		exit	[12];
    EXIT_DATA * 	old_exit[12];
    MPROG_LIST *	mprogs;
    char *		name;
    char *		description;
    char *		owner;
    long		mprog_flags;
    int			room_flags;
    int			bfs_tag;
    sh_int		vnum;
    sh_int		light;
    sh_int		sector_type;
    sh_int		heal_rate;
    sh_int 		mana_rate;
    sh_int		clan;
};


/*
 * Node in an area BFS.
 */
struct bfs_queue_data {
  ROOM_INDEX_DATA *	room;
  sh_int 		dir;
  sh_int		depth;
  
  bool			valid;
  BFS_QUEUE_DATA  *	next;
};


/*
 * Territory stuff.
 */
#define CRIME_PKILLING			(A)
#define CRIME_PSTEALING			(B)
#define TERRITORY_JUSTICAR_ALIGNED	(ee)

struct social_titles {
    char *			male;
    char *			female;
};

struct territory_data {
    char *                      name;
    struct social_titles        social_classes[MAX_SOCIAL_CLASS];
    long                        crimes;
    sh_int                      jail;
};

struct crime_data {
    long			crime;
    char *			victim;

    CRIME_DATA *		next;
    bool			valid;
};


/*
 * Types of attacks.
 * Must be non-overlapping with spell/skill types,
 * but may be arbitrary beyond that.
 */
#define TYPE_UNDEFINED               -1
#define TYPE_HIT                     1000



/*
 *  Target types.
 */
#define TAR_IGNORE          0
#define TAR_CHAR_OFFENSIVE  1
#define TAR_CHAR_DEFENSIVE  2
#define TAR_CHAR_SELF       3
#define TAR_OBJ_INV         4
#define TAR_OBJ_CHAR_DEF    5
#define TAR_OBJ_CHAR_OFF    6

#define TARGET_CHAR		    0
#define TARGET_OBJ		    1
#define TARGET_ROOM		    2
#define TARGET_NONE		    3



/* 
 * Skill/spell classes.
 */
#define SCLASS_NONE             -1
#define SCLASS_WEAPON           0
#define SCLASS_COMBAT           1
#define SCLASS_HEALING_SKILLS   2
#define SCLASS_MAGICAL          3
#define SCLASS_SUBTERFUGE       4
#define SCLASS_SOCIAL           5
#define SCLASS_OUTDOORS         6
#define SCLASS_MISC_SKILL       7
#define SCLASS_CHANNELING       8
#define SCLASS_BEGUILING        9
#define SCLASS_BENEDICTION      10
#define SCLASS_ELEMENTAL        11
#define SCLASS_CREATION         12
#define SCLASS_HEALING          13
#define SCLASS_DETECTION        14
#define SCLASS_ENCHANTMENT      15
#define SCLASS_ENHANCEMENT      16
#define SCLASS_ILLUSION         17
#define SCLASS_MALEDICTION      18
#define SCLASS_PROTECTIVE       19
#define SCLASS_TRANSPORT        20
#define SCLASS_WEATHER          21
#define SCLASS_DEMONIC          22
#define SCLASS_ANIMAL           23
#define SCLASS_EARTH            24
#define SCLASS_SPIRIT           25
#define SCLASS_NECROMANCY	26

#define MAX_SKILL_CLASS         (SCLASS_NECROMANCY + 1)


/*
 * Spell sub-classes.
 */
#define SSCLASS_HOLY		(A)
#define SSCLASS_UNHOLY		(B)

#define SSCLASS_FIRE		(A)
#define SSCLASS_COLD		(B)
#define SSCLASS_LIGHTNING	(C)
#define SSCLASS_ACID		(D)
#define SSCLASS_POISON		(E)
#define SSCLASS_ENERGY		(F)
#define SSCLASS_MENTAL		(G)
#define SSCLASS_DISEASE		(H)
#define SSCLASS_DROWNING	(I)
#define SSCLASS_LIGHT		(J)
#define SSCLASS_NEGATIVE	(K)

#define SSCLASS_DISHONORABLE    (A)

#define SSCLASS_GTR_HEALS	(A)


/*
 * Skills include spells as a particular case.
 */
struct	skill_type
{
    char *	name;                   /* Name of skill */
    sh_int	skill_level[MAX_CLASS]; /* Level needed by class */
    sh_int	rating[MAX_CLASS];      /* How hard it is to learn */
    SPELL_FUN *	spell_fun;              /* Spell pointer (for spells) */
    sh_int	target;                 /* Legal targets */
    sh_int	minimum_position;       /* Position for caster/user */
    sh_int *	pgsn;                   /* Pointer to associated gsn */
    sh_int	slot;                   /* Slot for #OBJECT loading */
    sh_int	min_mana;               /* Minimum mana used */
    sh_int	beats;                  /* Waiting time after use */
    char *	noun_damage;            /* Damage message */
    char *	msg_off;                /* Wear off message */
    char *	msg_obj;                /* Wear off message for objects */

    sh_int	sclass;                 /* Skill class. */
    int		sub_class;              /* Skill sub-class. */

    long	required_form;          /* Any required form bits. */
    long	disallowed_form;        /* Any form bits that prevent use. */
    long	required_parts;         /* Any required parts bits. */
    long	disallowed_parts;       /* Any parts buts that 
                                           prevent use. */
    bool	gainable;
    bool	bard_song;              /* As per spells, but needs
                                           to be sung rather than 
                                           cast. */
    char *      hometowns;              /* NULL is any, otherwise a list. */
    char *      unhometowns;            /* a hometown here means spell can't
                                           be learned by mages from there. */
};

struct  group_type
{
    char *	name;
    sh_int	rating[MAX_CLASS];
    char *	spells[MAX_IN_GROUP];

    sh_int	sclass;
    
    bool        gainable;
    char *      hometowns;
    char *      unhometowns;
};

	
#define SPEC_STYLE		(A)
#define SPEC_MAGICAL		(B)
#define SPEC_NO_REMORT		(C)

#define STYLE_TWO_HANDED	(A)
#define STYLE_DUAL_OFFENSIVE	(B)
#define STYLE_DUAL_RIPOSTE	(C)
#define STYLE_WINDMILL		(D)
#define STYLE_VIPER		(E)
#define STYLE_FAN		(F)
#define STYLE_STONE_CLAW	(G)
#define STYLE_RAINBOW		(H)
#define STYLE_VERTIGO		(I)


struct	style_type
{
    char *	name;
    sh_int	rating[MAX_CLASS];
    int		specialization;
    sh_int *	pgsn;
    char *	prereq;
};

/*
 *  Skill modification (god based).
 */
struct  skill_modifier
{
    int         unavail_subs;           /* Unavailable sub-classes.     */
    sh_int      level_mod;              /* % casting level modification */
};


struct  skill_modification
{
    bool	unavailable;

    struct skill_modifier       caster;
    struct skill_modifier       non_caster;
};


/*
 * God type.
 */
#define ALIGN_GOOD      A
#define ALIGN_NEUTRAL   B
#define ALIGN_EVIL      C
#define ALIGN_ANY       (ALIGN_GOOD|ALIGN_NEUTRAL|ALIGN_EVIL)

#define GOD_WINTER		A
#define GOD_SPRING		B
#define GOD_SUMMER		C
#define GOD_FALL		D

struct	religion_type
{
    char *			name;
    char *                      head;
    bool			player_god;
    int				align_limits;
    int				recall_vnum;
    int				symbol_vnum;
    int				orb_vnum;
    int				brand_vnum;
    int				flags;

    bool			classes[ MAX_CLASS ];
    sh_int			champions[MAX_PROFESSIONS - 1][MAX_PROFESSION_OPTION];
    
    char *			recall_self;
    char *			recall_room;
    char *			recall_appear_self;
    char *			recall_appear_room;
    char *			sac_self;
    char *			sac_room;
    
    struct skill_modification	skill_modifications[ MAX_SKILL_CLASS ];
};


/*
 * MOBprog definitions
 */                   
#define TRIG_ACT		(A)
#define TRIG_BRIBE		(B)
#define TRIG_DEATH		(C)
#define TRIG_ENTRY		(D)
#define TRIG_FIGHT		(E)
#define TRIG_GIVE		(F)
#define TRIG_GREET		(G)
#define TRIG_GRALL		(H)
#define TRIG_KILL		(I)
#define TRIG_HPCNT		(J)
#define TRIG_RANDOM		(K)
#define TRIG_SPEECH		(L)
#define TRIG_EXIT		(M)
#define TRIG_EXALL		(N)
#define TRIG_DELAY		(O)
#define TRIG_SURR		(P)

#define OTRIG_ACT		(A)
#define OTRIG_RANDOM		(B)
#define OTRIG_GREET		(C)
#define OTRIG_GRALL		(D)
#define OTRIG_WEAR		(E)
#define OTRIG_REMOVE		(F)
#define OTRIG_SAC		(G)
#define OTRIG_LOOK		(H)
#define OTRIG_EXAMINE		(I)
#define OTRIG_USE		(J)
#define OTRIG_GET		(K)
#define OTRIG_PUT		(L)
#define OTRIG_DROP		(M)
#define OTRIG_SPEECH		(N)
#define OTRIG_GET_CONTENT	(O)
#define OTRIG_PUT_CONTENT	(P)
#define OTRIG_STEAL		(Q)
#define OTRIG_OPEN		(R)
#define OTRIG_CLOSE		(S)

#define RTRIG_ACT		(A)
#define RTRIG_RANDOM		(B)
#define RTRIG_GREET		(C)
#define RTRIG_GRALL		(D)
#define RTRIG_SPEECH		(E)
#define RTRIG_EXALL		(F)

struct mprog_list
{
    int			trig_type;
    char *		trig_phrase;
    sh_int		vnum;
    MPROG_CODE *	code;
    MPROG_LIST *	next;
    bool		valid;
};

struct mprog_code
{
    sh_int		vnum;
    char *		code;
    MPROG_CODE *	next;
};


/*
 * These are skill_lookup return values for common skills and spells.
 */
extern	sh_int	max_player_skill;

extern	sh_int	gsn_backstab;
extern	sh_int	gsn_dodge;
extern	sh_int	gsn_envenom;
extern	sh_int	gsn_hide;
extern	sh_int	gsn_peek;
extern	sh_int	gsn_pick_lock;
extern	sh_int	gsn_sneak;
extern	sh_int	gsn_steal;

extern	sh_int	gsn_disarm;
extern	sh_int	gsn_enhanced_damage;
extern	sh_int	gsn_kick;
extern	sh_int	gsn_parry;
extern	sh_int	gsn_rescue;
extern	sh_int	gsn_arms_mastery;
extern	sh_int	gsn_weapon_brawling;

extern	sh_int	gsn_blindness;
extern	sh_int	gsn_charm_person;
extern	sh_int	gsn_curse;
extern	sh_int	gsn_invis;
extern	sh_int	gsn_mass_invis;
extern	sh_int	gsn_plague;
extern	sh_int	gsn_poison;
extern	sh_int	gsn_sleep;
extern	sh_int	gsn_fly;
extern	sh_int	gsn_sanctuary;

/* new gsns */
extern	sh_int	gsn_axe;
extern	sh_int	gsn_bow;
extern	sh_int	gsn_dagger;
extern	sh_int	gsn_flail;
extern	sh_int	gsn_mace;
extern	sh_int	gsn_polearm;
extern	sh_int	gsn_shield_block;
extern	sh_int	gsn_spear;
extern	sh_int	gsn_sword;
extern	sh_int	gsn_whip;
 
extern	sh_int	gsn_bash;
extern	sh_int	gsn_berserk;
extern	sh_int	gsn_dirt;
extern	sh_int	gsn_hand_to_hand;
extern	sh_int	gsn_trip;
extern	sh_int	gsn_fast_healing;
extern	sh_int	gsn_haggle;
extern	sh_int	gsn_lore;
extern	sh_int	gsn_meditation;
 
extern	sh_int	gsn_scrolls;
extern	sh_int	gsn_staves;
extern	sh_int	gsn_wands;
extern	sh_int	gsn_recall;

extern	sh_int	gsn_track;
extern	sh_int	gsn_scan;
extern	sh_int	gsn_consider;
extern	sh_int	gsn_tail;
extern	sh_int	gsn_dual_wield;
extern	sh_int	gsn_ki_punch;
extern	sh_int	gsn_ki_shout;
extern	sh_int	gsn_eagles_claw;
extern	sh_int	gsn_armor;
extern	sh_int	gsn_bless;
extern	sh_int	gsn_petrification;
extern	sh_int	gsn_ride;
extern	sh_int	gsn_joust;
extern	sh_int	gsn_trample;
extern	sh_int	gsn_aging;
extern	sh_int	gsn_cadaverous_appearance;
extern	sh_int	gsn_light_intolerance;
extern	sh_int	gsn_agrophobia;
extern	sh_int	gsn_catatonia;
extern	sh_int	gsn_claustrophobia;
extern	sh_int	gsn_melancholia;
extern	sh_int	gsn_dipsomania;
extern	sh_int	gsn_introversion;
extern	sh_int	gsn_mania;
extern	sh_int	gsn_befriend;
extern	sh_int	gsn_petrify;
extern	sh_int	gsn_unmount;
extern	sh_int	gsn_shadow;
extern	sh_int	gsn_starvation;
extern	sh_int	gsn_detrap;
extern	sh_int	gsn_escape;
extern	sh_int	gsn_chain_lightning;
extern	sh_int	gsn_smoke_parasite;
extern	sh_int	gsn_spell_steal;
extern	sh_int	gsn_reflection;
extern	sh_int	gsn_blind_fighting;
extern	sh_int	gsn_sap;
extern	sh_int	gsn_bright_moonkiss_touch;
extern	sh_int	gsn_the_voice_of_nations_calling;
extern	sh_int	gsn_the_dragon_flight_thunder;
extern	sh_int	gsn_come_clarion_rage;
extern	sh_int	gsn_ere_faerie_glamour;
extern  sh_int  gsn_music;
extern  sh_int  gsn_mirror_image;
extern	sh_int	gsn_improved_invis;
extern	sh_int	gsn_death_trance;
extern	sh_int	gsn_alkar;
extern	sh_int	gsn_sing;

extern	sh_int	gsn_pummeling;
extern	sh_int	gsn_single_weapon_combat;
extern	sh_int	gsn_two_handed_combat;
extern	sh_int	gsn_weapon_and_shield_combat;
extern	sh_int	gsn_two_weapon_combat;
extern  sh_int  gsn_windmill;
extern  sh_int  gsn_viper;
extern  sh_int  gsn_fan;
extern  sh_int  gsn_stone_claw;
extern  sh_int  gsn_rainbow;
extern  sh_int  gsn_vertigo;

extern	sh_int	gsn_fix_soul;
extern	sh_int	gsn_mark_tree;
extern	sh_int	gsn_circle;
extern	sh_int	gsn_forage;
extern  sh_int  gsn_bite;
extern  sh_int  gsn_slow;
extern  sh_int  gsn_corpse_form;
extern  sh_int  gsn_fire_track;
extern  sh_int  gsn_contingency;
extern  sh_int  gsn_backlash;
extern  sh_int  gsn_weapon_curse;
extern  sh_int  gsn_dispel_magic;


/*
 * Attack lookups for common attacks.
 */
extern  sh_int  gdt_punch;
extern	sh_int	gdt_smash;


/*
 * Utility macros.
 */
#define NUM(s)			(sizeof(s) / sizeof(s[0]) )
#define IS_VALID(data)		((data) != NULL && (data)->valid)
#define VALIDATE(data)		((data)->valid = TRUE)
#define INVALIDATE(data)	((data)->valid = FALSE)
#define UMIN(a, b)		((a) < (b) ? (a) : (b))
#define UMAX(a, b)		((a) > (b) ? (a) : (b))
#define URANGE(a, b, c)		((b) < (a) ? (a) : ((b) > (c) ? (c) : (b)))
#define LOWER(c)		((c) >= 'A' && (c) <= 'Z' ? (c)+'a'-'A' : (c))
#define UPPER(c)		((c) >= 'a' && (c) <= 'z' ? (c)+'A'-'a' : (c))
#define DIFF(a, b)		((a > b) ? (a - b) : (b - a))
#define IS_SET(flag, bit)	((flag) & (bit))
#define SET_BIT(var, bit)	((var) |= (bit))
#define REMOVE_BIT(var, bit)	((var) &= ~(bit))
#define IS_NULLSTR(str)		((str)==NULL || (str)[0]=='\0') 
#define HAS_TRIGGER(data,trig)	(IS_SET((data)->pIndexData->mprog_flags, (trig)))
#define ROOM_HAS_TRIGGER(data,trig) \
				(IS_SET((data)->mprog_flags, (trig)))

/*
 * Character macros.
 */
#define IS_NPC(ch)		(IS_SET((ch)->act, ACT_IS_NPC))
#define IS_IMMORTAL(ch)		(get_trust(ch) >= LEVEL_IMMORTAL)
#define IS_HERO(ch)		(get_trust(ch) >= LEVEL_HERO)
#define IS_TRUSTED(ch,level)	(get_trust((ch)) >= (level))
#define IS_AFFECTED(ch, sn)	(IS_SET((ch)->affected_by, (sn)))
#define IS_AFFECTED2(ch, sn)	(IS_SET((ch)->affected_by2, (sn)))
#define GET_AGE(ch)		((int) (17 + ((ch)->played \
				 + current_time - (ch)->logon )/72000))
#define IS_GOOD(ch)		(ch->alignment >= 350)
#define IS_EVIL(ch)		(ch->alignment <= -350)
#define IS_NEUTRAL(ch)		(!IS_GOOD(ch) && !IS_EVIL(ch))
#define IS_AWAKE(ch)		(ch->position > POS_SLEEPING)
#define GET_HITROLL(ch)	\
		((ch)->hitroll+str_app[get_curr_stat(ch,STAT_STR)/4].tohit+(6*str_app[get_curr_stat(ch,STAT_DEX)/4].tohit/10)+(3*str_app[get_curr_stat(ch,STAT_PER)/4].tohit/10))
#define GET_HITROLL_MOB(ch) \
		((ch)->hitroll+str_app[get_curr_stat(ch,STAT_STR)/4].tohit_mob+(6*str_app[get_curr_stat(ch,STAT_DEX)/4].tohit_mob/10)+(3*str_app[get_curr_stat(ch,STAT_PER)/4].tohit_mob/10))
#define GET_DAMROLL(ch) \
		((ch)->damroll+(str_app[get_curr_stat(ch,STAT_STR)/4].todam))
#define GET_DAMROLL_MOB(ch) \
                ((ch)->damroll+(str_app[get_curr_stat(ch,STAT_STR)/4].todam_mob))
#define IS_OUTSIDE(ch)		(!((ch)->in_room->room_flags & ROOM_INDOORS))
#define GET_GOD(ch)		(IS_NPC(ch)?0:(ch)->pcdata->religion)
#define WAIT_STATE(ch, npulse)	((ch)->wait = UMAX((ch)->wait, (npulse)))
#define DAZE_STATE(ch, npulse)  daze_state(ch, npulse);
                                //((ch)->daze = UMAX((ch)->daze, (npulse)))
#define get_carry_weight(ch)	((ch)->carry_weight + (ch)->silver/10 +  \
						      (ch)->gold * 2 / 5)
#define CH(d)			((d)->original 				\
				? (d)->original 			\
				: (d)->character )
#define CHAR_KILLED(ch)		(!IS_VALID((ch))			\
				 || (!IS_NPC(ch)			\
				 && IS_SET(ch->act, PLR_KILLED)))
#define UNDERWATER(ch)		(ch->in_room != NULL			\
				 && (ch->in_room->sector_type ==	\
				     SECT_UNDERWATER			\
				 ||  ch->in_room->sector_type ==	\
				     SECT_UNDERWATER_BOTTOM))
#define CAN_BLEED(ch)           (!IS_SET(CHAR_FORM(ch), FORM_UNDEAD) &&    \
                                 !IS_SET(CHAR_FORM(ch), FORM_CONSTRUCT) && \
                                 !IS_SET(CHAR_FORM(ch), FORM_MIST) &&      \
                                 !IS_SET(CHAR_FORM(ch), FORM_INTANGIBLE))
#define BLEEDS_ICHOR(ch)        (IS_SET(CHAR_FORM(ch), FORM_INSECT) ||     \
                                 IS_SET(CHAR_FORM(ch), FORM_SPIDER))
#define COMPLEX_STYLE(ch, s)    (IS_NPC(ch)                             \
                                 ? FALSE                                \
                                 : (IS_SET(ch->pcdata->style, s)))
#define CHAR_NAME(ch)           ((ch)->polymorphed ? (ch)->polymorphed->player_name : (ch)->name)
#define CHAR_SHORT(ch)          ((ch)->polymorphed ? (ch)->polymorphed->short_descr : (ch)->short_descr)
#define CHAR_DESCRIPTION(ch)    ((ch)->polymorphed ? (ch)->polymorphed->description : (ch)->description )
#define CHAR_SIZE(ch)           ((ch)->polymorphed ? (ch)->polymorphed->size : (ch)->size)
#define CHAR_RACE(ch)           ((ch)->polymorphed ? (ch)->polymorphed->race : (ch)->race)
#define CHAR_PARTS(ch)          ((ch)->polymorphed ? (ch)->polymorphed->parts : (ch)->parts)
#define CHAR_FORM(ch)           ((ch)->polymorphed ? (ch)->polymorphed->form : (ch)->form)
#define CHAR_IMM(ch)            ((ch)->polymorphed ? (ch)->polymorphed->imm_flags : (ch)->imm_flags )
#define CHAR_RES(ch)            ((ch)->polymorphed ? (ch)->polymorphed->res_flags : (ch)->res_flags )
#define CHAR_VULN(ch)           ((ch)->polymorphed ? (ch)->polymorphed->vuln_flags : (ch)->vuln_flags )
#define CHAR_DAM_TYPE(ch)       ((ch)->polymorphed ? (ch)->polymorphed->dam_type : (ch)->dam_type)
#define CHAR_PERM_STAT(ch,stat) ((ch)->polymorphed ? get_mob_stat(stat, (ch)->level, (ch)->polymorphed) : (ch)->perm_stat[stat])

/*
 * Immune/... set/remove macros to avoid weakness in the NT compiler.
 */
#define CHAR_SET_IMM(ch, bits)  ((ch)->polymorphed ? ((ch)->polymorphed->imm_flags |= (bits)) : ((ch)->imm_flags |= (bits)))
#define CHAR_SET_RES(ch, bits)  ((ch)->polymorphed ? ((ch)->polymorphed->res_flags |= (bits)) : ((ch)->res_flags |= (bits)))
#define CHAR_SET_VULN(ch, bits) ((ch)->polymorphed ? ((ch)->polymorphed->vuln_flags |= (bits)) : ((ch)->vuln_flags |= (bits)))
#define CHAR_REM_IMM(ch, bits)  ((ch)->polymorphed ? ((ch)->polymorphed->imm_flags &= ~(bits)) : ((ch)->imm_flags &= ~(bits)))
#define CHAR_REM_RES(ch, bits)  ((ch)->polymorphed ? ((ch)->polymorphed->res_flags &= ~(bits)) : ((ch)->res_flags &= ~(bits)))
#define CHAR_REM_VULN(ch, bits) ((ch)->polymorphed ? ((ch)->polymorphed->vuln_flags &= ~(bits)) : ((ch)->vuln_flags &= ~(bits)))

/*
 * Object macros.
 */
#define CAN_WEAR(obj, part)	 (IS_SET((obj)->wear_flags,  (part)))
#define IS_OBJ_STAT(obj, stat)	 (IS_SET((obj)->extra_flags, (stat)))
#define IS_WEAPON_STAT(obj,stat) (IS_SET((obj)->value[4],(stat)))
#define WEIGHT_MULT(obj)	 ((obj)->item_type == ITEM_CONTAINER ? \
	(obj)->value[4] : 100)
#define OBJ_EXTRACTED(obj)	 (!IS_VALID((obj)))


/*
 * Description macros.
 */
#define PERS(ch, looker)        ( !can_see(looker, (ch))                \
                                  ? "someone"                           \
                                  : (ch)->polymorphed                   \
                                  ? (ch)->polymorphed->short_descr      \
                                  : IS_NPC(ch)                          \
                                  ? (ch)->short_descr                   \
                                  : (ch)->name )
#define PERS_TRUE(ch)           ( IS_NPC(ch) ? (ch)->short_descr	\
                                : (ch)->name )


/*
 * Extraction macros.
 */



/*
 * Time macros.
 */
#define MINUTES_IN_TICK         10
#define TICKS_IN_HOUR           6
#define HOURS_IN_DAY            24
#define DAYS_IN_WEEK            7
#define DAYS_IN_MONTH           35
#define MONTHS_IN_YEAR          17
#define DAYS_IN_LUNAR_MONTH     30
#define DAYS_IN_YEAR            (DAYS_IN_MONTH * MONTHS_IN_YEAR)
#define DAYS_THIS_YEAR          (time_info.month * DAYS_IN_MONTH + time_info.day)
#define SEASON                  (4 * DAYS_THIS_YEAR / DAYS_IN_YEAR)
#define SEASON_WINTER           0
#define SEASON_SPRING           1
#define SEASON_SUMMER           2
#define SEASON_FALL             3
#define PHASES_IN_LUNAR_MONTH   (DAYS_IN_LUNAR_MONTH / 6)
#define LUNAR_PHASE             (time_info.lunar_day / PHASES_IN_LUNAR_MONTH)
#define MOON_NEW                0
#define MOON_WAXING_CRESENT     1
#define MOON_WAXING_NEAR_FULL   2
#define MOON_FULL               3
#define MOON_WANING_NEAR_FULL   4
#define MOON_WANING_CRESENT     5
#define MOON_RISES              ((HOURS_IN_DAY - 1) * 			\
                                time_info.lunar_day /			\
                                (DAYS_IN_LUNAR_MONTH - 1))
#define MOON_SINKS              ((MOON_RISES + HOURS_IN_DAY / 3) %	\
                                HOURS_IN_DAY)


/*
 * Structure for a social in the socials table.
 */
#define SOCIAL_NULL	       -1
#define SOCIAL_NO_ADVERB	0
#define SOCIAL_ADVERB		1
#define SOCIAL_OPT_ADVERB	2

struct	social_data
{
    sh_int    type;
    char *    message;
    char *    adverb;
};

struct	social_type
{
    char      		name[20];
    struct social_data	char_no_arg;
    struct social_data	others_no_arg;
    struct social_data	char_found;
    struct social_data	others_found;
    struct social_data	vict_found;
    struct social_data	char_not_found;
    struct social_data	char_auto;
    struct social_data	others_auto;
};



/*
 * Global constants.
 */
extern	const	struct	str_app_type	str_app		[26];
extern	const	struct	int_app_type	int_app		[26];
extern	const	struct	wis_app_type	wis_app		[26];
extern	const	struct	dex_app_type	dex_app		[26];
extern	const	struct	con_app_type	con_app		[26];
extern  const   struct  per_app_type    per_app         [26];

extern	const	struct	class_type	class_table	[MAX_CLASS];
extern	const	struct	weapon_type	weapon_table	[];
extern	const	struct	poison_type	poison_table	[];
extern  const   struct  item_type	item_table	[];
extern	const	struct	wiznet_type	wiznet_table	[];
extern	const	struct	game_type	game_table	[];
extern	const	struct	attack_type	attack_table	[];
extern  const	struct  race_type	race_table	[];
extern	const	struct	pc_race_type	pc_race_table	[];
extern  const	struct	spec_type	spec_table	[];
extern	const	struct	liq_type	liq_table	[];
extern	const	struct	skill_type	skill_table	[MAX_SKILL];
extern  const   struct  group_type      group_table	[MAX_GROUP];
extern	const	struct	style_type	style_table	[MAX_STYLES];
extern	const	struct	hometown_type	hometown_table	[MAX_HOMETOWN];
extern          struct  social_type     social_table	[MAX_SOCIALS];
/*
extern	char *	const			title_table	[MAX_CLASS]
							[MAX_LEVEL+1]
							[2];
*/

extern	const	struct	affect_proc_name affect_procs[];
extern	const	struct	religion_type	religion_table[MAX_GODS];
extern		char *			adverb_table[MAX_ADVERBS];
extern	const	int			donation_rooms[MAX_DONATION];
extern	const	char *			str_names[ MAX_STAT_NAME ];
extern	const	char *			int_names[ MAX_STAT_NAME ];
extern	const	char *			wis_names[ MAX_STAT_NAME ];
extern	const	char *			dex_names[ MAX_STAT_NAME ];
extern	const	char *			con_names[ MAX_STAT_NAME ];
extern	const	char *			per_names[ MAX_STAT_NAME ];
extern	const	char *			cha_names[ MAX_STAT_NAME ];
extern	const	struct use_msg_type	use_msgs[];
extern	const	char *			con_names[];

/*
 * Global variables.
 */
extern		HELP_DATA	  *	help_first;
extern		SHOP_DATA	  *	shop_first;

extern		CHAR_DATA	  *	char_list;
extern		CHAR_DATA	  *	actor;
extern		CHAR_DATA	  *	extracted_chars;
extern		DESCRIPTOR_DATA   *	descriptor_list;
extern		OBJ_DATA	  *	object_list;
extern		OBJ_DATA	  *	extracted_objs;
extern		MPROG_CODE	  *	mprog_list;


extern		int			max_on;
extern		char			bug_buf		[];
extern		time_t			current_time;
extern		bool			fLogAll;
extern		FILE *			fpReserve;
extern		KILL_DATA		kill_table	[];
extern		char			log_buf		[];
extern		TIME_INFO_DATA		time_info;
extern		WEATHER_DATA		weather_info;
extern		bool			MOBtrigger;
extern		PERIODIC_CHECK_DATA *	periodic_object_checks;
extern		PERIODIC_CHECK_DATA *   periodic_room_checks;
extern		struct territory_data	territories[];


/*
 * OS-dependent declarations.
 * These are all very standard library functions,
 *   but some systems have incomplete or non-ansi header files.
 */
#if	defined(_AIX)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(apollo)
int	atoi		args( ( const char *string ) );
void *	calloc		args( ( unsigned nelem, size_t size ) );
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(hpux)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(linux)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(macintosh)
#define NOCRYPT
#if	defined(unix)
#undef	unix
#endif
#endif

#if	defined(MIPS_OS)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(MSDOS)
#define NOCRYPT
#if	defined(unix)
#undef	unix
#endif
#endif

#if	defined(NeXT)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif

#if	defined(sequent)
char *	crypt		args( ( const char *key, const char *salt ) );
int	fclose		args( ( FILE *stream ) );
int	fprintf		args( ( FILE *stream, const char *format, ... ) );
int	fread		args( ( void *ptr, int size, int n, FILE *stream ) );
int	fseek		args( ( FILE *stream, long offset, int ptrname ) );
void	perror		args( ( const char *s ) );
int	ungetc		args( ( int c, FILE *stream ) );
#endif

#if	defined(sun)
char *	crypt		args( ( const char *key, const char *salt ) );
int	fclose		args( ( FILE *stream ) );
int	fprintf		args( ( FILE *stream, const char *format, ... ) );
#if	defined(SYSV)
siz_t	fread		args( ( void *ptr, size_t size, size_t n, 
			    FILE *stream) );
#else
int	fread		args( ( void *ptr, int size, int n, FILE *stream ) );
#endif
int	fseek		args( ( FILE *stream, long offset, int ptrname ) );
void	perror		args( ( const char *s ) );
int	ungetc		args( ( int c, FILE *stream ) );
#endif

#if	defined(ultrix)
char *	crypt		args( ( const char *key, const char *salt ) );
#endif



/*
 * The crypt(3) function is not available on some operating systems.
 * In particular, the U.S. Government prohibits its export from the
 *   United States to foreign countries.
 * Turn on NOCRYPT to keep passwords in plain text.
 */
#if	defined(NOCRYPT)
#define crypt(s1, s2)	(s1)
#endif



/*
 * Data files used by the server.
 *
 * AREA_LIST contains a list of areas to boot.
 * All files are read in completely at bootup.
 * Most output files (bug, idea, typo, shutdown) are append-only.
 *
 * The NULL_FILE is held open so that we have a stream handle in reserve,
 *   so players can go ahead and telnet to all the other descriptors.
 * Then we close it whenever we need to open a file (e.g. a save file).
 */
#if defined(macintosh)
#define PLAYER_DIR	":player:"		/* Player files	*/
#define GOD_DIR		":gods:"		/* list of gods	*/
#define TEMP_FILE	":player:romtmp"
#define NULL_FILE	"dev:null"		/* To reserve one stream */
#define AREAS		":area:"		/* normal area directory */
#define WORKING_AREAS	":area:working:"
#define WORKING_TEMP	":area:working:areatmp"
#define BAD_AREAS	":area:bad:"
#define AREA_REVIEWS	":area:reviews:"

#define AREA_LIST       ":area:area.lst"	/* List of areas*/
#define ADVERB_LIST	":area:adverb.lst"	/* List of adverbs */
#define TERRITORIES_FILE \
			":area:territories.lst"	/* The list of territories */
#define TERRITORY_TEMP	":area:territories.tmp"	/* Temp save file. */
#define BUG_FILE        ":area:bugs.txt"	/* For 'bug' and bug()*/
#define TYPO_FILE       ":area:typos.txt"	/* For 'typo'*/
#define NOTE_FILE       ":area:notes.not"	/* For 'notes'*/
#define IDEA_FILE	":area:ideas.not"
#define PENALTY_FILE	":area:penal.not"
#define NEWS_FILE	":area:news.not"
#define CHANGES_FILE	":area:chang.not"
#define BUGS_FILE	":area:bugs.not"
#define SHUTDOWN_FILE   ":area:shutdown.txt"	/* For 'shutdown'*/
#define BAN_FILE	":area:ban.txt"
#define MUSIC_FILE	":area:music.txt"
#define INVALID_NAME_PARTS \
			":area:invalid.txt"	/* For validating names at login */
#define CRIER_FILE	":area:messages.lst"
#endif

#if defined(MSDOS) || defined(WIN32)
#define PLAYER_DIR	    "../player/"			/* Player files */
#define TEMP_FILE	    "../player/romtmp"
#define NULL_FILE	    "nul"			        /* To reserve one stream */
#define WORKING_AREAS	"./working/"
#define WORKING_TEMP	"./working/areatmp"
#define BAD_AREAS	    "./bad/"
#define AREA_REVIEWS	"./reviews/"
#endif

#if defined(unix)
#define PLAYER_DIR      "../player/"        	/* Player files */
#define GOD_DIR         "../gods/"  		/* list of gods */
#define TEMP_FILE	"../player/romtmp"
#define NULL_FILE	"/dev/null"		/* To reserve one stream */
#define WORKING_AREAS	"./working/"		/* Asaved areas */
#define WORKING_TEMP	"./working/areatmp"
#define BAD_AREAS	"./bad/"		/* Working areas that failed to
						   load. */
#define AREA_REVIEWS	"./reviews/"		/* Holds area reviews. */
#define CORE_EXAMINE_SCRIPT \
			"../area/examine"	
#endif

#if !defined(macintosh)
#define AREA_LIST       "area.lst"		/* List of areas*/
#define ADVERB_LIST	"adverb.lst"		/* List of adverbs */
#define TERRITORIES_FILE \
			"territories.lst"	/* The list of territories */
#define TERRITORY_TEMP	"territories.tmp"	/* Temp save file. */
#define BUG_FILE        "bugs.txt"		/* For 'bug' and bug()*/
#define TYPO_FILE       "typos.txt"		/* For 'typo'*/
#define NOTE_FILE       "notes.not"		/* For 'notes'*/
#define IDEA_FILE	"ideas.not"
#define PENALTY_FILE	"penal.not"
#define NEWS_FILE	"news.not"
#define CHANGES_FILE	"chang.not"
#define BUGS_FILE	"bugs.not"
#define SHUTDOWN_FILE   "shutdown.txt"		/* For 'shutdown'*/
#define BAN_FILE	"ban.txt"
#define MUSIC_FILE	"music.txt"
#define INVALID_NAME_PARTS \
			"invalid.txt"		/* For validating names at login */
#define CRIER_FILE	"messages.txt"
#define ACCOUNT_FILE	"accounts.txt"
#endif

/*
 * Our function prototypes.
 * One big lump ... this is every function in Merc.
 */
#define CD	CHAR_DATA
#define MID	MOB_INDEX_DATA
#define OD	OBJ_DATA
#define OID	OBJ_INDEX_DATA
#define RID	ROOM_INDEX_DATA
#define SF	SPEC_FUN
#define AD	AFFECT_DATA
#define ED	EXTRA_DESCR_DATA
#define RD	RESET_DATA
#define MPC	MPROG_CODE

/* account.c */
void	load_accounts	args( () );
void	save_accounts	args( () );
bool	account_deposit	args( ( const char *account_name, long amount ) );
bool	account_withdraw args( ( const char *account_name, long amount ) );
long	account_balance	args( ( const char *account_name ) );

/* act_comm.c */
void  	check_sex	args( ( CHAR_DATA *ch) );
void	add_follower	args( ( CHAR_DATA *ch, CHAR_DATA *master ) );
void	stop_follower	args( ( CHAR_DATA *ch ) );
void 	nuke_pets	args( ( CHAR_DATA *ch ) );
void	die_follower	args( ( CHAR_DATA *ch ) );
bool	is_same_group	args( ( CHAR_DATA *ach, CHAR_DATA *bch ) );
void	update_reply	args( ( CHAR_DATA* ch, CHAR_DATA *to ) );
void 	logf 		args((char * fmt, ...));

/* act_enter.c */
RID  *get_random_room   args ( (CHAR_DATA *ch) );

/* act_info.c */
void	set_title	args( ( CHAR_DATA *ch, char *title ) );
void	look_checkers	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );

/* act_move.c */
void	move_char	args( ( CHAR_DATA *ch, int door, bool follow ) );

/* act_obj.c */
bool	can_loot	args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
void	wear_obj	args( ( CHAR_DATA *ch, OBJ_DATA *obj, bool fReplace) );
void	get_obj		args( ( CHAR_DATA *ch, OBJ_DATA *obj,
				OBJ_DATA *container ) );

/* act_wiz.c */
void wiznet		args( ( char *string, CHAR_DATA *ch, OBJ_DATA *obj,
				long flag, long flag_skip, int min_level ) );
struct tm *update_time  args( ( struct tm *old_time ) );
void warmboot_recover	args((void));

/* alias.c */
void 	substitute_alias args( (DESCRIPTOR_DATA *d, char *input) );

/* ban.c */
bool	check_ban	args( ( char *site, int type) );


/* comm.c */
void	show_string	args( ( struct descriptor_data *d, char *input) );
void	close_socket	args( ( DESCRIPTOR_DATA *dclose, bool toast_corpses ) );
void	write_to_buffer	args( ( DESCRIPTOR_DATA *d, const char *txt,
				int length ) );
void	send_to_char	args( ( const char *txt, CHAR_DATA *ch ) );
void	page_to_char	args( ( const char *txt, CHAR_DATA *ch ) );
int	act		args( ( const char *format, CHAR_DATA *ch,
				const void *arg1, const void *arg2, int type ) );
int	act_new		args( ( const char *format, CHAR_DATA *ch, 
				const void *arg1, const void *arg2, int type,
				int min_pos) );
int	act_color	args( ( const char *format, CHAR_DATA *ch, 
				const void *arg1, const void *arg2, int type,
				int min_pos, int color) );
void	do_abort	args( () );
void	toast_corpses	args( ( char *name ) );

/* crier.c */
void 	load_messages	args( () );
void	add_message	args( ( const char *msg, void *arg1, 
				void *arg2, bool perm ) );
void	add_kill_message args( ( CHAR_DATA *ch, CHAR_DATA *victim, 
				int dam_type ) );
void	update_crier_messages	args( () );
void	cry		args( ( CHAR_DATA *crier ) );

/* db.c */
char *	print_flags	args( ( int flag ));
void	boot_db		args( ( void ) );
void	area_update	args( ( void ) );
CD *	create_mobile	args( ( MOB_INDEX_DATA *pMobIndex ) );
void	clone_mobile	args( ( CHAR_DATA *parent, CHAR_DATA *clone) );
OD *	create_object	args( ( OBJ_INDEX_DATA *pObjIndex, int level, bool randomize ) );
void	clone_object	args( ( OBJ_DATA *parent, OBJ_DATA *clone ) );
void	clear_char	args( ( CHAR_DATA *ch ) );
char *	get_extra_descr	args( ( const char *name, EXTRA_DESCR_DATA *ed ) );
MID *	get_mob_index	args( ( int vnum ) );
OID *	get_obj_index	args( ( int vnum ) );
RID *	get_room_index	args( ( int vnum ) );
MPC *	get_mprog_index	args( ( int vnum ) );
char	fread_letter	args( ( FILE *fp ) );
int	fread_number	args( ( FILE *fp ) );
long 	fread_flag	args( ( FILE *fp ) );
char *	fread_string	args( ( FILE *fp ) );
char *  fread_string_eol args(( FILE *fp ) );
void	fread_to_eol	args( ( FILE *fp ) );
char *	fread_word	args( ( FILE *fp ) );
long	flag_convert	args( ( char letter) );
void *	alloc_mem	args( ( int sMem ) );
void *	alloc_perm	args( ( int sMem ) );
void	free_mem	args( ( void *pMem, int sMem ) );
char *	str_dup		args( ( const char *str ) );
void	free_string	args( ( char *pstr ) );
int	number_fuzzy	args( ( int number ) );
int	number_range	args( ( int from, int to ) );
int	number_percent	args( ( void ) );
int	number_door	args( ( void ) );
int	number_bits	args( ( int width ) );
long    number_mm       args( ( void ) );
int	dice		args( ( int number, int size ) );
int	interpolate	args( ( int level, int value_00, int value_32 ) );
void	smash_tilde	args( ( char *str ) );
bool	str_cmp		args( ( const char *astr, const char *bstr ) );
bool	str_prefix	args( ( const char *astr, const char *bstr ) );
bool	str_infix	args( ( const char *astr, const char *bstr ) );
bool	str_suffix	args( ( const char *astr, const char *bstr ) );
const char *str_str     args( ( const char *astr, const char *bstr ) );
char *	capitalize	args( ( const char *str ) );
void	append_file	args( ( CHAR_DATA *ch, char *file, char *str ) );
void	remove_bad_area	args( (void) );
void	bug		args( ( const char *str, int param ) );
void	log_string	args( ( const char *str ) );
void	tail_chain	args( ( void ) );
void	reset_area	args( ( AREA_DATA *pArea ) );

/* effect.c */
void	acid_effect	args( (void *vo, int level, int dam, int target) );
void	cold_effect	args( (void *vo, int level, int dam, int target) );
void	fire_effect	args( (void *vo, int level, int dam, int target) );
void	poison_effect	args( (void *vo, int level, int dam, int target) );
void	shock_effect	args( (void *vo, int level, int dam, int target) );
void    curse_effect    args( (void *vo, int level, int dam, int target) );


/* fight.c */
bool 	is_safe		args( (CHAR_DATA *ch, CHAR_DATA *victim ) );
bool 	is_safe_spell	args( (CHAR_DATA *ch, CHAR_DATA *victim, bool area ) );
void	violence_update	args( ( void ) );
void	multi_hit	args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dt ) );
bool	damage		args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam,
				int dt, int class, bool show, 
				OBJ_DATA *weapon ) );
bool	damage_old	args( ( CHAR_DATA *ch, CHAR_DATA *victim, int dam,
				int dt, int class, bool show, 
				OBJ_DATA *weapon ) );
void	update_pos	args( ( CHAR_DATA *victim ) );
void	stop_fighting	args( ( CHAR_DATA *ch, bool fBoth ) );
void	check_killer	args( ( CHAR_DATA *ch, CHAR_DATA *victim) );
int	get_ac		args( ( CHAR_DATA *ch, int dam_type ) );
void	save_hostility	args( ( CHAR_DATA *victim ) );
bool	check_dismount	args( ( CHAR_DATA *victim ) );
bool    martial_artist  args( ( CHAR_DATA *ch ) );
void	handle_death	args( ( CHAR_DATA *ch, CHAR_DATA *victim,
				int dam_type, bool make_parts ) );
void	decapitate	args( ( CHAR_DATA *victim, CHAR_DATA *killer ) );
void    set_fighting    args( ( CHAR_DATA *ch, CHAR_DATA *victim,
                                bool record ) );
void    daze_state      args( ( CHAR_DATA *victim, int numPulses ) );


/* handler.c */
AD *    affect_find     args( ( AFFECT_DATA *paf, int sn ) );
void    affect_check    args( ( CHAR_DATA *ch, int where, int vector ) );
int     count_users     args( ( OBJ_DATA *obj ) );
void    deduct_cost     args( ( CHAR_DATA *ch, int cost ) );
void    affect_enchant  args( ( OBJ_DATA *obj ) );
int     check_immune    args( ( CHAR_DATA *ch, int dam_type ) );
int     religion_lookup args( ( const char *name ) );
int     liq_lookup      args( ( const char *name ) );
int     material_lookup args( ( const char *name ) );
int     weapon_lookup   args( ( const char *name ) );
int     advantage_lookup
                        args( ( const struct advantage_type *table, 
                                const char *argument, CHAR_DATA *ch ) );
int     weapon_type     args( ( const char *name ) );
char *  weapon_name     args( ( int weapon_Type ) );
int     poison_type     args( ( const char *name ) );
char *  poison_name     args( ( int poison_Type ) );
char *  poison_type_name
                        args( ( int type ) );
int     item_lookup     args( ( const char *name ) );
char *  item_name       args( ( int item_type ) ); 
int     attack_lookup   args( ( const char *name ) );
int     race_lookup     args( ( const char *name ) );
long    wiznet_lookup   args( ( const char *name ) );
int     class_lookup    args( ( const char *name ) );
int	hometown_lookup	args( ( const char *name ) );
bool    is_clan         args( ( CHAR_DATA *ch ) );
bool    is_same_clan    args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    is_old_mob      args( ( CHAR_DATA *ch ) );
int     get_skill       args( ( CHAR_DATA *ch, int sn ) );
int     get_weapon_sn   args( ( CHAR_DATA *ch ) );
int     get_secondary_sn
                        args( (CHAR_DATA *ch) );
int     get_weapon_skill    
                        args( ( CHAR_DATA *ch, int sn ) );
int     get_age         args( ( CHAR_DATA *ch ) );
void    reset_char      args( ( CHAR_DATA *ch )  );
int     get_trust       args( ( CHAR_DATA *ch ) );
int     get_mob_stat    args( ( int stat, int level, MOB_INDEX_DATA *pIndexData ) );
int     get_curr_stat   args( ( CHAR_DATA *ch, int stat ) );
int     get_real_stat   args( ( CHAR_DATA *ch, int stat ) );
const char *get_stat_word
                        args( ( CHAR_DATA *ch, int stat ) );
int     get_max_train   args( ( CHAR_DATA *ch, int stat ) );
int     can_carry_n     args( ( CHAR_DATA *ch ) );
int     can_carry_w     args( ( CHAR_DATA *ch ) );
int     get_stat_mod    args( ( CHAR_DATA *ch, int stat ) );

bool    is_name         args( ( char *str, char *namelist ) );
bool    is_exact_name   args( ( char *str, char *namelist ) );
char *  true_name       args( ( CHAR_DATA *ch ) );
void    affect_modify   args( ( CHAR_DATA *ch, AFFECT_DATA *paf, bool fAdd ) );
void    affect_to_char  args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void    affect_to_char_after
                        args( ( CHAR_DATA *ch, AFFECT_DATA *paf, 
                                AFFECT_DATA *after ) );
void    affect_to_obj   args( ( OBJ_DATA *obj, AFFECT_DATA *paf ) );
void    affect_remove   args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void    affect_remove_obj
                        args( ( OBJ_DATA *obj, AFFECT_DATA *paf ) );
void    affect_strip    args( ( CHAR_DATA *ch, int sn ) );
bool    is_affected     args( ( CHAR_DATA *ch, int sn ) );
void    affect_join     args( ( CHAR_DATA *ch, AFFECT_DATA *paf ) );
void    char_from_room  args( ( CHAR_DATA *ch, bool dismount ) );
void    char_to_room    args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *pRoomIndex ) );
bool    char_matches    args( ( CHAR_DATA *ch, int flags ) );
void    obj_to_char     args( ( OBJ_DATA *obj, CHAR_DATA *ch ) );
void    obj_from_char   args( ( OBJ_DATA *obj ) );
int     apply_ac        args( ( OBJ_DATA *obj, int iWear, int type ) );
OD *    get_eq_char     args( ( CHAR_DATA *ch, int iWear ) );
void    equip_char      args( ( CHAR_DATA *ch, OBJ_DATA *obj, int iWear ) );
void    unequip_char    args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
int     count_obj_list  args( ( OBJ_INDEX_DATA *obj, OBJ_DATA *list ) );
void    obj_from_room   args( ( OBJ_DATA *obj ) );
void    obj_to_room     args( ( OBJ_DATA *obj, ROOM_INDEX_DATA *pRoomIndex ) );
void    obj_to_obj      args( ( OBJ_DATA *obj, OBJ_DATA *obj_to ) );
void    obj_from_obj    args( ( OBJ_DATA *obj ) );
void    extract_obj     args( ( OBJ_DATA *obj ) );
void    extract_char    args( ( CHAR_DATA *ch, bool fPull ) );
CD *    get_char_room   args( ( CHAR_DATA *ch, char *argument ) );
CD *    get_char_world  args( ( CHAR_DATA *ch, char *argument ) );
OD *    get_obj_type    args( ( OBJ_INDEX_DATA *pObjIndexData ) );
OD *    get_obj_list    args( ( CHAR_DATA *ch, char *argument,
                                OBJ_DATA *list ) );
OD *    get_obj_carry   args( ( CHAR_DATA *ch, char *argument, 
                                CHAR_DATA *viewer ) );
OD *    get_obj_wear    args( ( CHAR_DATA *ch, char *argument ) );
OD *    get_obj_wear_other
                        args( ( CHAR_DATA *ch, char *argument,
                                CHAR_DATA *victim ) );
OD *    get_obj_here    args( ( CHAR_DATA *ch, char *argument ) );
OD *    get_obj_world   args( ( CHAR_DATA *ch, char *argument ) );
OD *    create_money    args( ( int gold, int silver ) );
int     get_obj_number  args( ( OBJ_DATA *obj ) );
int     get_obj_weight  args( ( OBJ_DATA *obj ) );
int     get_true_weight args( ( OBJ_DATA *obj ) );
bool    room_is_dark    args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *pRoomIndex ) );
bool    is_room_owner   args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *room) );
bool    room_is_private args( ( ROOM_INDEX_DATA *pRoomIndex ) );
bool    can_see         args( ( CHAR_DATA *ch, CHAR_DATA *victim ) );
bool    can_see_obj     args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
bool    can_see_room    args( ( CHAR_DATA *ch, ROOM_INDEX_DATA *pRoomIndex) );
bool    can_drop_obj    args( ( CHAR_DATA *ch, OBJ_DATA *obj ) );
char *  affect_loc_name args( ( int location ) );
char *  affect_bit_name args( ( int vector ) );
char *  affect2_bit_name
            args( ( int vector ) );
char *  extra_bit_name  args( ( int extra_flags ) );
char *  wear_bit_name   args( ( int wear_flags ) );
char *  act_bit_name    args( ( int act_flags ) );
char *  off_bit_name    args( ( int off_flags ) );
char *  imm_bit_name    args( ( int imm_flags ) );
char *  form_bit_name   args( ( int form_flags ) );
char *  part_bit_name   args( ( int part_flags ) );
char *  weapon_bit_name args( ( int weapon_flags ) );
char *  comm_bit_name   args( ( int comm_flags ) );
char *  cont_bit_name   args( ( int cont_flags ) );
char *  room_bit_name   args( ( int room_flags ) );
char *  furniture_bit_name  
                        args( ( int furn_flags ) );
char *  exit_bit_name   args( ( int exit_flags ) );
char *  portal_bit_name args( ( int portal_flags ) );
char *  aggression_bit_name 
                        args( ( int flags ) );
char *  restriction_bit_name 
                        args( ( int flags ) );
char *  fit_bit_name    args( ( int flags ) );
char *  area_bit_name   args( ( int flags ) );
bool    has_customization
                        args( ( CHAR_DATA *ch, int type ) );
bool    has_holylight   args( ( CHAR_DATA *ch ) );
int     get_olc_level   args( ( CHAR_DATA *ch ) );
void    remove_memory   args( ( CHAR_DATA *ch, MEM_DATA *memory ) );
char *  trap_bit_name   args( ( int flags ) );
char *  territory_bit_name
                        args( ( int flags ) );
char *  find_use_msg    args( ( OBJ_DATA *obj, sh_int tag ) );
char *  crime_bit_name  args( ( int flags ) );
RID  *  get_random_room args( ( CHAR_DATA *ch ) );
OD   *  get_random_obj  args( ( CHAR_DATA *ch ) );
CD   *  get_random_npc  args( (CHAR_DATA *ch ) );
const char *
        get_room_description
                        args( ( CHAR_DATA *ch ) );
const char *
        get_room_name   args( ( CHAR_DATA *ch ) );
int     count_objects   args( ( OBJ_DATA *obj ) );


/* help.c */
void    append_default_skills
                        args( ( CHAR_DATA *ch, BUFFER *output, 
                                const char *args ) );
void    append_gainable_skills
                        args( ( CHAR_DATA *ch, BUFFER *output,
                                const char *args ) );
void    append_default_groups
                        args( ( CHAR_DATA *ch, BUFFER *output,
                                const char *args ) );
void    append_gainable_groups
                        args( ( CHAR_DATA *ch, BUFFER *output,
                                const char *args ) );
void    append_race_cost
                        args( ( CHAR_DATA *ch, BUFFER *output,
                                const char *args ) );
void    append_race_skills
                        args( ( CHAR_DATA *ch, BUFFER *output,
                                const char *args ) );
void    append_ch_cost  args( ( CHAR_DATA *ch, BUFFER *output,
                                const char *args ) );


/* interp.c */
void	interpret   	args( ( CHAR_DATA *ch, char *argument ) );
bool	is_number	    args( ( char *arg ) );
int	number_argument	    args( ( char *argument, char *arg ) );
int	mult_argument	    args( ( char *argument, char *arg) );
char *	one_argument	args( ( char *argument, char *arg_first ) );
char *	cased_one_argument
                        args( ( char *argument, char *arg_first ) );
bool	trusted_command	args( ( CHAR_DATA *ch, char *command ) );

/* magic.c */
int	ind_spell	    args( ( CHAR_DATA *ch, const char *name, bool *stolen ) );
int 	mana_cost 	    args( (CHAR_DATA *ch, int min_mana, int level) );
int	    slot_lookup	    args( ( int slot ) );
int	    skill_lookup    args( ( const char *name ) );
int     skill_lookup_abs
                        args( ( const char *name ) );
int     find_spell      args( ( CHAR_DATA *ch, const char *name, 
                                bool *stolen ) );
bool	saves_spell	    args( ( int level, CHAR_DATA *victim, int dam_type ) );
void	obj_cast_spell	args( ( int sn, int level, CHAR_DATA *ch,
				                CHAR_DATA *victim, OBJ_DATA *obj ) );
int     affect_proc_lookup
                        args( ( char *name ) );
void	mob_cast	    args( ( const char *spell, CHAR_DATA *ch,
				                void *vo, int target ) );
bool    check_bard_song args( ( CHAR_DATA *ch, int sn ) );
void    remove_bard_song
                        args( ( CHAR_DATA *ch, bool silent ) );
void	remove_crime	args( ( CHAR_DATA *victim, CRIME_DATA *crime,
                                int territory ) );
bool    can_cast        args( ( CHAR_DATA *ch, const char *name,
                                int *sn, bool *stolen ) );
int     get_mana_cost   args( ( CHAR_DATA *ch, int sn ) );

/* magic3.c */
void    check_contingency
			args( ( CHAR_DATA *ch, int type ) );
void    level_familier  args( ( CHAR_DATA *familier, int level ) );

/* mob_prog.c */
void	program_flow	args( ( sh_int vnum, char *source, CHAR_DATA *mob,
				CHAR_DATA *ch, const void *arg1,
				const void *arg2 ) );
bool	mp_act_trigger	args( ( char *argument, CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2,
				int type ) );
bool	mp_percent_trigger args( ( CHAR_DATA *mob, CHAR_DATA *ch,
				const void *arg1, const void *arg2,
				int type ) );
void	mp_bribe_trigger args( ( CHAR_DATA *mob, CHAR_DATA *ch, int amount ) );
bool	mp_exit_trigger	 args( ( CHAR_DATA *ch, int dir ) );
void	mp_give_trigger	 args( ( CHAR_DATA *mob, CHAR_DATA *ch,
				OBJ_DATA *obj ) );
void 	mp_greet_trigger args( ( CHAR_DATA *ch ) );
void	mp_hprct_trigger args( ( CHAR_DATA *mob, CHAR_DATA *ch ) );
bool	op_act_trigger	    args( ( char *argument, OBJ_DATA *obj,
				    CHAR_DATA *ch, const void *arg1,
				    const void *arg2, int type ) );
bool	op_percent_trigger  args( ( OBJ_DATA *obj, CHAR_DATA *ch, 
				    const void *arg1, const void *arg2,
				    int type ) );
void	op_greet_trigger    args( ( CHAR_DATA *ch ) );
void	op_simple_trigger   args( ( OBJ_DATA *obj, CHAR_DATA *ch, int type ) );
void	op_get_trigger	    args( ( OBJ_DATA *obj, CHAR_DATA *ch,
				    OBJ_DATA *container ) );
void	op_put_trigger	    args( ( OBJ_DATA *obj, CHAR_DATA *ch,
				    OBJ_DATA *container ) );
void	op_speech_trigger   args( ( CHAR_DATA *ch, char *txt ) );
void	op_get_content_trigger args( ( OBJ_DATA *obj, CHAR_DATA *ch,
				    OBJ_DATA *content ) );
void	op_put_content_trigger args( ( OBJ_DATA *obj, CHAR_DATA *ch,
				    OBJ_DATA *content ) );
bool	op_steal_trigger    args( ( OBJ_DATA *obj, CHAR_DATA *thief,
				    CHAR_DATA *victim ) );
bool	rp_act_trigger	    args( ( char *argument, ROOM_INDEX_DATA *pRoom,
				    CHAR_DATA *ch, const void *arg1,
				    const void *arg2, int type ) );
bool	rp_percent_trigger  args( ( ROOM_INDEX_DATA *pRoom, CHAR_DATA *ch, 
				    const void *arg1, const void *arg2,
				    int type ) );
void	rp_greet_trigger    args( ( CHAR_DATA *ch ) );
void	rp_speech_trigger   args( ( CHAR_DATA *ch, char *txt ) );
bool	rp_exit_trigger	    args( ( CHAR_DATA *ch, int door ) );
bool	skill_prog_gainable	args( ( CHAR_DATA *ch, int sn ) );
bool	group_prog_gainable	args( ( CHAR_DATA *ch, int gn ) );


/* mob_cmds.c */
void	mob_interpret	args( ( CHAR_DATA *ch, char *argument ) );
char *	mprog_type_to_name	args( ( int type ) );
char *	oprog_type_to_name	args( ( int type ) );
char *	rprog_type_to_name	args( ( int type ) );

/* note.c */
void	append_note	args( ( NOTE_DATA *pnote ) );

/* olcedit.c */
bool	edit_desc	args( ( CHAR_DATA *ch, char **description, 
				char *argument ) );
ED	*find_extra	args( ( EXTRA_DESCR_DATA *head, char *keywords ) );
void	remove_extra	args( ( EXTRA_DESCR_DATA **head,
				EXTRA_DESCR_DATA *remove ) );

/* olcarea.c */
bool	is_creator	args( ( CHAR_DATA *ch, AREA_DATA *area ) );

/* olcread.c */
void	load_olc_area	args( ( FILE *fp ) );
void	load_olc_mobile	args( ( FILE *fp ) );
void	load_olc_object	args( ( FILE *fp ) );
void	load_olc_rooms	args( ( FILE *fp ) );
void	load_olc_resets	args( ( FILE *fp ) );
void	load_olc_shops	args( ( FILE *fp ) );
void	load_olc_specials	args( ( FILE *fp ) );
int	convert_wear_location	args( ( int old_location, int old_version ) );

/* olcreset.c */
void	remove_resets	args( ( AREA_DATA *area, char type, 
				int arg1, int arg2 ) );
void	remove_reset	args( ( AREA_DATA *area, RESET_DATA *pReset ) );
RD 	*find_reset	args( ( AREA_DATA *area, char type, 
				int arg1, int arg2 ) );
RD	*create_reset	args( ( AREA_DATA *area, RESET_DATA *after ) );

/* olcsave.c */
void	fwrite_area	args( ( AREA_DATA *area ) );

/* renown.c */
int	default_renown	args( () );
const char *	renown	args( ( CHAR_DATA *ch ) );
void	adjust_kill_renown	args( ( CHAR_DATA *ch, int victim_level ) );
void	adjust_flee_renown	args( ( CHAR_DATA *ch ) );
void	adjust_death_renown	args( ( CHAR_DATA *ch ) );

/* save.c */
char	*print_flags	args( ( int flag ) );
void	save_char_obj	args( ( CHAR_DATA *ch, bool extract ) );
bool	load_char_obj	args( ( DESCRIPTOR_DATA *d, char *name ) );

/* skills.c */
bool 	parse_gen_groups args( ( CHAR_DATA *ch,char *argument ) );
void 	list_group_costs args( ( CHAR_DATA *ch ) );
void    list_group_known args( ( CHAR_DATA *ch ) );
int 	exp_per_level	args( ( CHAR_DATA *ch, int points ) );
void 	check_improve	args( ( CHAR_DATA *ch, int sn, bool success, 
				int multiplier, bool msg_vis ) );
int 	group_lookup	args( (const char *name) );
int 	group_lookup_abs
			args( (const char *name) );
void	gn_add		args( ( CHAR_DATA *ch, int gn) );
void 	gn_remove	args( ( CHAR_DATA *ch, int gn) );
void 	group_add	args( ( CHAR_DATA *ch, const char *name, bool deduct) );
void	group_remove	args( ( CHAR_DATA *ch, const char *name) );
int	effective_level	args( ( CHAR_DATA *ch, int sn ) );
int	skill_level	args( ( CHAR_DATA *ch, int sn ) );
int	skill_rating	args( ( CHAR_DATA *ch, int sn ) );
bool	skill_usable	args( ( CHAR_DATA *ch, int sn ) );
bool	group_usable	args( ( CHAR_DATA *ch, int gn ) );
bool	is_specialized	args( ( CHAR_DATA *ch, int sn ) );
bool	has_specialization
			args( ( CHAR_DATA *ch, int sn ) );

/* sound.c */
void    act_sound       args( ( const char *argument, CHAR_DATA *ch, 
                                CHAR_DATA *victim, int type ) );
void    sound_to_char   args( ( const char *argument, CHAR_DATA *ch ) );
void    act_music       args( ( const char *argument, CHAR_DATA *ch, 
                                CHAR_DATA *victim, int type ) );
void    music_to_char   args( ( const char *argument, CHAR_DATA *ch ) );

/* string.c */
char *  first_arg       args( ( char *argument, char *arg_first, bool fCase ) );

/* special.c */
SF *	spec_lookup	args( ( const char *name ) );
char *	spec_name	args( ( SPEC_FUN *function ) );

/* teleport.c */
RID *	room_by_name	args( ( char *target, int level, bool error) );

/* territories.c */
void	load_territories    args( ( void ) );
char *	get_social_class    args( ( CHAR_DATA *ch, int territory ) );
int     territory_lookup    args( ( const char *name ) );
void 	territory_unsaved   args( ( CHAR_DATA *ch ) );
bool	is_killer           args( ( CHAR_DATA *ch ) );
bool	is_thief            args( ( CHAR_DATA *ch ) );
bool	is_criminal         args( ( CHAR_DATA *victim, bool anywhere ) );
void    make_criminal       args( ( CHAR_DATA *ch, long crime, 
                                    CHAR_DATA *victim ) );
bool    has_territory_flag  args( ( CHAR_DATA *ch, int territory, 
                                    long flag ) );

/* track.c */
int	find_first_step	args( ( CHAR_DATA *ch, void *target, int target_type,
				int max_depth, bool cross_air, bool cross_water,
				bool cross_deep_water ) );
void	hunt		args( ( CHAR_DATA *ch ) );
void	answer_call	args( ( CHAR_DATA *ch ) );
void    fire_track      args( ( CHAR_DATA *ch ) );

/* traps.c */
void	trap_player		args( ( OBJ_DATA *trap, CHAR_DATA *victim ) );
void	check_object_for_trap	args( ( CHAR_DATA *ch, OBJ_DATA *obj,
					int flag ) );
void	check_room_for_trap	args( ( CHAR_DATA *ch, int flag ) );
bool	is_trapped		args( ( OBJ_DATA *obj ) );
bool	is_room_trapped		args( ( ROOM_INDEX_DATA *pRoomIndex ) );
OD *	get_trap		args( ( OBJ_DATA *obj ) );
OD *	get_room_trap		args( ( ROOM_INDEX_DATA *room ) );

/* update.c */
void	advance_level	args( ( CHAR_DATA *ch, bool hide ) );
void	gain_exp	args( ( CHAR_DATA *ch, int gain ) );
void	gain_condition	args( ( CHAR_DATA *ch, int iCond, 
				int value, bool show ) );
void	update_handler	args( ( void ) );

#undef	CD
#undef	MID
#undef	OD
#undef	OID
#undef	RID
#undef	SF
#undef	AD
#undef	ED
#undef	RD












