/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <time.h>
#include "merc.h"


DECLARE_DO_FUN( do_look		);


void gas( CHAR_DATA *victim, int level, int dam, int sn, int dam_class )
{
    CHAR_DATA *rch, *rch_next;
    
    for ( rch = victim->in_room->people; rch != NULL; rch = rch_next )
    {
	rch_next = rch->next_in_room;
	
	if ( rch == victim )
	{
	    obj_cast_spell( sn, level, victim, victim, NULL );
	    damage( victim, victim, dam, TYPE_UNDEFINED,
	            dam_class, FALSE, NULL );
	}
	else
	{
	    obj_cast_spell( sn, level / 2, victim, victim, NULL );
	    damage( victim, victim, dam / 2, TYPE_UNDEFINED,
	            dam_class, FALSE, NULL );
	}
    }
}


void trap_player( OBJ_DATA *trap, CHAR_DATA *victim )
{
#define DAM	number_range(trap->value[3]/2, 3*trap->value[3]/2)

    const char *msg_self, *msg_room;
    ROOM_INDEX_DATA *pRoomIndex;
    AFFECT_DATA af;
    OBJ_DATA *obj;

    switch ( trap->value[1] )
    {
	case TRAP_TYPE_ARROW:
	case TRAP_TYPE_POISONED_ARROW:
	    msg_self = "You hear a loud twang followed by a searing pain as an arrow thuds into your side!";
	    msg_room = "You hear a loud twang followed by a cry as an arrow thuds into $ns side!";
	    break;
	case TRAP_TYPE_CEILING_BLOCK:
	    msg_self = "You hear a deep grinding a moment before something smashes into your head!";
	    msg_room = "$n starts to look up in surprise a moment before a large block from the ceiling smashes into his head!";
	    break;
	case TRAP_TYPE_CHUTE:
	    if ( (pRoomIndex = get_room_index(trap->value[3])) == NULL
	    ||   !can_see_room(victim, pRoomIndex) )
		return;
	    if ( IS_AFFECTED(victim, AFF_FLYING) )
	    {
		send_to_char( "An opening appears suddenly in the floor beneath you!\n\r"
		              "It closes before you can react.", victim );
		act( "An opening appears in the floor beneath $n, closing before any of you can react",
		    victim, NULL, NULL, TO_ROOM );
		return;
	    }
	    msg_self = "You gasp sharply as the floor beneath you opens, sending you flying down a narrow chute.";
	    msg_room = "$n lets out a strangled gasp as he disappears down a chute that appears suddenly in the floor.";
	    break;
	case TRAP_TYPE_GAS_BLINDING:
	    msg_self = "A large cloud of reddish brown gas issues forth!";
	    msg_room = "A large cloud of reddish brown gas issues forth!";
	    break;
	case TRAP_TYPE_GAS_POISON:
	    msg_self = "You start to cough and gag as a cloud of green gas fills the room.";
	    msg_room = "You start to cough and gag as a cloud of green gas fills the room.";
	    break;
	case TRAP_TYPE_GAS_SLEEP:
	    msg_self = "A faint white gas hisses into the room, filling it from the bottom.";
	    msg_room = "A faint white gas hisses into the room, filling it from the bottom.";
	    break;
	case TRAP_TYPE_GAS_SLOW:
	    msg_self = "A swirling cloud of pale blue gas spurts into the room!";
	    msg_room = "A swirling cloud of pale blue gas spurts into the room!";
	    break;
	case TRAP_TYPE_GAS_WEAKNESS:
	    msg_self = "A dark purple gas starts to issue forth, quickly filling the room!";
	    msg_room = "A dark purple gas starts to issue forth, quickly filling the room!";
	    break;
	case TRAP_TYPE_LIGHTNING:
	    msg_self = "A sparking jolt of electricty arcs onto YOU!";
	    msg_room = "$n jumps with shock as $e is hit by a massive spark of lightning!";
	    break;
	case TRAP_TYPE_BLADE:
	    msg_self = "With a loud swoosh a hidden blade springs out and hits YOU!";
	    msg_room = "With a loud swooch a hidden blade springs out and hits $n!";
	    break;
	case TRAP_TYPE_TELEPORTER:
	    if ( (pRoomIndex = get_room_index(trap->value[3])) == NULL
	    ||   !can_see_room(victim, pRoomIndex) )
		return;
	    msg_self = "As the room starts to fade from view you realise you've been teleported.";
	    msg_room = "$n disappears!";
	    break;
	case TRAP_TYPE_VENT_ACID:
	    msg_self = "You hear a soft click, then scream as a fine spray of acid covers you!";
	    msg_room = "$n screams as a fine spray of acid hits $m!";
	    break;
	case TRAP_TYPE_VENT_FIRE:
	    msg_self = "You leap back as a tongue of flame licks you!";
	    msg_room = "$n leaps back as $e is licked by a tongue of flame!";
	    break;
	case TRAP_TYPE_DART:
	case TRAP_TYPE_POISON_DART:
	    msg_self = "You hear a sharp spring then a stabbing pain as a dart thuds into you.";
	    msg_room = "$n jumps back as a small dart stabs into $m!";
	    break;
	case TRAP_TYPE_POISON_NEEDLE:
	    msg_self = "You feel a stabbing pain as a tiny needle shoots into you!";
	    msg_room = "$n jumps suddenly as a small needle shoots into $m.";
	    break;
	case TRAP_TYPE_SEX_CHANGE:
	    msg_self = "A strange swirling aura surrounds you.";
	    msg_room = "$n is surrounded by a swirling aura of colors!";
	    break;
	case TRAP_TYPE_PETRIFICATION:
	    if ( saves_spell(trap->level, victim, DAM_OTHER) )
	    {
	        send_to_char( "You feel a brief tingling.", victim );
	        return;
	    }
	    msg_self = "A searing pain shoots through you as you flesh petrifies.";
	    msg_room = "$n screams, $s flesh slowly turning to stone.";
	    break;
	default:
	    msg_self = "You hear as soft twang as you realise you've sprung a trap.";
	    msg_room = "You hear a soft twang.";
	    break;
    }
    
    act( msg_self, victim, NULL, NULL, TO_CHAR );
    act( msg_room, victim, NULL, NULL, TO_ROOM );
    
    if ( trap->value[0] > 0 )
	trap->value[0]--;
    if ( trap->value[0] == 0 )
	extract_obj( trap );

    switch ( trap->value[1] )
    {
	case TRAP_TYPE_ARROW:
	case TRAP_TYPE_DART:
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_PIERCE, FALSE, NULL );
	    break;
	case TRAP_TYPE_POISONED_ARROW:
	case TRAP_TYPE_POISON_DART:
	case TRAP_TYPE_POISON_NEEDLE:
	    obj_cast_spell( gsn_poison, trap->level, victim, victim, NULL );
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_PIERCE, FALSE, NULL );
	    break;
	case TRAP_TYPE_CEILING_BLOCK:
	    obj = create_object( get_obj_index(OBJ_VNUM_CEILING_BLOCK), 0, FALSE );
	    obj -> timer = 24;
	    obj_to_room( obj, victim->in_room );
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_BASH, FALSE, NULL );
	    break;
	case TRAP_TYPE_CHUTE:
	case TRAP_TYPE_TELEPORTER:
	    char_from_room( victim, TRUE );
	    char_to_room( victim, get_room_index(trap->value[3]) );
	    do_look( victim, "auto" );
	    check_room_for_trap( victim, TRAP_ENTER );
	    break;
	case TRAP_TYPE_GAS_BLINDING:
	    gas( victim, trap->level, DAM, gsn_blindness, DAM_NONE );
	    break;
	case TRAP_TYPE_GAS_POISON:
	    gas( victim, trap->level, DAM, gsn_poison, DAM_POISON );
	    break;
	case TRAP_TYPE_GAS_SLEEP:
	    gas( victim, trap->level, DAM, skill_lookup("sleep"), DAM_NONE );
	    break;
	case TRAP_TYPE_GAS_SLOW:
	    gas( victim, trap->level, DAM, skill_lookup("slow"), DAM_NONE );
	    break;
	case TRAP_TYPE_GAS_WEAKNESS:
	    gas( victim, trap->level, DAM, skill_lookup("weakness"), DAM_NONE );
	    break;
	case TRAP_TYPE_LIGHTNING:
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_LIGHTNING, FALSE, NULL );
	    break;
	case TRAP_TYPE_BLADE:
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_SLASH, FALSE, NULL );
	    break;
	case TRAP_TYPE_VENT_ACID:
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_ACID, FALSE, NULL );
	    break;
	case TRAP_TYPE_VENT_FIRE:
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_FIRE, FALSE, NULL );
	    break;
	case TRAP_TYPE_SEX_CHANGE:
	    obj_cast_spell( skill_lookup("sex change"), trap->level,
	                    victim, victim, NULL );
	    break;
	case TRAP_TYPE_PETRIFICATION:
	    af.where		= TO_AFFECTS;
	    af.type		= gsn_petrification;
	    af.level		= trap->level;
	    af.duration		= 24;
	    af.location		= APPLY_NONE;
	    af.modifier		= 0;
	    af.bitvector	= AFF_PARALYSIS;
	    af.procNo		= 0;
	    af.flags		= AFF_PRI_HIGH;
	    af.name	 	= "";
	    af.appearance	= 
	        "A statue of %n stands here, an expression of horror on %s face.";
	    affect_to_char( victim, &af );
	    stop_fighting( victim, TRUE );
	    break;
	default:
	    damage( victim, victim, DAM, TYPE_UNDEFINED,
	            DAM_NONE, FALSE, NULL );
	    break;
    }
#undef DAM
}


void check_object_for_trap( CHAR_DATA *ch, OBJ_DATA *obj, int flag )
{
    OBJ_DATA *trap, *trap_next;

    if ( !obj->contains )
	return;

    for ( trap = obj->contains; trap; trap = trap_next )
    {
	trap_next = trap->next_content;

	if ( trap->item_type == ITEM_TRAP
	&&   IS_SET(trap->value[2], flag) )
	{
	    trap_player( trap, ch );
	    if ( CHAR_KILLED(ch) )
		return;
	}
    }
}


void check_room_for_trap( CHAR_DATA *ch, int flag )
{
    OBJ_DATA *trap, *trap_next;

    if ( ch == NULL )
	return;

    if ( ch->in_room == NULL || ch->in_room->contents == NULL )
	return;

    for ( trap = ch->in_room->contents; trap; trap = trap_next )
    {
	trap_next = trap->next_content;

	if ( trap->item_type == ITEM_TRAP
	&&   IS_SET(trap->value[2], flag) )
	{
	    trap_player( trap, ch );
	    if ( CHAR_KILLED(ch) )
		return;
	}
    }
}


bool is_trapped( OBJ_DATA *obj )
{
    OBJ_DATA *trap;

    if ( !obj->contains )
	return FALSE;

    for ( trap = obj->contains; trap; trap = trap->next_content )
	if ( trap->item_type == ITEM_TRAP )
	    return TRUE;

    return FALSE;
}


bool is_room_trapped( ROOM_INDEX_DATA *pRoomIndex )
{
    OBJ_DATA *trap;

    if ( !pRoomIndex->contents )
	return FALSE;

    for ( trap = pRoomIndex->contents; trap; trap = trap->next_content )
	if ( trap->item_type == ITEM_TRAP )
	    return TRUE;

    return FALSE;
}


OBJ_DATA *get_trap( OBJ_DATA *obj )
{
    OBJ_DATA *trap;

    if ( !obj->contains )
	return NULL;

    for ( trap = obj->contains; trap; trap = trap->next_content )
	if ( trap->item_type == ITEM_TRAP )
	    return trap;

    return NULL;
}


OBJ_DATA *get_room_trap( ROOM_INDEX_DATA *room )
{
    OBJ_DATA *trap;
    
    if ( room->contents == NULL )
	return NULL;

    for ( trap = room->contents; trap; trap = trap->next_content )
    {
	if ( trap->item_type == ITEM_TRAP )
	    return trap;
    }
    
    return NULL;
}
